/*
  	#[ Include file :
*/
#include "stedi.h"
/*
  	#] Include file :
 	#[ Cursor movements :
 		#[ Left movement :
			#[ One Left :
*/

LONG
l_arrow(VOID)
{
	BUFFER b = cbuf;
	if ( commandmode ) {
		b = commandbuffer;
		if ( b->column > MinCommandColumn ) { b->column--; MessageCommand(); }
		else
#ifdef PORTWIN
		if ( frommouse == 0 )
#endif
		{ KeyFlush(); }
	}
	else if ( b->column > 1 ) { b->column--; DoDisplay(); }
	else KeyFlush();
	return(0);
}

/*
			#] One Left :
			#[ To First Column :
*/

LONG
sl_arr(VOID)
{
	if ( commandmode ) {
		commandbuffer->column = MinCommandColumn;
		MessageCommand();
	}
	else { cbuf->column = 1; DoDisplay(); }

	return(0);
}

/*
			#] To First Column :
			#[ Scroll Screen Left :
*/

LONG
cl_arr(VOID)
{
	BUFFER b = cbuf;
	WORD oldoffset;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) {
		b = commandbuffer;
		if ( b->offset > 0 ) b->offset -= cColumnStep;
		MessageCommand();
	}
	else {
		oldoffset = b->offset;
		if ( b->offset == ( MAXCOLUMN - TextScreen->wi ) ) {
			b->offset -= (( MAXCOLUMN - TextScreen->wi - 1 )%ColumnStep) + 1;
		}
		else if ( b->offset > 0 ) b->offset -= ColumnStep;
		if ( b->offset < 0 ) b->offset = 0;
		b->column += b->offset - oldoffset;
		if ( b->offset != oldoffset ) ForceDisplay();
		else DoDisplay();
	}
	return(0);
}

/*
			#] Scroll Screen Left :
			#[ Previous Character :
*/

LONG
shctle(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD n;

	FINDPOS fp;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) return(l_arrow());
	else {
		if ( b->newvirt > 0 ) {
			if ( b->column > 1 ) b->column = 1;
			else { u_arrow(); return(sr_arr()); }
			DoDisplay();
			return(0L);
		}
		l = b->current;
		if ( ( l->used == LINEHEAD ) || ( b->column == 1 ) ) {
			l = l->prev;
			if ( b->column > 1 ) b->column = 1;
			else if ( l != (LINE)b ) {
				if ( l->used < 0 ) n = ((FOLDLINE)l)->used - FOLDHEAD;
				else n = l->used - LINEHEAD;
				if ( n == 0 ) b->column = 1;
				else b->column = FindColumn(l,n) + 1;
				return(u_arrow());
			}
		}
		else {
			FindChar(l,b->column,&fp);
			if ( fp.virt > 0 ) {
				b->column -= fp.virt;
				if ( b->column <= 0 ) b->column = 1;
			}
			else if ( fp.num <= 2 ) b->column = 1;
			else b->column = FindColumn(l,fp.num-2) + 1;
		}
		DoDisplay();
	}
	return(0L);
}

/*
			#] Previous Character :
 		#] Left movement :
 		#[ Right movement :
			#[ One Right :
*/

LONG
r_arrow(VOID)
{
	BUFFER b = cbuf;
	if ( commandmode ) { commandbuffer->column++; MessageCommand(); }

	else {
		if ( b->column < MAXCOLUMN ) {
			if ( ( b->column - b->offset ) >= TextScreen->wi
#ifdef PORTWIN
			&& frommouse == 0
#endif
			 ) KeyFlush();
			b->column++;
			DoDisplay();
		}
	}

	return(0);
}

/*
			#] One Right :
			#[ To end of line :
*/

VOID
ToEOL(VOID)
{
	BUFFER b = cbuf;
	WORD n;
	LINE l;
	l = b->current;
	if ( ( l == (LINE)b ) || ( b->newvirt > 0 ) ) {
		b->column = 1;
	}
	else {
		if ( l->used < 0 ) n = ((FOLDLINE)l)->used - FOLDHEAD;
		else n = l->used - LINEHEAD;
		if ( n == 0 ) b->column = 1;
		else b->column = FindColumn(l,n) + 1;
	}
}

/*
			#] To end of line :
			#[ Cursor to end of line :
*/

LONG
sr_arr(VOID)
{
	BUFFER b;
	if ( commandmode ) {
		b = commandbuffer;
		b->column = b->current->used - LINEHEAD + 1;
		MessageCommand();
	}
	else {
		ToEOL();
		DoDisplay();
	}
	return(0);
}

/*
			#] Cursor to end of line :
			#[ Scroll Screen Right :
*/

LONG
cr_arr(VOID)
{
	BUFFER b = cbuf;
	WORD oldoffset;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) {
		commandbuffer->offset += cColumnStep;
		MessageCommand();
	}
	else {
		oldoffset = b->offset;
		b->offset += ColumnStep;
		if ( b->offset > ( MAXCOLUMN - TextScreen->wi ) )
			b->offset = MAXCOLUMN - TextScreen->wi;
		b->column += b->offset - oldoffset;
		if ( b->offset != oldoffset ) ForceDisplay();
		else DoDisplay();
	}
	return(0);
}

/*
			#] Scroll Screen Right :
			#[ Next Character :
*/

LONG
shctri(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type;
	FINDPOS fp;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) return(r_arrow());
	else {
		if ( b->newvirt > 0 ) return(0L);
		l = b->current;
		type = FindChar(l,b->column,&fp);
		if ( type == NORMALEOL || type == AFTERVIRTUAL ) {
			b->column = 1;
			return(d_arrow());
		}
		b->column = FindColumn(l,fp.num) + 1;
		DoDisplay();
	}
	return(0);
}

/*
			#] Next Character :
 		#] Right movement :
 		#[ Up movement :
			#[ UpOne :
*/

VOID
UpOne(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	l = b->current;
	if ( b->screenline == 1 ) {
		if ( b->newvirt > 0 ) {
			if ( b->totline || b->newvirt > 1 ) b->newvirt--;
			return;
		}
		l = l->prev;
		if ( l == (LINE)b ) return;
		ScrollDown(1,l);
		if ( l->used < 0 ) b->newline -= LINESINFOLD(l);
		else b->newline--;
		b->current = l;			
		b->screenline++;	/* imitate a shifted screen */
	}
	else {
		if ( b->newvirt > 0 ) {
			if ( ( l != (LINE)b ) || ( b->newvirt > 1 ) ) {
				b->newvirt--;
			}
			if ( ( l != (LINE)b ) && ( b->newvirt == 0 ) && ( l->used < 0 ) )
				{ b->newline -= LINESINFOLD(l) - 1; }
		}
		else {
			l = l->prev;
			if ( l->used < 0 ) b->newline -= LINESINFOLD(l);
			else b->newline--;
			b->current = l;
		}
	}
}

/*
			#] UpOne :
			#[ Up Arrow :
*/

LONG
u_arrow(VOID)
{
	BUFFER b;
	LINE l;
	LONG n;
	if ( commandmode ) {
		/* move back through the history */
		if ( MinCommandColumn > 1 ) return(0);
#ifdef PORTWIN
		if ( frommouse == 0 )
#endif
		KeyFlush();
		b = commandbuffer;
		n = b->oldline++;
		if ( b->oldline > b->totline ) {
			if ( b->totline <= 1 ) b->oldline = 1;
			else b->oldline = 2;
		}
		l = FindLine((LONG)(b->oldline));
		if ( ( l == (LINE)0 ) || CopyLine(l,(LINE)b) )
			{ b->oldline = n; return(-1L); }
		b->current = l = b->first;
		LineDealloc(l->next);
		b->column = 1;
		MessageCommand();
	}
	else {
		if ( cbuf->screenline <= 1 ) KeyFlush();
		UpOne();
		DoDisplay();		/* needs to get oldline right */
#ifdef FASTSCREEN
		MessageUpdate();
#endif
	}
	return(0);
}

/*
			#] Up Arrow :
			#[ Page Up :
*/

LONG
su_arr(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	LONG num;
	LONG StopTime;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) return(0L);
#ifndef DEMO
	StopTime = GetTicks() + dbufFer.PageWait;
#endif
	l = b->current;
	num = ScrollStep;
	if ( b->totline == 0 ) {	/* empty buffer */
		b->newvirt = 1;
		DoDisplay();
		return(0L);
	}
	if ( b->newvirt > 0 ) {
		num -= b->newvirt;
		b->newvirt = b->oldvirt = 0;
		if ( l->used < 0 ) b->newline -= LINESINFOLD(l) - 1;
	}
	num = chline(-num);		/* In num we get the number still to move */
	if ( num == 0 ) {
		num = Distend(-1);	/* Lines from the top */
		if ( b->screenline > (WORD)num ) b->screenline = (WORD)num;
	}
	b->oldline = b->newline;
	b->oldvirt = b->newvirt;
	ForceDisplay();
	MessageUpdate();
#ifndef DEMO
	MyWait(StopTime);
#endif
	return(0);
}

/*
			#] Page Up :
			#[ Scroll One Up :
*/

LONG
ctrup(VOID)
{
	BUFFER b = cbuf;
	WORD i, j;
	if ( commandmode ) return(u_arrow());
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	j = i = b->screenline - 1;
	while ( --i >= 0 ) UpOne();
	UpdateDisplay();
	UpOne();
	while ( --j >= 0 ) DownOne();
	DoDisplay();
#ifdef FASTSCREEN
	MessageUpdate();
#endif
	return(0);
}

/*
			#] Scroll One Up :
 		#] Up movement :
 		#[ Down movement :
			#[ DownOne :
*/

VOID
DownOne(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	l = b->current;
	if ( b->screenline == TextScreen->hi ) {
		l = l->next;
		if ( l == (LINE)b ) {
			if ( b->newvirt < 5 ) {
				ScrollUp(TextScreen->hi,(LINE)0);
				b->newline = b->totline;
				b->screenline--;	/* imitate a shifted screen */
				b->newvirt++;
			}
		}
		else {
			ScrollUp(TextScreen->hi,l);
			if ( l->prev->used < 0 ) b->newline += LINESINFOLD(l->prev);
			else b->newline++;
			b->current = l;
			b->screenline--;	/* imitate a shifted screen */
		}
	}
	else {
		if ( b->newvirt > 0 ) {
			b->newvirt++;
		}
		else {
			l = l->next;
			if ( l == (LINE)b ) {
				b->newline = b->totline;
				b->newvirt = 1;
			}
			else {
				if ( l->prev->used < 0 ) b->newline += LINESINFOLD(l->prev);
				else b->newline++;
				b->current = l;
			}
		}
	}
}

/*
			#] DownOne :
			#[ Down Arrow :
*/

LONG
d_arrow(VOID)
{
	BUFFER b;
	LINE l;
	LONG n;
	if ( commandmode ) {
		/* move up through the history */
		if ( MinCommandColumn > 1 ) return(0);
#ifdef PORTWIN
		if ( frommouse == 0 )
#endif
		KeyFlush();
		b = commandbuffer;
		n = b->oldline--;
		if ( b->oldline <= 1 ) b->oldline = b->totline;
		l = FindLine((LONG)(b->oldline));
		if ( ( l == (LINE)0 ) || CopyLine(l,(LINE)b) )
			{ b->oldline = n; return(-1L); }
		b->current = l = b->first;
		LineDealloc(l->next);
		b->column = 1;
		MessageCommand();
	}
	else {
		if ( cbuf->screenline >= TextScreen->hi ) KeyFlush();
		DownOne();
		DoDisplay();		/* needs to get oldline right */
#ifdef FASTSCREEN
		MessageUpdate();
#endif
	}
	return(0);
}

/*
			#] Down Arrow :
			#[ Page Down :
*/

LONG
sd_arr(VOID)
{
	BUFFER b = cbuf;
	LONG num;
	LONG StopTime;
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	if ( commandmode ) return(0L);
#ifndef DEMO
	StopTime = GetTicks() + dbufFer.PageWait;
#endif
	if ( b->totline == 0 )		/* empty buffer */
		{ b->newvirt = 1; DoDisplay(); return(0L); }
	if ( b->newvirt > 0 ) return(0L);
	else {
		num = chline((LONG)ScrollStep);	/* In num we get the number still to move */
		if ( num == 0 ) {
			num = Distend(1);	/* Lines from the bottom */
			if ( ( TextScreen->hi - b->screenline ) > ( num + 4 ) )
				{ b->screenline += TextScreen->hi - b->screenline - (WORD)num - 4; }
		}
		else {
			if ( num > 5 ) num = 5;
			b->screenline = TextScreen->hi - (WORD)num + 1;
			b->newvirt = 1;
			b->newline = b->totline;
		}
		b->oldline = b->newline;
		b->oldvirt = b->newvirt;
	}
	ForceDisplay();
	MessageUpdate();
#ifndef DEMO
	MyWait(StopTime);
#endif
	return(0);
}

/*
			#] Page Down :
			#[ Scroll One Down :
*/

LONG
ctrdo(VOID)
{
	BUFFER b = cbuf;
	WORD i, j;
	if ( commandmode ) return(d_arrow());
	if ( b->newvirt >= 5 ) return(0L);
#ifdef PORTWIN
	if ( frommouse == 0 )
#endif
	KeyFlush();
	j = TextScreen->hi - b->screenline;
	i = j;
	while ( --i >= 0 ) DownOne();
	UpdateDisplay();
	DownOne();
	while ( --j >= 0 ) UpOne();
	DoDisplay();
#ifdef FASTSCREEN
	MessageUpdate();
#endif
	return(0);
}

/*
			#] Scroll One Down :
 		#] Down movement :
 		#[ Home key actions :
			#[ Clear/Home :
*/

LONG
clrhom(VOID)
{
	BUFFER b = cbuf;
	if ( commandmode ) MessageCommand();
	else {
		if ( b->first == (LINE)b ) {
			b->newvirt = 1;
			b->column = 1;
			b->totline = b->newline = 0;
		}
		else {
			b->current = b->first;
			b->totline = CountLines(b);
			b->newline = b->oldline = 1; b->column = 1;
			b->oldvirt = b->newvirt = 0;
		}
		ForceDisplay();
		KeyFlush();
		MessageForce();
	}
	return(0);
}

/*
			#] Clear/Home :
			#[ To end of file :
*/

LONG
sh_hom(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD n;
	if ( commandmode ) return(0);
	b->current = l = b->last;
	if ( l == (LINE)b ) return(clrhom());
	b->newline = b->totline;
	if ( l->used < 0 ) b->newline -= LINESINFOLD(l) - 1;
	if ( l->used < 0 ) n = ((FOLDLINE)l)->used - FOLDHEAD;
	else n = l->used - LINEHEAD;
	b->column = 1;
	if ( n > 0 ) b->column += FindColumn(l,n);
	b->newvirt = 0;
	ForceDisplay();
	return(0);
}

/*
			#] To end of file :
			#[ Top of screen :
*/
#ifndef DEMO

LONG
cthome(VOID)
{
	BUFFER b = cbuf;
	WORD n;
	if ( commandmode ) return(0);
	n = b->screenline - 1;
	b->column = b->offset + 1;
	while ( --n >= 0 ) UpOne();
	DoDisplay();
	return(0L);
}

/*
			#] Top of screen :
			#[ Bottom of screen :
*/

LONG
ctlhom(VOID)
{
	BUFFER b = cbuf;
	WORD n;
	if ( commandmode ) return(0);
	n = TextScreen->hi - b->screenline;
	b->column = b->offset + 1;
	while ( --n >= 0 ) DownOne();
	DoDisplay();
	return(0);
}
#endif

/*
			#] Bottom of screen :
 		#] Home key actions :
 		#[ Line jumps :
			#[ Go to line :
*/

LONG
gotoln(LONG num)
{
	BUFFER b = cbuf;
	LINE l;
	if ( num <= 0 ) num = 1;
	if ( num > b->totline ) num = b->totline;
	if ( num <= 0 ) return(clrhom());
	l = FindLine(num);
	if ( l == (LINE)0 ) return(-1L);
	b->current = l;
	b->newline = FindNum(l);
	DoDisplay();
	return(0L);
}

/*
			#] Go to line :
			#[ Change lines :

			Moves the current line by 'num' screenlines.
			newline is also adjusted. If the begin or the
			end of the file are reached the return value
			indicates the number of unfinished steps.
*/

LONG
chline(LONG num)
{
	BUFFER b = cbuf;
	LINE l;
	LONG number;
	l = b->current;
	number = b->newline;
	if ( num > 0 ) {
		do {
			if ( l->next == (LINE)b ) {
				b->newline = number;
				b->current = l;
				return(num);
			}
			else if ( l->used >= 0 ) number++;
			else number += LINESINFOLD(l);
			l = l->next;
		} while ( --num > 0 );
	}
	else if ( num < 0 ) {
		do {
			l = l->prev;
			if ( l == (LINE)b ) {
				b->newline = 1;
				b->current = b->first;
				return(num);
			}
			else if ( l->used >= 0 ) number--;
			else number -= LINESINFOLD(l);
		} while ( ++num < 0 );
	}
	b->newline = number;
	b->current = l;
	return(0L);
}

/*
			#] Change lines :
			#[ Distance to end :
*/

WORD
Distend(WORD n)
{
	BUFFER b = cbuf;
	LINE l;
	WORD s;
	l = b->current;
	s = TextScreen->hi;
	if ( n > 0 ) {			/* Distance from the end */
		n = 1;
		do {
			if ( ( l = l->next ) == (LINE)b ) return(n);
			else n++;
		} while ( --s >= 0 );
	}
	else {					/* Distance from the start */
		n = 1;
		do {
			if ( ( l = l->prev ) == (LINE)b ) return(n);
			else n++;
		} while ( --s >= 0 );
	}
	return(n);
}

/*
			#] Distance to end :
			#[ To column :

		,number is move to column
		,,number is move to byte.
*/

LONG
MoveColumn(UBYTE *s,WORD n)
{
	BUFFER b = cbuf;
	LONG num, x;
	LINE l1,l2;
	WORD flag = 0;
	if ( n > 0 && *s == ',' ) {
		n--; s++; flag = 1;
		SKIPBLANKS(s,n);
	}
	x = ItoL(s,n);
	if ( flag ) {
		l1 = l2 = (LINE)b;
		while ( ( l1 = l1->next ) != l2 ) {
			if ( l1->used >= 0 ) {
				num = l1->used - LINEHEAD;
				switch ( b->outputmode ) {
					case UNIXMODE :  num++; break;
					case ATARIMODE : num += 2; break;
					case PRINTMODE :
							num = FindColumn(l1,(WORD)num) + 2;
							break;
				}
			}
			else {
				num = CountBytes(((FOLDLINE)l1)->first,((FOLDLINE)l1)->last->next);
			}
			if ( num > x ) {
				if ( l1->used < 0 && x > (((FOLDLINE)l1)->used-FOLDHEAD) )
					x = ((FOLDLINE)l1)->used - FOLDHEAD;
				b->column = FindColumn(l1,(WORD)x)+1;
				if ( x <= 0 ) b->column--;
				if ( b->column <= 0 ) b->column = 1;
				b->current = l1;
				b->newline = FindNum(l1);
				break;
			}
			else { x -= num; }
		}
		
	}
	else {
		if ( x > MAXCOLUMN ) x = MAXCOLUMN;
		else if ( x <= 0 ) x = 1;
		b->column = (WORD)x;
	}
	DoDisplay();
	return(0L);
}
 
/*
			#] To column :
			#[ From Last :

LONG
MoveLast(UBYTE *s,WORD n)
{
	LONG x = 0;
	if ( NumVal(s,(LONG)n,&x) ) return(Syntax());
	x = cbuf->totline - x;
	return(gotoln(x));
}

			#] From Last :
			#[ Plus :
*/
#ifndef DEMO

LONG
MovePlus(UBYTE *s,WORD n)
{
	LONG x;
	if ( NumVal(s,(LONG)n,&x) ) return(Syntax());
	chline(x);
	DoDisplay();
	return(0L);
}

/*
			#] Plus :
			#[ Min :
*/

LONG
MoveMin(UBYTE *s,WORD n)
{
	LONG x;
	if ( NumVal(s,(LONG)n,&x) ) return(Syntax());
	chline(-x);
	DoDisplay();
	return(0L);
}

/*
			#] Min :
			#[ Point :

LONG
MovePoint(UBYTE *s,WORD n)
{
	if ( ( n > 0 ) && ( *s == '+' ) ) { s++; n--; return(MovePlus(s,n)); }
	else if ( ( n > 0 ) && ( *s == '-' ) ) { s++; n--; return(MoveMin(s,n)); }
	return(Syntax());
}
*/

#endif
/*
			#] Point :
			#[ Absolute move :
*/

LONG
MoveCursor(UBYTE *s,WORD n)
{
	LONG x, y;
	WORD i;
	if ( ( i = NumVal(s,(LONG)n,&x) ) < 0 ) {
		s += n+i; n = -i;
		if ( *s != ',' ) return(Syntax());
		n--;
		s++;
		if ( NumVal(s,(LONG)n,&y) ) return(Syntax());
		if ( y > MAXCOLUMN ) y = MAXCOLUMN;
		if ( y > 0 ) cbuf->column = (WORD)y;
	}
	return(gotoln(x));
}

/*
			#] Absolute move :
 		#] Line jumps :
 		#[ Tags :
			#[ Go to tag :
*/
#ifndef DEMO

LONG
GotoTag(UBYTE *s,WORD n)
{
	TAG *t;
	BUFFER oldbuf;
	LONG number;
	if ( commandmode ) return(0L);
	if ( ( *s <= '9' ) && ( *s >= '0' ) ) {
		t = &(tags[*s-'0']);
		s++; n--;
		SKIPBLANKS(s,n);
		if ( n <= 0 ) {
			oldbuf = cbuf;
			cbuf = textbuffer[t->bufnum];
			if ( ( number = FindNum(t->line) ) < 0 ) {
				cbuf = oldbuf;
				MesnOut(9); /* "Tag not found." */
				return(-1L);
			}
			cbuf->current = t->line;
			cbuf->column = t->column;
			cbuf->newvirt = 0;
			cbuf->newline = number;
			if ( cbuf != oldbuf ) {
				cbuf = oldbuf;
				GotoBuffer(t->bufnum);
			}
			else
				DoDisplay();
			return(0L);
		}
	}
	return(Syntax());
}

/*
			#] Go to tag :
			#[ Put tag :
*/

LONG
PutTag(UBYTE *s,WORD n)
{
	TAG *t;
	WORD i;
	if ( ( *s <= '9' ) && ( *s >= '0' ) ) {
		i = *s-'0';
		t = tags + i;
		s++; n--;
		SKIPBLANKS(s,n);
		if ( n <= 0 ) {
			t->line   = cbuf->current;
			t->bufnum = cbuf->bufnum;
			t->column = cbuf->column;
			if ( DispBlock <= 0 ) MesPrint(1,i); /* "Tag %d placed" */
			return(0);
		}
	}
	return(Syntax());
}
#endif

/*
			#] Put tag :
 		#] Tags :
 		#[ DoDisplay :
*/

VOID
DoDisplay(VOID)
{
	Display(0);
}

/*
 		#] DoDisplay :
 	#] Cursor movements :
*/

