/*
  	#[ Include file :
*/
#include "stedi.h"
/*
  	#] Include file :
  	#[ Fold routines :
 		#[ Open a fold :		LINE OpenFold(line1)
*/

LINE
OpenFold(FOLDLINE line1)
{
	LINE a1;
	BUFFER b = cbuf;
	line1->next->prev = line1->last;
	line1->last->next = line1->next;
	line1->next = a1 = line1->first;
	a1->prev = (LINE)line1;
	if ( line1 == (FOLDLINE)(b->current) ) b->current = a1;
	if ( line1 == (FOLDLINE)(b->mark) ) b->mark = a1;
	LineDealloc((LINE)line1);
	return(a1);
}

/*
 		#] Open a fold :
 		#[ Close a fold :		FOLDLINE CloseFold(line1,line2)
*/

FOLDLINE
CloseFold(LINE line1,LINE line2)
{
	FOLDLINE a1;
	UBYTE *s, *t;
	LONG totlines;
	WORD num = line1->used-LINEHEAD;
	if ( ( a1 = FoldAlloc(num,line1->prev) ) == 0 ) return((FOLDLINE)0);
	s = (UBYTE *)(line1->text);
	t = (UBYTE *)(a1->text);
	while ( --num >= 0 ) *t++ = *s++;
	a1->text[4] = '#';
	totlines = NumLines(line1,line2)+1;
	a1->lines = (UWORD)totlines;
	a1->mark = FOLDCODE | (WORD)(totlines>>16);
	a1->next = line2->next;
	line2->next->prev = (LINE)a1;
	a1->first = line1;
	a1->last = line2;
	line2->next = line1->prev = (LINE)(&(((FOLDLINE)a1)->first));
	return(a1);
}

/*
 		#] Close a fold :
 		#[ FindStart :			LINE FindStart(a2,flag)
*/

LINE
FindStart(LINE a2,WORD *flag)
{
	LINE a1, a3;
	WORD num, n;
	UBYTE *s;
	WORD rflag;
	*flag = 0;
	if ( ( a1 = a2->prev ) == (LINE)cbuf ) return((LINE)0);
	if ( a2 == cbuf->current ) *flag = 1;
	num = 5;
	while ( a2->text[num++] != ':' ) {}
	num -= 5;
	do {
		if ( a1 == cbuf->current ) *flag = 1;
		if ( a1->text[3] == '#' && ( ( n = a1->used - (LINEHEAD+5) ) > 0 ) ) {
			if ( ( a1->text[4] == '[' ) && ( n >= num )
			&& !strNcmp(a2->text+5,a1->text+5,num) ) { return(a1); }
			else if ( a1->text[4] == ']' ) {
				s = a1->text + 5;
				while ( n > 0 && *s != ':' ) { n--; s++; }
				if ( n > 0 ) {
					a3 = FindStart(a1,&rflag);
					if ( a3 ) { a1 = a3; *flag |= rflag; }
				}
			}
		}
	} while ( ( a1 = a1->prev ) != (LINE)cbuf );
	return ( (LINE)0 );
}

/*
 		#] FindStart :
 		#[ FindEnd :			LINE FindEnd(a2,flag)
*/

LINE
FindEnd(LINE a2,WORD *flag)
{
	LINE a1, a3;
	WORD num, n;
	WORD rflag;
	UBYTE *s;
	*flag = 0;
	if ( ( a1 = a2->next ) == (LINE)cbuf ) return((LINE)0);
	if ( a2 == cbuf->current ) *flag = 1;
	num = 5;
	while ( a2->text[num++] != ':' ) {}
	num -= 5;
	do {
		if ( a1 == cbuf->current ) *flag = 1;
		if ( ( a1->text[3] == '#' ) && ( ( n = a1->used-LINEHEAD-5 ) > 0 ) ) {
			if ( ( a1->text[4] == ']' ) && ( n >= num )
			&& !strNcmp(a2->text+5,a1->text+5,num) ) { return(a1); }
			else if ( a1->text[4] == '[' ) {
				s = a1->text + 5;
				while ( n > 0 && *s != ':' ) { n--; s++; }
				if ( n > 0 ) {
					a3 = FindEnd(a1,&rflag);
					if ( a3 ) { a1 = a3; *flag |= rflag; }
				}
			}
		}
	} while ( ( a1 = a1->next ) != (LINE)cbuf );
	return ( (LINE)0 );
}

/*
 		#] FindEnd :
 		#[ FindFold :			WORD FindFold(c1,c2)
*/

WORD
FindFold(LINE *c1,LINE *c2)
{
	BUFFER b = cbuf;
	LINE a1, a2;
	WORD i;
	UBYTE *s;
	WORD flag;
	if ( b->newvirt > 0 ) goto nofold;
	a1 = b->current;
	while ( a1 != (LINE)b ) {
		if ( ( a1->text[3] == '#' ) && ( a1->used > (LINEHEAD+5) ) ) {
			s = a1->text + 4;
			if ( *s == '[' ) {
				s++; i = a1->used - LINEHEAD - 5;
				do {
					if ( *s++ == ':' ) {	/* found candidate */
						a2 = FindEnd(a1,&flag);
						if ( a2 && flag ) {
							*c1 = a1;
							*c2 = a2;
							return(1);
						}
						break;
					}
				} while ( --i > 0 );
			}
			else if ( *s == ']' ) {
				if ( a1 != b->current ) {
					s++; i = a1->used - LINEHEAD - 5;
					do {
						if ( *s++ == ':' ) {	/* found candidate */
							a2 = FindStart(a1,&flag);
							if ( a2 ) a1 = a2;
							break;
						}
					} while ( --i > 0 );
				}
			}
		}
		a1 = a1->prev;
	}
nofold:
	return(0);
}

/*
 		#] FindFold :
 		#[ Close Current Fold :	LONG CloseCFold()
*/

WORD FinternCall = 0;

LONG
CloseCFold(VOID)
{
	BUFFER b = cbuf;
	LINE a1, a2;
	if ( commandmode ) return(0L);
	ClearUndo();
	if ( FindFold(&a1,&a2) && ( a1 = (LINE)CloseFold(a1,a2) ) != 0 ) {
			b->current = a1;
			b->oldline = b->newline = FindNum(a1);
			b->oldvirt = b->newvirt = 0;
			ForceDisplay();
			return(0L);
	}
	if ( FinternCall ) { ForceDisplay(); }
	else {
		MesnOut(MESNUM1); /* "Cursor not inside a legal fold." */
	}
	return(-1L);
}

/*
 		#] Close Current Fold :
 		#[ Open Current Fold :	LONG OpenCFold()
*/

LONG
OpenCFold(VOID)
{
	BUFFER b = cbuf;
	LINE a1;
	if ( commandmode ) return(0L);
	if ( b->newvirt <= 0 ) {
		a1 = b->current;
		if ( a1->used < 0 ) {
			OpenFold((FOLDLINE)a1);
			ClearUndo();
			ForceDisplay();
			return(0L);
		}
	}
	MesnOut(MESNUM2); /* "Cursor not in a foldline." */
	return(-1L);
}

/*
 		#] Open Current Fold :
 		#[ Remove a fold :		VOID RemoveFold(a1)
*/

VOID
RemoveFold(LINE a1)
{
	LINE a2, a3, a4;
	a3 = (LINE)(((UBYTE *)a1)+LINEHEAD);
	a2 = a3->next;
	do {
		a4 = a2->next;
		if ( a2->used >= 0 ) LineDealloc(a2);
		else				 RemoveFold(a2);
		a2 = a4;
	} while ( a2 != a3 );
	LineDealloc(a1);
}

/*
 		#] Remove a fold :
 		#[ Open all folds :		LONG OpenAll()
*/

LONG
OpenAll(VOID)
{
	BUFFER b = cbuf;
	LINE a1;
	if ( commandmode ) return(0L);
	a1 = b->first;
	if ( a1 == (LINE)b ) return(0L);
	ClearUndo();
	do {
		if ( a1->used < 0 ) a1 = OpenFold((FOLDLINE)a1);
	} while ( ( a1 = a1->next ) != (LINE)b );
	ForceDisplay();
	return(0L);
}

/*
 		#] Open all folds :
 		#[ Close all folds :	LONG CloseAll()
*/

WORD CloseFlag = 0;

LONG
CloseAll(VOID)
{
	BUFFER b = cbuf;
	LINE a1,a2,a3;
	UBYTE *s;
	WORD num;
	WORD flag;
	if ( commandmode ) return(0L);
	a1 = b->first;
	if ( a1 == (LINE)b ) return(0L);
	ClearUndo();
	do {
		if ( ( a1->used > (LINEHEAD+5) ) && ( a1->text[3] == '#' )
		&& ( a1->text[4] == ']' ) ) {
			num = a1->used - LINEHEAD - 5;
			s = a1->text + 5;
			do {
				if ( *s++ == ':' ) {
					num--;
					if ( !CloseFlag || ( num > 0 && s[num-1] == ' ' ) ) {
						a2 = FindStart ( a1, &flag );
						if ( a2 ) {
							a3 = (LINE)CloseFold(a2,a1);
							if ( a3 == 0 ) {
								ForceDisplay();
								MesMem();
								return(NOMEMORYL);
							}
							if ( flag ) {
								b->current = a3;
								b->newvirt = 0;
								b->newline = FindNum(a3);
							}
							if ( CloseFlag ) DropPart(a1,1);
							a1 = a3;
						}
					}
					break;
				}
			} while ( --num > 0 );
		}
	} while ( ( a1 = a1->next ) != (LINE)b );
	if ( CloseFlag ) UpdateDisplay();
	else ForceDisplay();
	return(0L);
}

/*
 		#] Close all folds :
 		#[ AutoClose :			LONG AutoClose()
*/

LONG
AutoClose(VOID)
{
	LONG RetCode;
	CloseFlag = 1;
	RetCode = CloseAll();
	CloseFlag = 0;
	return(RetCode);
}

/*
 		#] AutoClose :
 		#[ Open by number :		LONG OpenNum(number)
*/

LONG
OpenNum(LONG number)
{
	LONG i, j;
	BUFFER b = cbuf;
	LINE a1;
	if ( ( b->totline <= 0 ) || ( number == 0 ) ) return(-1L);
	ClearUndo();
	if ( number > b->totline ) number = b->totline;
	i = number;
	a1 = b->first;
	while ( a1 != (LINE)b ) {
		if ( a1->used >= 0 ) {
			number--;
			a1 = a1->next;
		}
		else if ( number > ( j = LINESINFOLD(a1) ) ) {
			number -= j;
			a1 = a1->next;
		}
		else {
			a1 = OpenFold((FOLDLINE)a1);
		}
		if ( number == 0 ) {
			b->current = a1->prev;
			b->newline = i;
			b->newvirt = 0;
			ForceDisplay();
			return(0L);
		}
	}
	return(-1L);
}

/*
 		#] Open by number :
 		#[ Close by number :	LONG CloseNumber(number)
*/

LONG
CloseNumber(LONG number)
{
	LONG value;
	ClearUndo();
	if ( ! FindLine(number) ) return(-1L);
	FinternCall = 1;
	value = CloseCFold();
	FinternCall = 0;
	return(value);
}

/*
 		#] Close by number :
 		#[ Open by name :		LONG OpenName(s)
*/

LONG
OpenName(UBYTE *s,WORD n)
{
	WORD length;
	BUFFER b = cbuf;
	LINE a1;
	UBYTE *t;
	ClearUndo();
	t = s;
	while ( ( n > 0 ) && ( *t != '\'' ) ) { n--; t++; }
	if ( ( *t != '\'' ) || ( n == 0 ) ) return(Syntax());
	n--;
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	*t = ':';
	length = (WORD)(t - s) + 1;
	a1 = b->first;
	while ( a1 != (LINE)b ) {
		if ( ( a1->used < 0 ) && 
		( !strNcmp( ((FOLDLINE)a1)->text+5, s, length ) ) ) {
			a1 = OpenFold((FOLDLINE)a1);
			b->current = a1;
			b->newline = FindNum(a1);
			b->newvirt = 0;
			*t = '\'';
			ForceDisplay();
			return(0L);
		}
		a1 = a1->next;
	}
	*t = '\'';
	MesnOut(33); /* "Fold not found." */
	return(-1L);
}

/*
 		#] Open by name :
 		#[ Close by name :		LONG CloseName(s)
*/

LONG
CloseName(UBYTE *s,WORD n)
{
	WORD length;
	BUFFER b = cbuf;
	LINE a1;
	LINE a2;
	UBYTE *t;
	WORD flag;
	ClearUndo();
	t = s;
	while ( ( n > 0 ) && ( *t != '\'' ) ) { n--; t++; }
	if ( ( *t != '\'' ) || ( n == 0 ) ) return(Syntax());
	n--;
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	*t = ':';
	length = (WORD)(t - s) + 1;
	a1 = b->first;
	while ( a1 != (LINE)b ) {
		if ( ( a1->used >= 0 ) && ( a1->text[3] == '#' )
		&& ( a1->text[4] == '[' ) &&
		( !strNcmp( a1->text+5, s, length ) ) &&
		( ( a2 = FindEnd(a1,&flag) ) != 0 ) ) {
			if ( ( a1 = (LINE)CloseFold(a1,a2) ) == 0 )
				{ *t = '\''; return(NOMEMORYL); }
			else {
				b->current = a1;
				b->newline = FindNum(a1);
				b->newvirt = 0;
				*t = '\'';
				ForceDisplay();
				return(0L);
			}
		}
		a1 = a1->next;
	}
	*t = '\'';
	MesnOut(33); /* "Fold not found." */
	return(-1L);
}

/*
 		#] Close by name :
 		#[ Commandline action :
			#[ [ command :		LONG COpenFold(s)
*/

LONG
COpenFold(UBYTE *s,WORD n)
{
	UBYTE c;
	if ( n <= 0 ) return(OpenCFold());
	c = *s;
	switch ( c ) {
		case 'A':
		case 'a':
			if ( n <= 1 ) return(OpenAll());
			break;
		case '\'':
			n--; s++;
			if ( n > 0 ) return(OpenName(s,n));
			break;
		default:
			if ( ( c <= '9' ) && ( c >= '0' ) ) {
				return(OpenNum((LONG)ItoL(s,n)));
			}
			break;
	}
	return(Syntax());
}

/*
			#] [ command :
			#[ ] command :		LONG CCloseFold(s)
*/

LONG
CCloseFold(UBYTE *s,WORD n)
{
	UBYTE c;
	if ( n <= 0 ) return(CloseCFold());
	c = *s;
	switch ( c ) {
		case 'A':
		case 'a':
			if ( n <= 1 ) return(CloseAll());
			break;
		case '\'':
			n--; s++;
			if ( n > 0 ) return(CloseName(s,n));
			break;
		default:
			if ( ( c <= '9' ) && ( c >= '0' ) ) {
				return(CloseNumber((LONG)ItoL(s,n)));
			}
	}
	return(Syntax());
}

/*
			#] ] command :
 		#] Commandline action :
  	#] Fold routines :
*/

