/*
  	#[ PREAMBLE :	includes and definitions.

 *----------------------------------------------------------------------------*
 |                                                                            |
 |      This file contains the new version of keycomp.c which is used in      |
 |                         STedi version from 3.0 on.                         |
 |                            Preferred sizes are:                            |
 |                              LONG is 4 bytes                               |
 |                              WORD is 2 bytes                               |
 |                              BYTE is 1 byte                                |
 |                                                                            |
 |           For an ANSI compiler one should define the macro ANSI            |
 |                                                                            |
 |                         Copyright J.A.M.Vermaseren                         |
 |                                11-aug-1989                                 |
 |                                30-dec-1990                                 |
 |                                                                            |
 *----------------------------------------------------------------------------*

           With the right editor shift-F6 gives the helicopter view
*/
 
#define VOID void
#define BYTE char
#define WORD short
#define LONG long
#define UBYTE unsigned char
#define UWORD unsigned int
#define ULONG unsigned long

#ifdef UNIX
 
#include <fcntl.h>

extern long lseek();

#define Fcreate(name,y)	open(name,(int)(O_RDWR | O_CREAT | O_TRUNC),(int)0666)
#define Fopen(name,y)	open(name,(int)O_RDONLY,(int)0666)
#define Fclose(handle)	close((int)(handle))
#define Fread(handle,count,buffer)	read((int)(handle),(char *)buffer,(int)(count))
#define Fwrite(handle,count,buffer)	write((int)(handle),(char *)buffer,(int)(count))
#define Fseek(offset,handle,mode)	lseek((int)(handle),(long)(offset),(int)(mode))

#define Malloc(x)			malloc((unsigned int)(x))
#define Cconws(x)			write(1,x,strlen(x))

#else

#ifdef ATARI
#ifdef ANSI
				/*	This is for turbo C   */
#include <tos.h>
#else
				/*  This is fine for the other compilers */
#include <osbind.h>
#endif

#else

#ifdef __WATCOMC__
				/*	This is for the Watcom C compiler on the PC */
#include <dos.h>
#include <dosfunc.h>

LONG Fcreate(BYTE *name,WORD attribute);
LONG Fopen(BYTE *name,WORD attribute);
LONG Fclose(WORD handle);
LONG Fread(WORD handle,LONG number,BYTE *buffer);
LONG Fwrite(WORD handle,LONG number,BYTE *buffer);
LONG FileWR(WORD handle,LONG number,BYTE *buffer,WORD type);
VOID Cconws(BYTE *StringToConsole);
LONG Fseek(LONG offset,WORD handle,WORD origin);
VOID *Malloc(LONG RequestedSpace);

#else
				/*  This is turbo C on the PC */
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <alloc.h>

#define Malloc(x)            farmalloc(x)
#define Fcreate(x,y)		_creat(x,y)
#define Fopen(x,y)			_open(x,y)
#define Fclose(x)			_close(x)
#define Fread(x,y,z)		_read(x,z,(WORD)(y))
#define Fwrite(x,y,z)		_write(x,z,(WORD)(y))
#define Cconws(x)			_write(1,x,strlen(x))
#define Fseek(x,y,z)		lseek(y,x,z)
#endif

#endif

#endif
/*
	The next define is for compilers that pass the environment pointer.
	Remove this define when using a compiler that doesn't pass
	the environment string as the third parameter in main.
*/

#define WITHENVIRONMENT

/*
	The next buffer size limits the length of a redefinition.
	Sum of keys in lhs and rhs is forced to be less than OUTBUFFERSIZE/4
	So if you don't like it....
	The editor doesn't like the lhs longer than 10 (which is already
	way beyond the practical unless you like passwords (easy to crack)).
*/
 
#define OUTBUFFERSIZE 2048

#define T_END		1
#define T_COMMENT	2
#define T_EQUALS	3
#define T_KEY		4
#define T_STRING	5
#define T_ILLEG		6
 
WORD numlin=0;

BYTE outbuf[OUTBUFFERSIZE];
LONG *outall;
LONG *outleft;
LONG *outright;
LONG *outlong;
LONG *outstop;

WORD input;
WORD foutp;
BYTE *pinbuf, *pendbuf;
LONG inlen;
WORD incommand;
WORD errcommand;
LONG *outcommand;

#ifndef WITHENVIRONMENT

/*	For compilers that don't pass the environment string to main */

BYTE	fake[2] = { 0, 0 };

#endif

#ifdef ANSI

WORD StrIcmp(BYTE *, BYTE *);
WORD IniMnemo(VOID);
LONG FindMnemo(BYTE *);
WORD OneLine(VOID);
WORD Token(BYTE **, LONG *);
VOID Out(WORD);
VOID call_error(WORD);
VOID PutFile(BYTE *,BYTE **);
VOID AborT(WORD);
int main(WORD,BYTE **,BYTE **);
VOID exit(WORD);

#else

WORD StrIcmp();
WORD IniMnemo();
LONG FindMnemo();
WORD OneLine();
WORD Token();
VOID Out();
VOID call_error();
VOID PutFile();
VOID AborT();
int main();

#endif

/*
  	#] PREAMBLE :
  	#[ StrIcmp :	Case insensitive compare

	Case insensitive string compare.
	Note that doing this with a table allows for flexibility
	wrt to national character sets.
	The table here is made for the Atari ST computers.
	When only regular ASCII characters are used it makes no
	difference what the second half of the table looks like.

*/

#ifdef IBM

UBYTE ToUpper[256] = {
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0x9A,0x90,0x83,0x8E,0x85,0x8F,0x80,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x92,0x92,0x93,0x99,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC0,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF };

#else

UBYTE ToUpper[256] = {
	0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,
	0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,
	0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,
	0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,
	0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,
	0x28,0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,
	0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
	0x38,0x39,0x3A,0x3B,0x3C,0x3D,0x3E,0x3F,
	0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x5B,0x5C,0x5D,0x5E,0x5F,
	0x60,0x41,0x42,0x43,0x44,0x45,0x46,0x47,
	0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,
	0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,
	0x58,0x59,0x5A,0x7B,0x7C,0x7D,0x7E,0x7F,
	0x80,0x9A,0x90,0x83,0x8E,0xB6,0x8F,0x80,
	0x88,0x89,0x8A,0x8B,0x8C,0x8D,0x8E,0x8F,
	0x90,0x92,0x92,0x93,0x99,0x95,0x96,0x97,
	0x98,0x99,0x9A,0x9B,0x9C,0x9D,0x9E,0x9F,
	0xA0,0xA1,0xA2,0xA3,0xA5,0xA5,0xA6,0xA7,
	0xA8,0xA9,0xAA,0xAB,0xAC,0xAD,0xAE,0xAF,
	0xB7,0xB8,0xB2,0xB2,0xB5,0xB5,0xB6,0xB7,
	0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0xBE,0xBF,
	0xC1,0xC1,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
	0xC8,0xC9,0xCA,0xCB,0xCC,0xCD,0xCE,0xCF,
	0xD0,0xD1,0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,
	0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,
	0xE0,0xE1,0xE2,0xE3,0xE4,0xE5,0xE6,0xE7,
	0xE8,0xE9,0xEA,0xEB,0xEC,0xED,0xEE,0xEF,
	0xF0,0xF1,0xF2,0xF3,0xF4,0xF5,0xF6,0xF7,
	0xF8,0xF9,0xFA,0xFB,0xFC,0xFD,0xFE,0xFF };

#endif

WORD
StrIcmp(a,b)
register BYTE *a, *b;
{
	register UBYTE c1, c2;
	while ( *a ) {
		c1 = ToUpper[*a & 0x00FF];
		c2 = ToUpper[*b & 0x00FF];
		a++; b++;
		if ( c1 != c2 ) return(c1-c2);
	}
	return ( *a - *b );
}

/*
  	#] StrIcmp :
  	#[ Mnemonics :  Tables and searches
 		#[ MNEMO :
*/

typedef struct Mnemo {
	BYTE *name;
	LONG code;
} MNEMO;

/*
 		#] MNEMO :
 		#[ Table :

		List of all mnemonics that could correspond to some action
		internally.

		Currently the `numeric keypad' bit is stripped, so a
		numeric 0 and a regular zero do the same internally.

		The mouse items are only for systems that support a mouse.

		Some of the defined `keys' are not bound to anything.
		The code is included to make it easier to use them in the
		future.

		On some systems some of the mnemonics may not make sense.
		Often there are equivalent mnemonics that do make sense.

		The first two (STARTCOMMAND and ENDCOMMAND) exist only for
		the new versions (>= 3.0) of STedi.
*/

#define STARTCOMMAND 0x00001F00L
#define ENDCOMMAND 0x00001E00L

MNEMO mTable[] = {
		"AFTER_READ",	0x12000000L,
		"ALT_0",		0x08000130L,
		"ALT_1",		0x08000131L,
		"ALT_2",		0x08000132L,
		"ALT_3",		0x08000133L,
		"ALT_4",		0x08000134L,
		"ALT_5",		0x08000135L,
		"ALT_6",		0x08000136L,
		"ALT_7",		0x08000137L,
		"ALT_8",		0x08000138L,
		"ALT_9",		0x08000139L,
		"ALT_A",		0x08000141L,
		"ALT_B",		0x08000142L,
		"ALT_C",		0x08000143L,
		"ALT_D",		0x08000144L,
		"ALT_E",		0x08000145L,
		"ALT_EQ",		0x0800013DL,		/* Alternate - equalsign */
		"ALT_F",		0x08000146L,
		"ALT_FUN0",		0x04000230L,		/* For PC */
		"ALT_FUN1",		0x04000231L,
		"ALT_FUN2",		0x04000232L,
		"ALT_FUN3",		0x04000233L,
		"ALT_FUN4",		0x04000234L,
		"ALT_FUN5",		0x04000235L,
		"ALT_FUN6",		0x04000236L,
		"ALT_FUN7",		0x04000237L,
		"ALT_FUN8",		0x04000238L,
		"ALT_FUN9",		0x04000239L,
		"ALT_FUN10",	0x04000230L,
		"ALT_G",		0x08000147L,
		"ALT_H",		0x08000148L,
		"ALT_I",		0x08000149L,
		"ALT_J",		0x0800014AL,
		"ALT_K",		0x0800014BL,
		"ALT_L",		0x0800014CL,
		"ALT_M",		0x0800014DL,
		"ALT_N",		0x0800014EL,
		"ALT_O",		0x0800014FL,
		"ALT_P",		0x08000150L,
		"ALT_Q",		0x08000151L,
		"ALT_R",		0x08000152L,
		"ALT_S",		0x08000153L,
		"ALT_T",		0x08000154L,
		"ALT_U",		0x08000155L,
		"ALT_V",		0x08000156L,
		"ALT_W",		0x08000157L,
		"ALT_X",		0x08000158L,
		"ALT_Y",		0x08000159L,
		"ALT_Z",		0x0800015AL,
		"BACKSLASH",	0x0000005CL,
		"BACKSPACE",	0x00001018L,
		"BLANK",		0x00000020L,
		"CLEAR",		0x02000809L,
		"CLOSE",		0x00000406L,
		"CLOSE_ALL",	0x02000806L,
		"CLOSE_WIN",	0x0000404BL,		/* Only with windows */
		"COLON",		0x0000003AL,
		"COMMA",		0x0000002CL,
		"COMMAND",		STARTCOMMAND,
		"COPY",			0x00000404L,
		"COPY_BLOCK",	0x02000804L,
		"CRETURN",		0x00001019L,		/* Carriage return */
		"CTRL_0",		0x04000230L,		/* For Atari */
		"CTRL_1",		0x04000231L,
		"CTRL_2",		0x04000232L,
		"CTRL_3",		0x04000233L,
		"CTRL_4",		0x04000234L,
		"CTRL_5",		0x04000235L,
		"CTRL_6",		0x04000236L,
		"CTRL_7",		0x04000237L,
		"CTRL_8",		0x04000238L,
		"CTRL_9",		0x04000239L,
		"CTRL_A",		0x04000241L,
		"CTRL_B",		0x04000242L,
		"CTRL_C",		0x04000243L,
		"CTRL_D",		0x04000244L,
		"CTRL_E",		0x04000245L,
		"CTRL_F",		0x04000246L,
		"CTRL_FUN0",	0x06000C0AL,		/* Named double to avoid confusion */
		"CTRL_FUN1",	0x06000C01L,		/* For PC */
		"CTRL_FUN10",	0x06000C0AL,
		"CTRL_FUN2",	0x06000C02L,
		"CTRL_FUN3",	0x06000C03L,
		"CTRL_FUN4",	0x06000C04L,
		"CTRL_FUN5",	0x06000C05L,
		"CTRL_FUN6",	0x06000C06L,
		"CTRL_FUN7",	0x06000C07L,
		"CTRL_FUN8",	0x06000C08L,
		"CTRL_FUN9",	0x06000C09L,
		"CTRL_G",		0x04000247L,
		"CTRL_H",		0x04000248L,
		"CTRL_I",		0x04000249L,
		"CTRL_J",		0x0400024AL,
		"CTRL_K",		0x0400024BL,
		"CTRL_L",		0x0400024CL,
		"CTRL_M",		0x0400024DL,
		"CTRL_MIN",		0x0400022DL,
		"CTRL_N",		0x0400024EL,
		"CTRL_O",		0x0400024FL,
		"CTRL_P",		0x04000250L,
		"CTRL_Q",		0x04000251L,
		"CTRL_R",		0x04000252L,
		"CTRL_S",		0x04000253L,
		"CTRL_T",		0x04000254L,
		"CTRL_U",		0x04000255L,
		"CTRL_V",		0x04000256L,
		"CTRL_W",		0x04000257L,
		"CTRL_X",		0x04000258L,
		"CTRL_Y",		0x04000259L,
		"CTRL_Z",		0x0400025AL,
		"CT_DELETE",	0x04001017L,		/* Control delete */
		"CT_DOWN",		0x04001009L,
		"CT_HOME",		0x04001012L,
		"CT_LEFT",		0x0400100BL,
		"CT_RIGHT",		0x0400100AL,
		"CT_UP",		0x04001008L,
		"CUT",			0x00000403L,
		"CUT_BLOCK",	0x02000803L,
		"DELETE",		0x00001016L,
		"DELETELINE",	0x04001017L,
		"DELETE_MARK",	0x02000801L,
		"DOWN",			0x00001001L,
		"END",			0x02001011L,
		"ENDCOMMAND",	ENDCOMMAND,
		"ENTER",		0x00001020L,
		"ESCAPE",		0x0000101BL,
		"EXCHANGE",		0x00000402L,
		"FLAG1OFF",		0x26000000L,
		"FLAG1ON",		0x2C000000L,
		"FLAG2OFF",		0x46000000L,
		"FLAG2ON",		0x4C000000L,
		"FLAG3OFF",		0x86000000L,
		"FLAG3ON",		0x8C000000L,
		"FLAGS000",		0x04000000L,
		"FLAGS001",		0x24000000L,
		"FLAGS010",		0x44000000L,
		"FLAGS011",		0x64000000L,
		"FLAGS100",		0x84000000L,
		"FLAGS101",		0xA4000000L,
		"FLAGS110",		0xC4000000L,
		"FLAGS111",		0xE4000000L,
		"FUN1",			0x00000401L,
		"FUN10",		0x0000040AL,
		"FUN11",		0x02000801L,
		"FUN12",		0x02000802L,
		"FUN13",		0x02000803L,
		"FUN14",		0x02000804L,
		"FUN15",		0x02000805L,
		"FUN16",		0x02000806L,
		"FUN17",		0x02000807L,
		"FUN18",		0x02000808L,
		"FUN19",		0x02000809L,
		"FUN2",			0x00000402L,
		"FUN20",		0x0200080AL,
		"FUN3",			0x00000403L,
		"FUN4",			0x00000404L,
		"FUN5",			0x00000405L,
		"FUN6",			0x00000406L,
		"FUN7",			0x00000407L,
		"FUN8",			0x00000408L,
		"FUN9",			0x00000409L,
		"GOTO_MARK",	0x02000802L,
		"HELP",			0x0000101DL,
		"HOME",			0x00001010L,
		"INSERT",		0x00001014L,
		"LEARN0",		0x04000230L,
		"LEARN1",		0x04000231L,
		"LEARN2",		0x04000232L,
		"LEARN3",		0x04000233L,
		"LEARN4",		0x04000234L,
		"LEARN5",		0x04000235L,
		"LEARN6",		0x04000236L,
		"LEARN7",		0x04000237L,
		"LEARN8",		0x04000238L,
		"LEARN9",		0x04000239L,
		"LEFT",			0x00001003L,
		"LINEFEED",		0x0400101AL,		/* Linefeed */
		"MARK",			0x00000401L,
		"ML_MEN1",		0x00070001L,		/* Mouse menu item 1 */
		"ML_MEN10",		0x0007000AL,		/* Only if no windows */
		"ML_MEN11",		0x0007000BL,
		"ML_MEN12",		0x0007000CL,
		"ML_MEN13",		0x0007000DL,
		"ML_MEN14",		0x0007000EL,
		"ML_MEN15",		0x0007000FL,
		"ML_MEN16",		0x00070010L,
		"ML_MEN17",		0x00070011L,
		"ML_MEN18",		0x00070012L,
		"ML_MEN19",		0x00070013L,
		"ML_MEN2",		0x00070002L,
		"ML_MEN20",		0x00070014L,
		"ML_MEN21",		0x00070015L,
		"ML_MEN22",		0x00070016L,
		"ML_MEN23",		0x00070017L,
		"ML_MEN24",		0x00070018L,
		"ML_MEN25",		0x00070019L,
		"ML_MEN26",		0x0007001AL,
		"ML_MEN27",		0x0007001BL,
		"ML_MEN28",		0x0007001CL,
		"ML_MEN29",		0x0007001DL,
		"ML_MEN3",		0x00070003L,
		"ML_MEN30",		0x0007001EL,
		"ML_MEN4",		0x00070004L,
		"ML_MEN5",		0x00070005L,
		"ML_MEN6",		0x00070006L,
		"ML_MEN7",		0x00070007L,
		"ML_MEN8",		0x00070008L,
		"ML_MEN9",		0x00070009L,
		"MR_MEN1",		0x000B0001L,		/* Mouse menu item 1 */
		"MR_MEN10",		0x000B000AL,		/* Only if no windows */
		"MR_MEN11",		0x000B000BL,
		"MR_MEN12",		0x000B000CL,
		"MR_MEN13",		0x000B000DL,
		"MR_MEN14",		0x000B000EL,
		"MR_MEN15",		0x000B000FL,
		"MR_MEN16",		0x000B0010L,
		"MR_MEN17",		0x000B0011L,
		"MR_MEN18",		0x000B0012L,
		"MR_MEN19",		0x000B0013L,
		"MR_MEN2",		0x000B0002L,
		"MR_MEN20",		0x000B0014L,
		"MR_MEN21",		0x000B0015L,
		"MR_MEN22",		0x000B0016L,
		"MR_MEN23",		0x000B0017L,
		"MR_MEN24",		0x000B0018L,
		"MR_MEN25",		0x000B0019L,
		"MR_MEN26",		0x000B001AL,
		"MR_MEN27",		0x000B001BL,
		"MR_MEN28",		0x000B001CL,
		"MR_MEN29",		0x000B001DL,
		"MR_MEN3",		0x000B0003L,
		"MR_MEN30",		0x000B001EL,
		"MR_MEN4",		0x000B0004L,
		"MR_MEN5",		0x000B0005L,
		"MR_MEN6",		0x000B0006L,
		"MR_MEN7",		0x000B0007L,
		"MR_MEN8",		0x000B0008L,
		"MR_MEN9",		0x000B0009L,
		"NOCODE",		0x10000000L,
		"NUM_0",		0x00002030L,		/* Numeric zero */
		"NUM_1",		0x00002031L,
		"NUM_2",		0x00002032L,
		"NUM_3",		0x00002033L,
		"NUM_4",		0x00002034L,
		"NUM_5",		0x00002035L,
		"NUM_6",		0x00002036L,
		"NUM_7",		0x00002037L,
		"NUM_8",		0x00002038L,
		"NUM_9",		0x00002039L,
		"NUM_ADD",		0x0000202BL,		/* Numeric - add */
		"NUM_DIV",		0x0000202FL,		/* Numeric - divide */
		"NUM_DOT",		0x0000202EL,		/* Numeric - dot */
		"NUM_ENTER",	0x00003019L,		/* Numeric - enter */
		"NUM_LB",		0x00002028L,		/* Numeric - left bracket */
		"NUM_LF",		0x0000301AL,		/* Numeric - linefeed */
		"NUM_MIN",		0x0000202DL,		/* Numeric - minus */
		"NUM_MUL",		0x0000202AL,		/* Numeric - multiply */
		"NUM_PERIOD",	0x0000202EL,		/* Numeric - period */
		"NUM_PLUS",		0x0000202BL,		/* Numeric - plus */
		"NUM_RB",		0x00002029L,		/* Numeric - right bracket */
		"NUM_SLASH",	0x0000202FL,		/* Numeric - slash */
		"NUM_STAR",		0x0000202AL,		/* Numeric - star */
		"NUM_SUB",		0x0000202DL,		/* Numeric - subtract */
		"ON_EXIT",		0x18000000L,		/* For action at quit */
		"OPEN",			0x00000407L,
		"OPEN_ALL",		0x02000807L,
		"OPEN_WIN",		0x0000404AL,		/* Only with windows */
		"PAGE_DOWN",	0x02001005L,
		"PAGE_UP",		0x02001004L,
		"PAGE_DOWN",	0x04001009L,
		"PAGE_UP",		0x04001008L,
		"PASTE",		0x00000405L,
		"PASTE_BLOCK",	0x02000805L,
		"PLUS",			0x0200002BL,
		"P_ITEM1",		0x00001030L,		/* Private menu items */
		"P_ITEM2",		0x00001031L,		/* for use in the window */
		"P_ITEM3",		0x00001032L,		/* version that runs under */
		"P_ITEM4",		0x00001033L,		/* PortWin */
		"P_ITEM5",		0x00001034L,
		"P_ITEM6",		0x00001035L,
		"P_ITEM7",		0x00001036L,
		"P_ITEM8",		0x00001037L,
		"P_ITEM9",		0x00001038L,
		"P_ITEM10",		0x00001039L,
		"QUIT",			0x0200080AL,
		"READ",			0x00000408L,
		"RETURN",		0x00001019L,		/* Carriage return */
		"RIGHT",		0x00001002L,		/* Cursor right */
		"SAVE",			0x00000409L,
		"SAVE_QUIT",	0x0000040AL,
		"SC_HOME",		0x06001013L,
		"SC_LEFT",		0x0600100FL,
		"SC_RIGHT",		0x0600100EL,
		"SEMICOLON",	0x0000003BL,
		"SH_DOWN",		0x02001005L,		/* Shift cursor down */
		"SH_HOME",		0x02001011L,
		"SH_INSERT",	0x02001015L,
		"SH_LEFT",		0x02001007L,
		"SH_PAGE_DOWN",	0x04001009L,
		"SH_PAGE_UP",	0x04001008L,
		"SH_RIGHT",		0x02001006L,
		"SH_UP",		0x02001004L,
		"STARTUP",		0x10000000L,
		"TAB",			0x00000009L,
		"TAG0",			0x06000C0AL,		/* Named double to avoid confusion */
		"TAG1",			0x06000C01L,
		"TAG10",		0x06000C0AL,
		"TAG2",			0x06000C02L,
		"TAG3",			0x06000C03L,
		"TAG4",			0x06000C04L,
		"TAG5",			0x06000C05L,
		"TAG6",			0x06000C06L,
		"TAG7",			0x06000C07L,
		"TAG8",			0x06000C08L,
		"TAG9",			0x06000C09L,
		"UNDO",			0x0000101CL,
		"UP",			0x00001000L,		/* Cursor up */
		"WRITE",		0x02000808L,
		"YANK",			0x00000403L,
		"YANK_BLOCK",	0x02000803L
};

/*
 		#] Table :
 		#[ Variables :
*/

MNEMO *mfirst, *mlast, *mstart;	/* for binary search */

/*
 		#] Variables :
 		#[ IniMnemo :			WORD IniMnemo()

		Note that the table of mnemonics must be in order (sorted).
		Any deviations of strict order will cause the binary
		search algorithm to fail.
		This is where the sort command of the editor comes in handy.
*/

WORD
IniMnemo()
{
	WORD NumMnemo;
	NumMnemo = (WORD)sizeof(mTable)/(WORD)sizeof(struct Mnemo);
	mfirst = mTable;
	mlast = mTable + NumMnemo - 1;
	mstart = mTable + NumMnemo/2;
	return(0);
}

/*
 		#] IniMnemo :
 		#[ FindMnemo :			WORD FindMnemo(s)

		Binary search in the table with the mnemonics
		A return value of -1 indicates that the string was not
		found in the table.
		Upon succes the code of the `name' is returned.

*/

LONG
FindMnemo(s)
BYTE *s;
{
	register MNEMO *first, *middle, *last;
	register  WORD i;
	first = mfirst; middle = mstart; last = mlast;
	do {
		if ( ( i = StrIcmp ( s, middle->name ) ) == 0 ) {
			return(middle->code);
		}
		else if ( i > 0 ) {		/* to the right of middle */
			first = middle + 1;
		}
		else {
			last = middle - 1;
		}
		middle = first + ( last - first ) / 2;
	} while ( first <= last );
	return(-1);				/* Not in list */
}

/*
 		#] FindMnemo :
  	#] Mnemonics :
  	#[ OneLine :	Compiles one line
*/

WORD
OneLine()
{
	register WORD left = 1;
	register WORD setskip = 0;
	LONG value;
	outall = (LONG *)outbuf;
	outleft = outall+1;
	outlong = outleft+1;
	outright = outlong;
	*outleft = 0;
	incommand = 0;
	errcommand = 0;
	numlin++;
	while ( pinbuf < pendbuf ) {
		switch ( Token(&pinbuf,&value) ) {
			case T_END:
/*
				End of line. Write the line if needed. Test for end of file.
*/
				if ( errcommand || incommand ) {
					call_error(3);
					setskip = 1;
				}
				*outall = ( *outleft + *outright + 3 ) * sizeof(LONG);
				if ( setskip ) {}
				else if ( ( *outleft > 0 ) && ( left == 0 ) ) {
					Fwrite(foutp,*outall,outbuf);
				}
				else if ( ( left == 0 ) || ( *outleft > 0 ) ) {
					call_error(2);
				}
				if ( pinbuf >= pendbuf ) return(0);
				else					 return(1);

			case T_COMMENT:
/*
				Comment is skipped. Do nothing.
*/
				break;

			case T_KEY:
/*
				Add the key to the output. Test for overflow and continue.
*/
				if ( outlong >= outstop ) {
					setskip = 1;
					call_error(1);
				}
				if ( !setskip ) {
					*outlong++ = value;
					if ( left ) (*outleft)++;
					else		(*outright)++;
				}
				break;

			case T_EQUALS:
/*
				The = sign is encountered. Test for uniqueness and close
				the left hand side. Open the right hand side and continue.
*/
				if ( left == 0 ) { setskip = 1; }
				else {
					left = 0;
					outright = outlong;
					*outlong++ = 0;
				}
				break;

			case T_STRING:	/* We read an entire string */
				while ( pinbuf < pendbuf ) {
					if ( *pinbuf == '\\' ) {
						pinbuf++;
					}
					else if ( *pinbuf == '"' ) {
						pinbuf++; break;
					}
					value = (ULONG)(UBYTE)(*pinbuf++);
					if ( !setskip ) {
						*outlong++ = value;
						if ( left ) (*outleft)++;
						else		(*outright)++;
					}
				}
				break;

			default:		/* same as case T_ILLEG: */

				setskip = 1;
				break;
		}
	}
	call_error(2);
	return(0);
}

/*
  	#] OneLine :
  	#[ Token :		Find the next object and determine what it is.
*/

WORD
Token(str,num)
BYTE **str;
LONG *num;
{
	register BYTE *s, *t;
	register LONG x, y;
	register WORD n;
	BYTE c, cp;
	s = *str;
/*
		Skip `whitespace'
*/
	while ( *s == ' '  || *s == '\t' || *s == ','
		 || *s == '\n' || *s == '\r' || *s == '+' ) s++;
/*
		Skip commentary
*/
	if ( *s == '(' || *s == '[' || *s == '{' ) {
		if ( *s == '(' ) { cp = ')'; }
		else if ( *s == '[' ) { cp = ']'; }
		else if ( *s == '{' ) { cp = '}'; }
		c = *s;
		n = 0;
		s++;
		do {
			if ( *s == c ) n++;
			else if ( *s == cp ) n--;
			else if ( !*s ) { *str = s; return(T_END); }
			s++;
		} while ( n >= 0 );
		*str = s;
		return(T_COMMENT);
	}
/*
		The equals sign is special
*/
	if ( *s == '=' ) { *str = s + 1; return(T_EQUALS); }
/*
		The end of the statement. Skip trailing commentary after :
*/
	if ( *s == ':' || *s == ';' || !*s ) {
		while ( *s && *s != ';' ) {
			if ( *s == '\\' ) s++;
			s++;
		}
		*str = s + 1;
		return(T_END);
	}
/*
		The double quote gives an uninterpreted string
*/
	if ( *s == '"' ) {
		*str = s+1;
		return(T_STRING);
	}
/*
		Take now the mnemonics
*/
	if ( ( *s >= 'a' && *s <= 'z' ) || ( *s >= 'A' && *s <= 'Z' ) ) {
		t = s + 1;
		while ( ( *t >= 'a' && *t <= 'z' )
			 || ( *t >= 'A' && *t <= 'Z' )
			 || ( *t >= '0' && *t <= '9' )
			 || *t == '_' ) t++;
		c = *t;
		*t = '\0';
		y = FindMnemo(s);
		*t = c;
		if ( y != -1L ) {		/* Caught one. */
SendKey:
			*num = y;
			*str = t;
/*
				After STARTCOMMAND we have to store `outlong' away.
				It should be remembered for when we run into ENDCOMMAND
*/
			if ( y == STARTCOMMAND ) {
				if ( incommand ) errcommand = 1;
				outcommand = outlong;
				incommand++;
			}
/*
				After ENDCOMMAND we compute the number of keys involved.
				Then we use `outcommand' to store this number inside the
				STARTCOMMAND. STedi can now copy the whole command
				directly to the command buffer.
*/
			if ( y == ENDCOMMAND ) {
				incommand--;
				if ( incommand < 0 ) errcommand = 1;
				else if ( incommand == 0 ) {
					x = outlong - outcommand;
					if ( x > 255 ) errcommand = 1; /* Too many */
					*outcommand |= x & 0xFF;	/* number of keys in upper word */
				}
			}
			return(T_KEY);
		}
	}
/*
		Check now for a hexadecimal sequence.
*/
	if ( ( *s >= '0' && *s <= '9' )
	  || ( *s >= 'a' && *s <= 'f' )
	  || ( *s >= 'A' && *s <= 'F' ) ) {
		t = s + 1;
		while ( ( *t >= 'a' && *t <= 'f' )
			 || ( *t >= 'A' && *t <= 'F' )
			 || ( *t >= '0' && *t <= '9' ) ) t++;
		if ( ( t - s ) >= 2 && ( t - s ) <= 8 ) {
/*
				There should be something that makes sense after the
				hexadecimal number or somebody is doing something wrong
				This may happen only after at most 8 hexadecimal digits.
*/
			if ( *t == ' ' || *t == '\t' || *t == ',' || *t == '+'
			|| *t == '\n' || *t == '\r' || *t == '(' || *t == '['
			|| *t == '{' || *t == ':' || *t == ';' || !*t ) {
				x = 0;
				while ( s < t ) {
					n = 0;
					if ( *s >= '0' && *s <= '9' ) n = *s - '0';
					else if ( *s >= 'A' && *s <= 'F' ) n = *s - 'A' + 10;
					else n = *s - 'a' + 10;
					x = ( x << 4 ) + n;
					s++;
				}
				y = x;
				goto SendKey;
			}
		}
	}
/*
		Finally we try for a single character code
		Test first for an escape code.
*/
	if ( *s == '\\' ) s++;
	t = s + 1;
	if ( *t == ' ' || *t == '\t' || *t == ',' || *t == '+'
	|| *t == '\n' || *t == '\r' || *t == '(' || *t == '['
	|| *t == '{' || *t == ':' || *t == ';' || !*t ) {
/*
		Single character
*/
		*num = ((LONG)*s) & 0x000000FFL;
		*str = t;
		return(T_KEY);
	}
/*
		Here we have run into incomprehensible code
*/
	t = s;
	s++;
	while ( *s != ' '  && *s != '\t' && *s != ',' && *s != '+'
	     && *s != '\n' && *s != '\r' && *s != '(' && *s != '['
	     && *s != '{'  && *s != ':'  && *s != ';' && *s != '"'
	     && *s ) s++;
	c = *s;
	*s = 0;
	Cconws ( t );		/* write the offending object */
	call_error(0);		/* And produce an error code with a line number */
	*s = c;
	*str = s;
	return(T_ILLEG);
}

/*
  	#] Token :
  	#[ ERRORS : 	Printing the error messages.
 		#[ NUMBER : Print a number.
*/

VOID
Out(n)
WORD n;
{
	BYTE s[2];
	if(n>9)Out(n/10);
	s[0] = (n%10)+'0';
	s[1] = 0;
	Cconws(s);
}
/*
 		#] NUMBER :
 		#[ PRINT : print the message.
*/

VOID
call_error(num)
WORD num;
{
	Cconws("Error in line number");Out(numlin);Cconws("\n");
	switch(num){

		case 0:
				Cconws(" is illegal code\n");
				break;
		case 1:
				Cconws(" Output buffer overflow\n");
				break;
		case 2:
				Cconws("\tleft side or right side missing.\n");
				break;
		case 3:
				Cconws("\tunmatched command/endcommand.\n");
				break;
		case 4:
				Cconws("\tirregular end of file.\n");
				break;
		default:
				break;
	}
}

/*
 		#] PRINT :
  	#] ERRORS :
  	#[ PutFile :    Write a filename properly

	Write a filename in the proper mode.
	This is only important on computers that use the antiquated
	\ as directory separator.
	Examples: MS-DOS, Atari-ST.
	If there is an environment variable `unixpath' the path is
	typed with / rather \ for directory separators.
	On unix the search for unixpath is of course not needed.

*/

VOID
PutFile(a,env)
register BYTE *a, **env;
{
	register BYTE *b;
#ifdef UNIX
	WORD unixp = 1;
#else
	WORD unixp = 0;
	while ( **env ) {
		if ( !StrIcmp ( *env, "unixpath=" ) ) { unixp = 1; break; }
		env++;
	}
#endif
	b = a;
	if ( unixp ) { while ( *b ) { if ( *b == '\\' ) *b = '/'; b++; } }
	Cconws ( a );
}

/*
  	#] PutFile :
  	#[ Sysfiles :	Some special files for special compilers
 		#[ Fcreate :			LONG Fcreate(BYTE *name,WORD attribute)
*/

#ifdef __WATCOMC__

LONG
Fcreate(BYTE *name,WORD attribute)
{
	union REGS inr, outr;
	struct SREGS ins;
	ins.ds = ((ULONG)(void far *)name) >> 16;
	inr.x.dx = (UWORD)name;
	inr.h.cl = attribute;
	inr.h.ah = DOS_CREAT;
	intdosx(&inr,&outr,&ins);
	return( outr.x.cflag ? -outr.x.ax : outr.x.ax );
}

/*
 		#] Fcreate :
 		#[ Fopen :				LONG Fopen(BYTE *name,WORD attribute)
*/

LONG
Fopen(BYTE *name,WORD attribute)
{
	union REGS inr, outr;
	struct SREGS ins;
	ins.ds = ((ULONG)(void far *)name) >> 16;
	inr.x.dx = (UWORD)name;
	inr.h.al = attribute;
	inr.h.ah = DOS_OPEN;
	intdosx(&inr,&outr,&ins);
	return( outr.x.cflag ? -outr.x.ax : outr.x.ax );
}

/*
 		#] Fopen :
 		#[ Fclose :				LONG Fclose(WORD handle)
*/

LONG
Fclose(WORD handle)
{
	union REGS inr, outr;
	inr.x.bx = handle;
	inr.h.ah = DOS_CLOSE;
	intdos(&inr,&outr);
	return ( outr.x.cflag ? -outr.x.ax : 0 );
}

/*
 		#] Fclose :
 		#[ Fread :				LONG Fread(WORD handle,LONG number,BYTE *buffer)
*/

LONG FileWR(WORD handle,LONG number,BYTE *buffer,WORD type);

LONG
Fread(WORD handle,LONG number,BYTE *buffer)
{
	return(FileWR(handle,number,buffer,DOS_READ));
}

/*
 		#] Fread :
 		#[ Fwrite :				LONG Fwrite(WORD handle,LONG number,BYTE *buffer)
*/

LONG
Fwrite(WORD handle,LONG number,BYTE *buffer)
{
	return(FileWR(handle,number,buffer,DOS_WRITE));
}

/*
 		#] Fwrite :
 		#[ FileWR :				LONG FileWR(WORD handle,LONG number,BYTE *buffer,WORD type)
*/

LONG
FileWR(WORD handle,LONG number,BYTE *buffer,WORD type)
{
	union REGS inr, outr;
	struct SREGS ins;
	LONG written = 0;
	UWORD buftop, bufbot;
	WORD towrite;
	if ( number <= 0 ) return(0);
	buftop = ((ULONG)(void far *)buffer) >> 16;
	bufbot = (UWORD)buffer;
	buftop += bufbot >> 4;
	bufbot &= 0xF;
	while ( number > 0 ) {
		towrite = number > 16384 ? 16384 : number;
		ins.ds = buftop;
		inr.x.dx = bufbot;
		inr.x.cx = towrite;
		inr.x.bx = handle;
		inr.h.ah = type;
		intdosx(&inr,&outr,&ins);
		if ( outr.x.cflag ) return(-outr.x.ax);
		written += outr.x.ax;
		if ( outr.x.ax != towrite ) break;
		buftop += towrite >> 4;
		number -= towrite;
	}
	return(written);
}

/*
 		#] FileWR :
 		#[ Cconws :				VOID Cconws(BYTE *StringToConsole)

		We write to stderr via Fwrite because of the rather insipid
		bug in MS_DOS function 9: it wants its string terminated
		with a dollar sign!
*/

VOID
Cconws(BYTE *StringToConsole)
{
	register WORD i = 0;
	register BYTE *s = StringToConsole;
	while ( *s ) { s++; i++; }
	Fwrite(2,(LONG)i,StringToConsole);
}

/*
 		#] Cconws :
 		#[ Fseek :				LONG Fseek(LONG offset,WORD handle,WORD origin)
*/

LONG
Fseek(LONG offset,WORD handle,WORD origin)
{
	union REGS inr, outr;
	inr.x.bx = handle;
	inr.h.al = origin;
	inr.x.cx = offset >> 16;
	inr.x.dx = (UWORD)offset;
	inr.h.ah = DOS_LSEEK;
	intdos(&inr,&outr);
	return( outr.x.cflag ? -(LONG)(outr.x.ax) : 
		(((ULONG)outr.x.dx)<<16)|((ULONG)(UWORD)outr.x.ax) );
}

/*
 		#] Fseek :
 		#[ Malloc :				VOID *Malloc(LONG RequestedSpace)
*/

VOID *
Malloc(LONG RequestedSpace)
{
	union REGS inr, outr;
	inr.h.ah = DOS_ALLOC_SEG;
	if ( RequestedSpace < 0 ) {
		inr.x.bx = 0xFFFF;
		intdos(&inr,&outr);
		return ( (void *)(((ULONG)outr.x.bx)<<4) );
	}
	else {
		inr.x.bx = ( RequestedSpace + 15 ) >> 4;
		intdos(&inr,&outr);
		return ( outr.x.cflag ? 0 : (void *)(((ULONG)outr.x.ax)<<16) );
	}
}

#endif

/*
 		#] Malloc :
  	#] Sysfiles :
  	#[ EXIT :		Cleanup of the environment.

	There are some completely idiotic compiler systems that usurp
	names that look much like Abort etc. so our own routine needs
	a less conventional name. 
*/

VOID
AborT(error)
WORD error;
{
	Fclose(input);
	Fclose(foutp);
	exit(error);
}
/*
  	#] EXIT :
  	#[ MAIN :		commandline handling
*/

int
main(argc,argv,envp)
WORD argc;
BYTE **argv, **envp;
{
	LONG bug;
	register BYTE *a1;
	BYTE cbuf[132];
	BYTE *cb;
#ifndef WITHENVIRONMENT
	envp = &fake;
#endif
	register WORD i = 0;

	if ( IniMnemo() ) AborT(-1);
	argc--;
	argv++;

	if ( argc < 1 || *argv == '\0' ) {
		Cconws ( "Use: keycomp infile outfile or keycomp file\n" );
		return(-1);
	}
	else if ( argc == 1 ) {
		a1 = *argv;
		while ( *a1 != 0 ) { cbuf[i++] = *a1++; }
		cbuf[i] = '\0';
		a1 = cbuf + i;
		a1--;
		while ( ( *a1 != '\\' ) && ( *a1 != ':' ) && ( a1 > cbuf ) ) { a1--; }
		while ( ( *a1 != '.' ) && ( *a1 != '\0' ) ) { a1++; }
		*a1++ = '.';
		*a1++ = 'k';
		*a1   = '\0';
		if ( ( input = Fopen ( cbuf, 0 ) ) < 0 ) {
			cb = cbuf;
			Cconws ( "Cannot open file " );
			PutFile( cb, envp );
			Cconws ( "\n" );
			return(-1);
		}
		*a1++ = 'e';
		*a1++ = 'y';
		*a1   = '\0';
		if ( ( foutp = Fcreate ( cbuf, 0 ) ) < 0 ) {
			cb = cbuf;
			Fclose ( input );
			Cconws ( "Cannot create file " );
			PutFile( cb, envp );
			Cconws ( "\n" );
			return(-1);
		}
	}
	else {
		if ( ( input = Fopen ( *argv, 0 ) ) < 0 ) {
			cb = argv[1];
			Cconws ( "Cannot open file " );
			PutFile( cb, envp );
			Cconws ( "\n" );
			return(-1);
		}
		if ( ( foutp = Fcreate ( argv[1], 0 ) ) < 0 ) {
			cb = argv[1];
			Fclose ( input );
			Cconws ( "Cannot create file " );
			PutFile( cb, envp );
			Cconws ( "\n" );
			return(-1);
		}
	}

	if ( ( inlen = Fseek(0L,input,2) ) < 0 ) AborT((WORD)inlen);
	if ( ( pinbuf = (BYTE *)Malloc(inlen+4) ) == 0 ) AborT(-39);
	Fseek(0L,input,0);
	if ( ( bug = Fread(input,inlen,pinbuf) ) != inlen ) AborT((WORD)bug);
/*
		Now fake an empty start line to get things going
*/
	pendbuf = pinbuf+inlen;
	*pendbuf = ';';		/* force an end of line */
	*(pendbuf+1) = 0;
	outstop = (LONG *) ( outbuf + OUTBUFFERSIZE );
/*
		The loop is rather simple (or so it seems).
*/
	while(OneLine()){}

	AborT(0);
	return(0);
}

/*
  	#] MAIN :
*/
