/*
  	#[ Include file :
*/
#include "stedi.h"
#include "keydefs.h"

#ifdef ANSI
LONG MakeKey(UBYTE *,WORD);
#else
LONG MakeKey();
#endif

extern PfunLo alts[], ctrls[];

/*
  	#] Include file :
  	#[ Date :
*/

LONG
DispDate(VOID)
{
#ifdef WITHDATE
	UBYTE buf[16];
	return(InNorm(buf,MakeDate(buf)));
#else
	return(0);
#endif
}

/*
  	#] Date :
  	#[ Positions :
*/
#ifndef DEMO

LONG
CountBytes(LINE l1,LINE l2)
{
	BUFFER b = cbuf;
	LONG sum = 0;
	WORD num;
	while ( l1 != l2 ) {
		num = l1->used - LINEHEAD;
		if ( num >= 0 ) {
			if ( b->outputmode == PRINTMODE ) {
				sum += FindColumn(l1,num) + 2;
			}
			else {
				sum += num;
				if ( b->outputmode < PRINTMODE ) sum += b->outputmode;
			}
		}
		else {
			sum += CountBytes(((FOLDLINE)l1)->first,((FOLDLINE)l1)->last->next);
		}
		l1 = l1->next;
	}
	return(sum);
}

LONG
Where(VOID)
{
	LONG number, totnum;
	WORD num;
	BUFFER b = cbuf;
	FINDPOS fp;
	
	DoNumber = 1;
	if ( b->first != b->current ) number = CountBytes(b->first,b->current);
	else number = 0;
	num = b->current->used - LINEHEAD;
	if ( num < 0 ) num = ((FOLDLINE)(b->current))->used - FOLDHEAD;
	if ( b->outputmode == PRINTMODE ) {
		num = FindColumn(b->current,num) + 1; 
		if ( num > b->column ) num = b->column;
		if ( num > 0 ) num--;
	}
	else {
		num = FindChar(b->current,b->column,&fp);
		if ( num != NORMALEOL && num != AFTERVIRTUAL ) {
			if ( fp.num > 0 ) fp.num--;
		}
		num = fp.num;
	}
	if ( b->totline <= 0 ) totnum = 0;
	else totnum = number + num;
	if ( b->current != (LINE)b ) number += CountBytes(b->current,(LINE)b);
	MesPrint(13,b->column, totnum, number, b->screenline, b->column-b->offset,
		(LONG)(b->totline));
	/* "%d bytes: %l/%l screen: %d,%d lines: %l" */
	return(b->newline);
}
#endif

LONG
DoRedraw(VOID)
{
#ifdef UNIX
	PSdraw();
#endif
	return(0);
}

#ifndef PORTWIN

LONG
rawkey(VOID)
{
	return(OneKeyUp(KeyGet));
}

#endif

LONG
intkey(VOID)
{
	return(OneKeyUp(KeyChar));
}

LONG
OneKeyUp(PfunLo f)
{
	UBYTE *h, *s;
	LONG key;
	WORD n = 8;
	UBYTE c8[8];
	h = (UBYTE *)hex;
	if ( commandmode ) return(-1L);
#ifdef PORTWIN
	key = KeyChar();
#else
#ifdef WITHMOUSE
	for(;;) {
		if ( KeyPoll(0) ) {
			key = (*f)();
			break;
		}
		if ( TestMouse(0) ) {
			key = TestMouse(1);
			break;
		}
	}
#else
	key = (*f)();
#endif
#endif
	s = c8 + 8;
	do {
		*--s = h[key & 0xF];
		key >>= 4;
	} while ( --n > 0 );
	return(InNorm(s,8));
}

LONG
FindBuffer(UBYTE *s,WORD n)
{
	BUFFER b;
	WORD i;
	WORD oldbuf;
	if ( n <= 0 ) return(0L);
	oldbuf = cbuf->bufnum;
	i = oldbuf;
	do {
		i++;
		if ( i > 9 ) i -= 10;
		b = textbuffer[i];
		if ( commandbuffer->sensitivity == SENSITIVE ) {
			if ( strNcmp(b->name,s,n) == 0 ) return(GotoBuffer(i));
		}
		else {
			if ( strNIcmp(b->name,s,n) == 0 ) return(GotoBuffer(i));
		}
	} while ( i != oldbuf );
	MesnOut(1); /* "Buffer not found" */
	return(-1L);
}

/*
  	#] Positions :
  	#[ String Insert :

	We first strip the last " and assume that the statement runs
	till that point. This avoids problems with strings like:
	"path\"

*/
#ifndef DEMO

LONG
Istring(UBYTE *s,WORD n)
{
	WORD i = 0;
	UBYTE *ss;
	ss = s + n;
	while ( *--ss != '"' ) n--;
	n--;
	ss = s;
	while ( n > 0 ) {
		if ( ( *s == '\\' || *s == 0x1B ) && n > 1 ) {
			if ( s[1] == 'n' || s[1] == 'r' ) {
				n--; s++; goto DoCarry;
			}
			if ( InNorm(ss,i) < 0 ) return(-1);
			n--; s++; i = 1; ss = s;
		}
		else if ( *s == '\n' || *s == '\r' ) {
DoCarry:
			if ( i > 0 ) { if ( InNorm(ss,i) < 0 ) return(-1); }
			if ( CRnorm() < 0 ) return(-1);
			i = 0; ss = s + 1;
		}
		else { i++; }
		n--; s++;
	}
	return(InNorm(ss,i));
}
#endif
/*
  	#] String Insert :
  	#[ Settings :
*/

LONG
tog_hexset(VOID)
{
	HexSetting++;
	if ( HexSetting >= 3 ) HexSetting = 0;
	ForceDisplay();
	return(0);
}

LONG
pathnam(VOID)
{
	MesOut((BYTE *)(cbuf->fullname));
	return(0);
}

LONG
set_sbr(VOID)
{
	if ( --cbuf->direction < -2 ) cbuf->direction = 2;
	return(0L);
}

LONG
set_raw(VOID)
{
	cbuf->outputmode = RAWMODE;
	return(0L);
}

LONG
tog_tab(VOID)
{
	if ( commandmode ) return(-1L);
	TabShow ^= 1;
#ifdef PORTWIN
	MarkTabMenu(TabShow);
#endif
	ForceDisplay();
	return(0);
}

LONG
set_ynk(VOID)
{
	WORD new = 17 - WhichYank;
	if ( cbuf == textbuffer[new] ) return((LONG)new);
	WhichYank = new;
	return(0);
}

LONG
set_auu(VOID)
{
	cbuf->outputmode = UNIXMODE;
	return(0);
}

LONG
tog_au(VOID)
{
	if ( --cbuf->outputmode < 0 ) cbuf->outputmode += 4;
	return(0);
}

LONG
tog_ua(VOID)
{
	cbuf->outputmode = ( cbuf->outputmode + 1 ) % 4;
	return(0);
}

LONG
set_ioi(VOID)
{
	BUFFER b = commandmode ? commandbuffer: cbuf;
#ifdef PORTWIN
	WORD old = b->iomode;
	b->iomode = INSERTMODE;
	if ( b->iomode != old ) IOSettings(b);
#else
	b->iomode = INSERTMODE;
#endif
	return(0);
}

LONG
set_ioo(VOID)
{
	BUFFER b = commandmode ? commandbuffer: cbuf;
#ifdef PORTWIN
	WORD old = b->iomode;
	b->iomode = OVERSTRIKEMODE;
	if ( b->iomode != old ) IOSettings(b);
#else
	b->iomode = OVERSTRIKEMODE;
#endif
	return(0);
}

LONG
tog_io(VOID)
{
	BUFFER b;
	if ( commandmode ) b = commandbuffer;
	else			   b = cbuf;
	b->iomode ^= 1;
	return(0);
}

LONG
set_prn(VOID)
{
	cbuf->outputmode = PRINTMODE;
	return(0);
}

LONG
set_aua(VOID)
{
	cbuf->outputmode = ATARIMODE;
	return(0);
}

LONG
set_sns(VOID)
{
#ifdef PORTWIN
	BUFFER b = cbuf;
	WORD old = b->sensitivity;
	b->sensitivity = SENSITIVE;
	if ( b->sensitivity != old ) IOSettings(b);
#else
	cbuf->sensitivity = SENSITIVE;
#endif
	return(0);
}

LONG
tog_ns(VOID)
{
	cbuf->sensitivity ^= 1;
	return(0);
}

LONG
set_sdr(VOID)
{
	if ( ++cbuf->direction > 2 ) cbuf->direction = -2;
#ifdef PORTWIN
	IOSettings(cbuf);
#endif
	return(0);
}

LONG
togcol(VOID)
{
	dbufFer.color ^= 1;
	PScolor();
	return(0);
}

LONG
set_snn(VOID)
{
#ifdef PORTWIN
	BUFFER b = cbuf;
	WORD old = b->sensitivity;
	b->sensitivity = NOTSENSITIVE;
	if ( b->sensitivity != old ) IOSettings(b);
#else
	cbuf->sensitivity = NOTSENSITIVE;
#endif
	return(0);
}

LONG
setview(VOID)
{
	cbuf->backupmode = VIEWONLY;
	return(0);
}

LONG
setback(VOID)
{
	if ( cbuf->backupmode != VIEWONLY ) {
		if ( ++cbuf->backupmode > NOBACKUP ) cbuf->backupmode = VISIBLEBACKUP;
	}
	return(0);
}

LONG
unsetv(VOID)
{
	if ( cbuf->backupmode == VIEWONLY ) {
		cbuf->backupmode = dbufFer.backupmode;
	}
	return(0);
}

LONG
GotoBuffer(WORD new)
{
	WORD old = 0;
#ifdef PORTWIN
	WORD windowchange;
	if ( commandmode ) return(-1);
	windowchange = DoNewWindow(new);
	TextScreen->bufnum = new;
#else
	if ( commandmode ) return(-1);
	if ( ActiveScreen ) {
		if ( ActiveScreen == 1 && TScreen[1].bufnum == new ) {
			ActiveScreen = 2;
			TextScreen = TScreen + 1;
		}
		else if ( ActiveScreen == 2 && TScreen[0].bufnum == new ) {
			ActiveScreen = 1;
			TextScreen = TScreen;
		}
		else {
			if ( ActiveScreen == 1 ) TScreen[0].bufnum = new;
			else TScreen[1].bufnum = new;
		}
	}
#endif
	old = cbuf->bufnum;
	cbuf = textbuffer[new];
	if ( ( cbuf->first == (LINE)cbuf ) && ( *cbuf->name == '\0' ) )
		inibuf(new);
	if ( new == WhichYank ) WhichYank = 17 - WhichYank;
	else if ( ( old == 8 ) || ( old == 9 ) ) WhichYank = old;
#ifdef PORTWIN
	ToTitle((BYTE *)(cbuf->name));
	IOSettings(cbuf);
	if ( windowchange ) UpdateDisplay();
	else
#endif
		ForceDisplay();
	oldbuffer = -1;
#ifndef PORTWIN
	if ( ActiveScreen ) RedefScroll();
#endif
	return(0);
}
#ifndef DEMO

LONG
alt1(VOID)
{
	return(GotoBuffer(0));
}

LONG
alt2(VOID)
{
	return(GotoBuffer(1));
}

LONG
alt3(VOID)
{
	return(GotoBuffer(2));
}

LONG
alt4(VOID)
{
	return(GotoBuffer(3));
}

LONG
alt5(VOID)
{
	return(GotoBuffer(4));
}

LONG
alt6(VOID)
{
	return(GotoBuffer(5));
}

LONG
alt7(VOID)
{
	return(GotoBuffer(6));
}

LONG
alt8(VOID)
{
	return(GotoBuffer(7));
}

LONG
alt9(VOID)
{
	return(GotoBuffer(8));
}

LONG
alt0(VOID)
{
	return(GotoBuffer(9));
}

LONG
control(WORD number)
{
	WORD n, m = 0;
	if ( learning ) {
		if ( learning & ( 0xFFF ^ ( 0xFFF << number ) ) ) {
			MesnOut(2); /* "Higher buffer called from a lower one!" */
			return(-1);
		}
		if ( learning & ( 1 << number ) ) {
			learning ^= 1 << number;
			n = --(dbufFer.InLearnBuffer[number]);
			if ( n == 1 ) m = 1;
			MesPrint(14,n,plural+m,number+1); /* "%d character%s in learnbuffer %d" */
			return(0);
		}
	}
	if ( dbufFer.InLearnBuffer[number] ) {
		LearnReplay |= 1 << number;
		NumLearnBuffer[number] = 0;
	}
	return(0);
}

LONG
ctrl1(VOID)
{
	return(control(0));
}

LONG
ctrl2(VOID)
{
	return(control(1));
}

LONG
ctrl3(VOID)
{
	return(control(2));
}

LONG
ctrl4(VOID)
{
	return(control(3));
}

LONG
ctrl5(VOID)
{
	return(control(4));
}

LONG
ctrl6(VOID)
{
	return(control(5));
}

LONG
ctrl7(VOID)
{
	return(control(6));
}

LONG
ctrl8(VOID)
{
	return(control(7));
}

LONG
ctrl9(VOID)
{
	return(control(8));
}

LONG
ctrl0(VOID)
{
	return(control(9));
}
#endif

LONG
unknown(VOID)
{
	MesnOut(3); /* "Key not active" */
	return(-1L);
}

LONG
unknown2(UBYTE *s,WORD n)
{
	UBYTE c;
	c = *s; *s = 0;
	if ( n >= 0 ) s--;
	MesPrint(15,s); /* "Unknown command %s" */
	if ( n >= 0 ) s++;
	*s = c;
	return(-1L);
}

LONG
deadzone(VOID)
{
	return(0L);
}

LONG
ScreenU(UBYTE *s,WORD n)
{
	if ( n >= 0 && *s == '-' ) redraw = 1;
	else {
		redraw = 0;
		ForceDisplay();
	}
	return(0L);
}

LONG
creturn(VOID)
{
	return(newline(CARRETURN));
}

LONG
lfeed(VOID)
{
	return(newline(NEWLINE));
}

/*
  	#] Settings :
  	#[ Command :
 		#[ Comments :

		Control comes here after the carriage return that finishes
		a command. This routine makes the distribution over the various
		other routines and sets the appropriate flags.

		Still to be added for a mainframe version:
		: as an alternative for the alt-key ( for most settings ).
		Commands for Read, Write, Yank, Copy, Paste/Insert and the mark.
		Also the Undo and help and insert should find a solution. This
		would however destroy much of the elegance.

 		#] Comments :
 		#[ ~ commands :

*/
#ifndef DEMO

LONG
Alttw(UBYTE *s,WORD n)
{
	UBYTE c;
	c = *s++;
	n--;
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	if ( ( c >= '1' ) && ( c <= '9' ) ) return(GotoBuffer((WORD)(c-'1')));
	else if ( c == '0' ) return(GotoBuffer(9));
	c = ToUpper[c];
	if ( c >= 'A' && c <= 'Z' ) return((*alts[c-'0'])());
	else if ( c == '=' || c == ')' || c == '\'' ) return(haakje());
	return(unknown());
}

/*
 		#] ~ commands :
 		#[ ^ commands :

*/

LONG
CtrlC(UBYTE *s,WORD n)
{
	UBYTE c;
	c = *s++;
	n--;
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	if ( c >= '1' && c <= '9' ) return(control( (WORD)(c - '1') ));
	else if ( c == '0' ) return(control(9));
	c = ToUpper[c];
	if ( c >= 'A' && c <= 'Z' && c != 'R' ) return((*ctrls[c-'-'])());
	return(unknown());
}

/*
 		#] ^ commands :
 		#[ word commands :

		Protected words for special commands:

*/

SPECS comwords[] = {
	 {"after"		,append}
	,{"alt"			,0}
	,{"backspace"    ,backspace}
	,{"bcopy"		,kcopy}
	,{"bcut"		,kcut}
	,{"bpaste"		,kpaste}
	,{"clear"		,empty}
	,{"copy"		,copy}
	,{"ctrl"		,0}
	,{"ctrl-down"	,ctrdo}
	,{"ctrl-home"	,cthome}
	,{"ctrl-left"	,cl_arr}
	,{"ctrl-right"	,cr_arr}
	,{"ctrl-up"		,ctrup}
	,{"cut"			,cut}
	,{"delete"      ,delete}
	,{"deleteline"  ,Ldelete}
	,{"delmark"		,remomk}
	,{"down"        ,d_arrow}
	,{"end"         ,sh_hom}
	,{"exchange"	,exgmrk}
	,{"first"		,0}
	,{"garbage"     ,garb}
	,{"gotomark"	,gotomk}
	,{"home"        ,clrhom}
	,{"insert"      ,insert}
	,{"left"        ,l_arrow}
	,{"mark"		,setmrk}
	,{"message"		,0}
	,{"next"        ,shctri}
	,{"paste"		,paste}
	,{"pause"		,0}
	,{"previous"    ,shctle}
	,{"quit"		,klaar}
	,{"right"       ,r_arrow}
	,{"save"		,save}
	,{"savequit"	,savek}
	,{"set"			,0}
	,{"sh-ctrl-home",ctlhom}
	,{"sh-home"     ,sh_hom}
	,{"sh-insert"	,append}
	,{"sh-left"     ,sl_arr}
	,{"sh-right"    ,sr_arr}
	,{"show"		,0}
	,{"up"          ,u_arrow}
	};

SPECS *
SpecKey(UBYTE *s,WORD n)
{
	UBYTE *ss, c;
	WORD m, mbottom, mtop, i;
	ss = s;
	while ( n > 0 && *ss != ' ' &&
			( *ss != '-' || ( n > 2 && ToLower[ss[1]] >= 'a'
			&& ToLower[ss[1]] <= 'z' ) ) ) { n--; ss++; }
	c = *ss; *ss = '\0';
	mbottom = 0;
	mtop = TABLESIZE(comwords,SPECS) - 1;

	for(;;) {
		m = (mtop + mbottom)/2;
		if ( ( i = StrCmp((UBYTE *)(comwords[m].key),s) ) == 0 ) {
			*ss = c;
			SKIPTBLANKS(ss,n)
			WordContinue = ss;
			WordCn = n;
			return(comwords+m);
		}
		if ( i > 0 )	mtop = m - 1;
		else			mbottom = m + 1;
		if ( mtop < mbottom ) {
			*ss = c;
			return(0);
		}
	}
}

#endif

/*
 		#] word commands :
 		#[ Command line commands :
*/

PfunLoP ComJump[] = {
#ifdef DEMO
		 unknown2
		,unknown2
#else
		 xtern			/* ! */
		,Istring		/* " */
#endif
		,unknown2		/* # */
		,unknown2		/* $ */
		,unknown2		/* % */
		,unknown2		/* & */
		,FindBuffer		/* ' */
		,unknown2		/* ( */
		,unknown2		/* ) */
		,unknown2		/* * */
#ifdef DEMO
		,unknown2
#else
		,MovePlus		/* + */
#endif
		,MoveColumn		/* , */
#ifdef DEMO
		,unknown2
#else
		,MoveMin		/* - */
#endif
		,unknown2		/* . */
		,Search			/* / */
		,MoveCursor		/* 0 */
		,MoveCursor		/* 1 */
		,MoveCursor		/* 2 */
		,MoveCursor		/* 3 */
		,MoveCursor		/* 4 */
		,MoveCursor		/* 5 */
		,MoveCursor		/* 6 */
		,MoveCursor		/* 7 */
		,MoveCursor		/* 8 */
		,MoveCursor		/* 9 */
		,MakeKey		/* : */
		,unknown2		/* ; */
#ifdef DEMO
		,unknown2
		,Freplace		/* = */
		,unknown2
		,unknown2
		,unknown2		/* @ */
		,unknown2
#else
		,PutTag			/* < */
		,Freplace		/* = */
		,GotoTag		/* > */
		,DiskFree		/* ? */
		,unknown2		/* @ */
		,AutoIndent		/* A */
#endif
		,unknown2		/* B */
#ifdef IBM
		,SetColor		/* C */
#else
		,unknown2		/* C */
#endif
		,Dfaults		/* D */
		,unknown2		/* E */
#ifdef DEMO
		,unknown2
#else
		,FlipSet		/* F */
#endif
		,unknown2		/* G */
		,unknown2		/* H */
#ifdef DEMO
		,unknown2
		,unknown2		/* J */
		,unknown2
		,unknown2
#else
		,Input			/* I */
		,unknown2		/* J */
		,KeyDefRead		/* K */
		,StartLearn		/* L */
#endif
#ifndef DEMO
		,MakeMacro		/* M */
#else
		,unknown2		/* M */
#endif
		,unknown2		/* N */
#ifdef DEMO
		,unknown2
		,unknown2
#else
		,Order			/* O */
		,Print			/* P */
#endif
		,Quit			/* Q */
		,ReadC			/* R */
		,SaveS			/* S */
		,Tab			/* T */
		,ScreenU		/* U */
		,unknown2		/* V */
#ifdef DEMO
		,unknown2
#else
		,WordWrap		/* W */
#endif
#ifndef DEMO
		,DoMacro
#else
		,unknown2		/* X */
#endif
		,unknown2		/* Y */
		,unknown2		/* Z */
		,COpenFold		/* [ */
		,unknown2		/* \ */
		,CCloseFold		/* ] */
#ifdef DEMO
		,unknown2
#else
		,CtrlC			/* ^ */
#endif
};

LONG
Command(UBYTE *s,WORD n)
{
	UBYTE c;
	SPECS *p;
	commandmode = 0;
	SKIPBLANKS(s,n);
	if ( n <= 0 ) return(0L);
	if ( ( p = SpecKey(s,n) ) != 0 ) {
		if ( p->fun == 0 ) {		/* The set command */
			c = ToLower[*s];
			if ( c == 'a' ) {
				return(Alttw(s+4,n-4));
			}
			if ( c == 'c' ) {
				return(CtrlC(s+5,n-5));
			}
			if ( c == 'f' ) {
				return(GetFirst(s+6,n-6));
			}
			if ( c == 'm' ) {
				s += 7; n-= 7;
				SKIPTBLANKS(s,n);
				c = s[n]; s[n] = 0;
				MesOut((BYTE *)s);
				s[n] = c;
				return(0);
			}
			if ( c == 'p' ) {
				return(Pause(s+6,n-6));
			}
			if ( ToLower[s[1]] == 'h' ) {
				return(ShowVariable(s+5,n-5));
			}
			return((LONG)(Compute(commandbuffer->current)));
		}
		return((*(p->fun))());
	}
	n--;
	c = ToUpper[*s++];
	if ( c <= '9' && c >= '0' ) { s--; n++; }
	else if ( c == 'W' ) {
		if ( n > 0 && ( *s == 'w' || *s == 'W' ) ) {
			s++; n--;
		}
		else return(WriteC(s,n,1));
	}
	else if ( c == '=' && ( n <= 0 || *s != '/' ) )
#ifdef DEMO
		return(Syntax());
#else
		return(Where());
#endif
	if ( c != '"' && c != 'W' && c != 'R' && c != '/' ) {
		SKIPTBLANKS(s,n);
	}
#ifndef DEMO
	if ( c == '~' ) return(Alttw(s,n));
#endif
	c -= '!';
	if ( c < ( TABLESIZE(ComJump,PfunLoP) ) ) return((*ComJump[c])(s,n));
	return(Syntax());
}

/*
 		#] Command line commands :
 		#[ Repeat :
*/

LONG
repeat(VOID)
{
	BUFFER b = commandbuffer;
	if ( b->totline <= 0 ) return(0L);
	return(DoCommand(b->first,(LINE)b));
}

/*

LONG
repeat2(VOID)
{
	BUFFER b = commandbuffer;
	if ( b->totline <= 1 ) return(0L);
	return(DoCommand(b->first->next,(LINE)b));
}
*/

/*
 		#] Repeat :
 		#[ Direct Channel :			LONG ForCommand(n)

		This routine provides the keyredefinitions with a direct
		channel to the command line. It won't enter in the command
		history and neither will it affect the screen while the
		characters come trickling in. This should be very useful
		for making composite commands that are bound to keys.
*/

LONG
ForCommand(WORD n)
{
	UBYTE *s;
	LINE line, oldcurrent;
	LONG retcode;
	if ( n > MacroReplay ) return(-1);
	n--;
	oldcurrent = commandbuffer->current;
	if ( ( line = LineAlloc(n,commandbuffer->last) ) == 0 ) return(-1);
	s = line->text;
	while ( --n >= 0 ) {
		retcode = GetMacro();
		*s++ = (UBYTE)retcode;
		if ( learning ) LearnEnter ( retcode );
	}
	if ( learning ) LearnEnter ( 0x1019 );
	if ( GetMacro() != 0x1E00 ) {
		retcode = -1;
	}
	else {
		commandbuffer->current = line;
		retcode = DoCommand(line,(LINE)commandbuffer);
		commandbuffer->current = oldcurrent;
	}
	LineDealloc(commandbuffer->last);
	return(retcode);
}

/*
 		#] Direct Channel :
 		#[ MakeKey :				LONG MakeKey(s,n)
*/
 
LONG
MakeKey(UBYTE *s,WORD n)
{
	ULONG x = 0;
	UBYTE c;
	SKIPTBLANKS(s,n);
	while ( n > 0 ) {
		if ( *s <= '9' && *s >= '0' ) {
			c = *s++ - '0';
		}
		else {
			c = ToLower[*s];
			if ( c >= 'a' && c <= 'f' ) {
				c -= 'a' - 10;
			}
			else break;
		}
		x = (x<<4) + c;
		n--;
	}
	return(Jump(x));
}

/*
 		#] MakeKey :
  	#] Command :
*/

