/*
  	#[ Include file :
*/
#ifndef DEMO
#include "stedi.h"
#ifdef LINUX
#include <unistd.h>
#endif

#define WHILE 0
#define IF 1

#define LOCALMODE 0
#define GLOBALMODE 1

#define NOOPERATION 0
#define LOGNOT 1
#define STRLEN 2
#define MULTIPLICATION 3
#define QUOTIENT 4
#define REMAINDER 5
#define ADDITION 6
#define SUBTRACTION 7
#define CONCATENATION 8
#define LOGNOTEQUAL 9
#define LOGEQUAL 10
#define LOGGT 11
#define LOGLT 12
#define LOGGE 13
#define LOGLE 14
#define LOGLEXGT 15
#define LOGLEXLT 16
#define LOGLEXGE 17
#define LOGLEXLE 18
#define LOGAND 19
#define LOGOR 20
#define STRTAKELEFT 21
#define STRTAKERIGHT 22
#define STRCLIPLEFT 23
#define STRCLIPRIGHT 24
#define STRMAKELEFT 25
#define STRMAKERIGHT 26
#define TOUPPER 27
#define TOLOWER 28
#ifdef WITHHEX
#define DECTOHEX 29
#define HEXTODEC 30
#endif
 
static WORD OpTable[] = {	/* The hierarchy of the operations */
	(short)20,(short)1,(short)1,(short)2,(short)2,
	(short)2,(short)3,(short)3,(short)6,(short)7,
	(short)7,(short)7,(short)7,(short)7,(short)7,
	(short)8,(short)8,(short)8,(short)8,(short)9,
	(short)10,(short)5,(short)5,(short)5,(short)5,
	(short)5,(short)5,(short)1,(short)1
#ifdef WITHHEX
	,(short)1,(short)1
#endif
};

UBYTE varbuffer[MAXVARS], *buftop, *inbuf;
UBYTE scrap[SCRAPSIZE];

typedef struct var_store {
	struct tline *next;
	struct tline *prev;
	WORD totlen;
	WORD used;
	WORD namesize;
	UBYTE name[2];
} *VARSTORE;

/*
	Note: the next defines must run parallel with the names in Protected
*/

#define V_AUTOCLOSE 0
#define V_BACKUP 1
#define V_BIOS 2
#define V_BUFFER 3
#define V_BYTE 4
#define V_CHAR 5
#define V_COLOR 6
#define V_COLUMN 7
#define V_CWD 8
#define V_DATE 9
#define V_DIRECTION 10
#define V_DIRTY 11
#define V_FILENAME 12
#define V_FOLD 13
#define V_FULLNAME 14
#define V_HSTEP 15
#define V_IOMODE 16
#define V_ISFOLD 17
#define V_ISMARK 18
#define V_KEY 19
#define V_LASTMESS 20
#define V_LINE 21
#define V_LINECHARS 22
#define V_MAXCOLUMN 23
#define V_MAXHIST 24
#define V_MENUNOTSPACED 25
#define V_MSTEP 26
#define V_MVERSION 27
#define V_NEXTATT 28
#define V_NEXTDATE 29
#define V_NEXTFILE 30
#define V_NEXTFNAME 31
#define V_NEXTNAME 32
#define V_NEXTSIZE 33
#define V_NUMBERING 34
#define V_NUMCHAR 35
#define V_PAGEDELAY 36
#define V_RANGE 37
#define V_RETURNCODE 38
#define V_SCREENLINE 39
#define V_SMODE 40
#define V_SHELL 41
#define V_TOTLINES 42
#define V_VALUE 43
#define V_WAITFLAG 44
#define V_WORD 45
#define V_WORDWRAP 46
#define V_WRITEMODE 47
#define V_WWORD 48
#define V_YANKBUF 49

BYTE *Protected[] = {
	 "autoclose"
	,"backup"
	,"bios"
	,"buffer"
	,"byte"
	,"char"
	,"color"
	,"column"
	,"cwd"
	,"date"
	,"direction"
	,"dirty"
	,"filename"
	,"fold"
	,"fullname"
	,"hstep"
	,"insertmode"
	,"isfold"
	,"ismark"
	,"key"
	,"lastmess"
	,"line"
	,"linechars"
	,"maxcol"
	,"maxhist"
	,"menuspaced"
	,"mstep"
	,"mversion"
	,"nextatt"
	,"nextdate"
	,"nextfile"
	,"nextfname"
	,"nextname"
	,"nextsize"
	,"numbers"
	,"numchar"
	,"pagedelay"
	,"range"
	,"returncode"
	,"screenline"
	,"searchmode"
	,"shell"
	,"totlines"
	,"value"
	,"waitflag"
	,"word"
	,"wordwrap"
	,"writemode"
	,"wword"
	,"yankbuf"
};

BYTE ProtSize[] = {
	  9, 6, 4, 6, 4, 4, 5, 6, 3, 4
	, 9, 5, 8, 4, 8, 5,10, 6, 6, 3
	, 8, 4, 9, 6, 7,10, 5, 8, 7, 8
	, 8, 9, 8, 8, 7, 7, 9, 5,10,10
	,10, 5, 8, 5, 8, 4, 8, 9, 5, 7 };

extern UBYTE OUchars[];
extern UBYTE VBchars[];
extern LONG ReturnValue;
extern WORD UseAmper;
extern WORD VarsUsed;

static UBYTE *macpath = 0;

static UBYTE *fullsearch;
static UBYTE *fullsearchend;

static WORD IsRetCode = 0;

UBYTE *WordContinue;
WORD WordCn;

BYTE *MacroText;
WORD MacroTnum;

#ifdef ANSI
static LONG ViewMacros(UBYTE *,WORD);
#else
static LONG ViewMacros();
#endif

static struct onerror1 {
	struct tline l;
	BYTE more[16];
} OnError = {
	{0, 0, 32, 24, {'g', 'o', 't', 'o'}}, {' ', 'o','n','e','r','r','o','r',
	0, 0, 0, 0, 0, 0, 0, 0}
};

/*
	The next typedef and array are purely for the use of the @ variables
*/

typedef struct v_usage {
	LINE startline;
	LINE endline;
	BYTE *startchar;
	BYTE *endchar;
	WORD used;
	WORD claimed;
} V_USAGE;

extern V_USAGE VarUsage[];

/*
  	#] Include file :
  	#[ Macros :
 		#[ Remarks :

		The memory arrangements rely on the lines mechanism.
		variables are stored in the variables buffer.
		A line is put together

		The local variables of a macro and its parameters are
		separated by blank lines. Popping means the release of lines
		till the next blank line is encountered.

		Layout in line:
			next
			prev
			totlen
			used
			namesize
			name
			contents

 		#] Remarks :
 		#[ PopVarStack :		VOID PopVarStack()
*/

VOID
PopVarStack(VOID)
{
	WORD n;
	BUFFER b = varbuf;
	while ( b->last != (LINE)b ) {
		n = b->last->used - LINEHEAD;
		LineDealloc(b->last);
		if ( n <= 0 ) return;
	}
}

/*
 		#] PopVarStack :
 		#[ EnterVar :			WORD EnterVar(name,namesize,contents,size,mode)

		Puts the variable in the buffers.
		Possible actions are:
		1:	New variable:	put on top
		2:	Redefinition of a local variable
		3:	Redefinition of a more global variable

		mode indicates whether a variable may be looked at as global
		if such is needed.
*/

WORD
EnterVar(UBYTE *name,WORD namesize,UBYTE *contents,LONG size,WORD mode)
{
	BUFFER b = varbuf;
	VARSTORE v;
	UBYTE *s, *t;
	WORD n, ntop, nbottom, i;
#ifdef WITHMOUSE
	if ( *name <= '9' && *name >= '0' ) {
		n = *name++ - '0';
		while ( --namesize > 0 ) { n = 10*n + *name++ - '0'; }
#ifdef PORTWIN
		if ( n > 10 || n <= 0 ) return(0);
		n--;
		if ( size >= MAXNAMEMENU ) size = MAXNAMEMENU - 1;
		s = contents;
		t = dbufFer.menu + n*MAXNAMEMENU;;
		while ( --size >= 0 ) *t++ = *s++;
		*t = 0;
#else
		if ( size >= 1 ) {
			n = (n-1)<<1;
			dbufFer.menu[n] = *contents;
			if ( size > 1 ) dbufFer.menu[n+1] = contents[1];
		}
#endif
		return(0);
	}
#endif
ReDoSearch:
	v = (VARSTORE)(b->last);
	while ( v != (VARSTORE)b ) {
		if ( v->used == LINEHEAD ) {
			if ( mode == LOCALMODE ) break;
		}
		else if ( namesize == v->namesize
		&& strNcmp(name,v->name,namesize) == 0 ) {
			if ( size <= ( v->totlen - LINEHEAD - sizeof(WORD) - namesize) ) {
				s = v->name + v->namesize;
				t = contents;
				while ( --size >= 0 ) *s++ = *t++;
				v->used = (WORD)(s - (UBYTE *)v);
				return(0);
			}
			else {
				v = (VARSTORE)LineAlloc((WORD)(size+namesize+sizeof(WORD)),(LINE)v);
				if ( v == 0 ) return(-1);
				LineDealloc(v->prev);
				goto DoVar;
			}
		}
		v = (VARSTORE)(v->prev);
	}
/*
	Test first for one of the special settings
*/
	if ( *name == '<' && name[2] == '>' && namesize == 3 ) {
		if ( strNIcmp(contents,(UBYTE *)("ON"),(WORD)size) == 0 ) n = 1;
		else if ( strNIcmp(contents,(UBYTE *)("OFF"),(WORD)size) == 0 ) n = -1;
		else if ( strNIcmp(contents,(UBYTE *)("SINGLE"),(WORD)size) == 0 ) n = 0;
		else {
			MesnOut(36); /* "Value should be ON, OFF or SINGLE" */
			return(-1);
		}
		name++;
		dbufFer.wordtable[*name] = n;
		return(0);
	}
	nbottom = 0;
	ntop = TABLESIZE(Protected,UBYTE *)-1;
	for(;;) {
		n = (ntop + nbottom)>>1;
		if ( ( i = strNcmp((UBYTE *)(Protected[n]),name,(WORD)(ProtSize[n])) )
		 == 0 ) break;
		if ( i > 0 )	ntop = n - 1;
		else			nbottom = n + 1;
		if ( ntop < nbottom ) goto NewVar;
	}
	if ( n == V_MVERSION || n == V_MAXHIST ) {
		LONG num;
		if ( NumVal(contents,size,&num) ) goto expnum;
		if ( n == V_MVERSION ) dbufFer.menuversion = (WORD)num;
		else dbufFer.maxhist = (WORD)num;
		return(0);
	}
	if ( n == V_BIOS || n == V_AUTOCLOSE || n == V_NUMBERING
	 || n == V_WAITFLAG || n == V_MENUNOTSPACED
	 || n == V_DIRTY || n == V_COLOR ) {
		WORD num;
		if ( size == 0 || strNIcmp(contents,(UBYTE *)("ON"),(WORD)size) == 0 ) num = 1;
		else if ( strNIcmp(contents,(UBYTE *)("OFF"),(WORD)size) == 0 ) num = 0;
		else {
			MesnOut(37); /* "Value should be ON or OFF" */
			return(-1);
		}
		if ( n == V_BIOS ) dbufFer.DoBIOS = num;
		else if ( n == V_AUTOCLOSE ) dbufFer.autoclose = num;
		else if ( n == V_WAITFLAG ) dbufFer.waitflag = num;
		else if ( n == V_MENUNOTSPACED ) dbufFer.menunotspaced = num ^ 1;
		else if ( n == V_DIRTY ) cbuf->dirtyflag = num;
		else if ( n == V_COLOR ) {
			if ( num != dbufFer.color ) {
				dbufFer.color = num;
				PScolor();
			}
		}
		else dbufFer.lnumber = num;
		return(0);
	}
	if ( n == V_BACKUP ) {
		if ( size == 1 ) {
			if ( *contents == 'B' ) {
				cbuf->backupmode = 1;
				return(0);
			}
			else if ( *contents == 'b' ) {
				cbuf->backupmode = 2;
				return(0);
			}
			else if ( *contents == 'V' || *contents == 'v' ) {
				cbuf->backupmode = 0;
				return(0);
			}
			else if ( *contents == '!' ) {
				cbuf->backupmode = 3;
				return(0);
			}
		}
		MesIll(114);	/* "Illegal backup mode" */
		return(-1);
	}
	if ( n == V_RETURNCODE ) {
		if ( IsRetCode ) {
			mode = GLOBALMODE;
			goto ReDoSearch;
		}
		v = (VARSTORE)LineAlloc((WORD)(size+namesize+sizeof(WORD)),(LINE)b);
		if ( v == 0 ) return(-1);
		IsRetCode = 1;
		goto DoVar;
	}
	if ( n == V_MSTEP || n == V_HSTEP || n == V_PAGEDELAY ) {
		LONG num;
		if ( NumVal(contents,size,&num) ) {
expnum:
			MesnOut(38); /* "numerical value expected." */
			return(-1);
		}
		if ( n == V_PAGEDELAY ) dbufFer.PageWait = (WORD)num;
		else if ( n == V_HSTEP ) {
			ColumnStep = ( (WORD)num > TextScreen->wi ) ? TextScreen->wi: (WORD)num;
		}
		else {
			cColumnStep = ( (WORD)num > Mes2Screen.wi ) ? Mes2Screen.wi: (WORD)num;
		}
		return(0);

	}

NewVar:
	v = (VARSTORE)LineAlloc((WORD)(size+namesize+sizeof(WORD)),b->last);
	if ( v == 0 ) return(-1);
DoVar:
	v->namesize = namesize;
	s = v->name; t = name;
	while ( --namesize >= 0 ) *s++ = *t++;
	t = contents;
	while ( --size >= 0 ) *s++ = *t++;
	return(0);
}

/*
 		#] EnterVar :
 		#[ FindVar :			UBYTE *FindVar(name,n,size)
*/

static BYTE *mdirchars[5] = { "<", "<<", "0", ">>", ">" };
static BYTE backchars[12] = { 'w','-','-','h','-','s','-','v','-','d','-','a'};
 
UBYTE *
FindVar(UBYTE *name,WORD n,WORD *size)
{
	VARSTORE v;
	BUFFER b = varbuf, cb;
	UBYTE *s = 0, *t;
	WORD nmid, ntop, nbottom, i;
	LONG nn;
	cb = cbuf;
	v = (VARSTORE)(b->last);
	if ( n == 1 && *name <= '9' && *name >= '0' ) {	/* Find argument */
		while ( v->used > LINEHEAD ) {
			if ( v->namesize == 1 && v->name[0] == *name ) {
				*size = v->used - LINEHEAD - (WORD)(sizeof(WORD)) - 1;
				return(v->name+v->namesize);
			}
			v = (VARSTORE)(v->prev);
		}
		*size = 0;
		return(scrap);
	}
/*
	The next class of variables can be used only after a successful
	search with a regular expression. The only statements that can
	be inbetween are set commands and flow control commands
*/
	if ( n == 2 && *name == '@' ) {
		LINE l, l1, l2;
		UBYTE *u = 0;
		if ( name[1] <= '9' && name[1] >= '0' ) i = name[1] - '0';
		else if ( name[1] == '&' ) i = 10;
		else return(0);
		if ( !UseAmper ) return(0);
		if ( i < 10 && ( ( 1 << i ) & VarsUsed ) == 0 ) return(0);
		l = l1 = VarUsage[i].startline;
		l2 = VarUsage[i].endline;
		t = scrap;
		nmid = 0;
		for (;;) {
			if ( l->used < 0 ) {
				s = ((FOLDLINE)l)->text;
				u = s + ((FOLDLINE)l)->used;
			}
			if ( l == l1 ) s = (UBYTE *)VarUsage[i].startchar;
			if ( l == l2 ) u = (UBYTE *)VarUsage[i].endchar;
			while ( s < u && nmid < SCRAPSIZE ) { *t++ = *s++; nmid++; }
			if ( l == l2 ) break;
			l = l->next;
			if ( cb->outputmode != RAWMODE ) {
				if ( nmid < SCRAPSIZE - 2 ) {
					nmid += 2;
					*t++ = '\\'; *t++ = 'n';
				}
			}
		}
		*size = nmid;
		return(scrap);
	}
	while ( v != (VARSTORE)b ) {
		if ( v->namesize == n && strNcmp(v->name,name,n) == 0 ) {
			*size = v->used - LINEHEAD - (WORD)(sizeof(WORD)) - n;
			return(v->name+n);
		}
		v = (VARSTORE)(v->prev);
	}
/*
	Not a user defined name. Try a systems name.
*/
	if ( *name == '<' && name[2] == '>' && n == 3 ) {
		name++;
		s = scrap;
		if ( (BYTE)(dbufFer.wordtable[*name]) > 0 ) {
			*s++ = 'O', *s++ = 'N'; *size = 2;
		}
		else if ( dbufFer.wordtable[*name] == 0 ) {
			*s++ = 'S'; *s++ = 'I'; *s++ = 'N';
			*s++ = 'G'; *s++ = 'L'; *s++ = 'E'; *size = 6;
		}
		else {
			*s++ = 'O'; *s++ = 'F'; *s++ = 'F'; *size = 3;
		}
		return(scrap);
	}
	nbottom = 0;
	ntop = TABLESIZE(Protected,UBYTE *)-1;

	for(;;) {
		nmid = (ntop + nbottom)>>1;
		if ( ( i = strNcmp((UBYTE *)(Protected[nmid]),name,
/*		(WORD)(ProtSize[nmid])) ) == 0 ) */
		n) ) == 0 )
		{
			i = (WORD)(ProtSize[nmid]) - n;
			if ( i == 0 ) break;
		}
		if ( i > 0 )	ntop = nmid - 1;
		else			nbottom = nmid + 1;
		if ( ntop < nbottom ) {
/*
			Last attempt. Try the environment
*/
			UBYTE c;
			*size = 0;
			t = name + n; 
			c = *t; *t = 0;
			s = (UBYTE *)(MYGETENV((BYTE *)name));
			*t = c;
			if ( s ) {
				t = s; n = 0;
				while ( *t ) { t++; n++; }
				*size = n;
			}
			return(s);
		}
	}
	*size = 1;
	switch ( nmid ) {
		case V_BYTE:
			nn = CountBytes(cb->first,cb->current);
			goto AddChar;
		case V_COLUMN:
			nn = cb->column;
DoOneNum:
			t = inbuf;
			NumToStr(nn);
			*size = n = (WORD)(inbuf - t);
			inbuf = t;
			s = scrap;
			while ( --n >= 0 ) *s++ = *t++;
			return(scrap);
		case V_LINE:
			nn = cb->newline;
			goto DoOneNum;
		case V_TOTLINES:
			nn = cb->totline;
			goto DoOneNum;
		case V_CHAR:
		case V_NUMCHAR:
			nn = 0;
AddChar:
			{
				WORD type;
				FINDPOS fp;
				if ( cb->newvirt ) {
					*size = 0;
					return(scrap);
				}
				type = FindChar(cb->current,cb->column,&fp);
				if ( nmid == V_CHAR ) {
					if ( type == NORMALEOL || fp.virt ) {
						*size = 0;
					}
					else {
						scrap[0] = *(fp.address);
					}
					return(scrap);
				}
				if ( type != NORMALEOL && fp.virt == 0 ) fp.num--;
				nn += fp.num;
				goto DoOneNum;
			}
		case V_LINECHARS:
			if ( cb->current == (LINE)cb ) nn = 0;
			else if ( cb->current->used > 0 ) {
				nn = cb->current->used - LINEHEAD;
			}
			else {
				nn = ((FOLDLINE)(cb->current))->used - FOLDHEAD;
			}
			goto DoOneNum;
		case V_MAXCOLUMN:
			i = cb->current->used - LINEHEAD;
			if ( i < 0 ) i = ((FOLDLINE)(cb->current))->used - FOLDHEAD;
			if ( i == 0 ) nn = 1;
			else nn = FindColumn(cb->current,i) + 1;
			goto DoOneNum;
		case V_ISFOLD:
			scrap[0] = ( cb->current->used <= 0 ) ? '1': '0';
			return(scrap);
		case V_RANGE:
			{
				WORD type, charnum, marknum;
				FINDPOS fp;
				if ( cb->newvirt ) {
					*size = 0;
					return(scrap);
				}
				type = FindChar(cb->current,cb->column,&fp);
				charnum = fp.num;
				if ( type != NORMALEOL && fp.virt == 0 ) charnum--;
				type = FindChar(cb->current,cb->MarkColumn,&fp);
				marknum = fp.num;
				if ( type != NORMALEOL && fp.virt == 0 )
					marknum--;
				if ( marknum > charnum ) {
					type = marknum;
					marknum = charnum;
					charnum = type;
				}
				*size = charnum - marknum;
				return(cb->current->text+marknum);
			}
		case V_FOLD:
			{
				LINE a1,a2;
				if ( FindFold(&a1,&a2) ) {
					t = s = a1->text+5;
					while ( *s != ':' ) s++;
					*size = (WORD)(s - t);
					return(t);
				}
				else {
					*size = 0;
					return(scrap);
				}
			}
		case V_BUFFER:
			scrap[0] = cb->bufnum + '1';
			if ( scrap[0] > '9' ) scrap[0] = '0';
			return(scrap);
		case V_FILENAME:
			n = 0;
			s = cb->name;
			while ( *s ) { s++; n++; }
			*size = n;
			return(cb->name);
		case V_FULLNAME:
			n = 0;
			s = cb->fullname;
			while ( *s ) { s++; n++; }
			*size = n;
			return(cb->fullname);
		case V_DATE:
			*size = MakeDate(scrap);
			return(scrap);
		case V_IOMODE:
			scrap[0] = cb->iomode ? 'O': 'I';
			return(scrap);
		case V_SMODE:
			scrap[0] = cb->sensitivity ? 'S': 'N';
			return(scrap);
		case V_DIRECTION:
			i = cb->direction;
			if ( ( i & 1 ) != 0 ) *size = 2;
			return((UBYTE *)(mdirchars[i+2]));
		case V_YANKBUF:
			scrap[0] = (WhichYank == 8) ? 'Y': 'y';
			return(scrap);
		case V_MENUNOTSPACED:
			nn = dbufFer.menunotspaced ^ 1;
			goto OnOff;
		case V_LASTMESS:
			*size = InLastMess;
			return(LastMessage);
		case V_AUTOCLOSE:
			nn = dbufFer.autoclose;
			goto OnOff;
		case V_WAITFLAG:
			nn = dbufFer.waitflag;
			goto OnOff;
		case V_BIOS:
			nn = dbufFer.DoBIOS;
			goto OnOff;
		case V_ISMARK:
			if ( cb->mark == (LINE)cb ) nn = 0;
			else  nn = 1;
			goto OnOff;
		case V_NUMBERING:
			nn = dbufFer.lnumber;
OnOff:
			s = scrap;
			*s++ = 'O';
			if ( nn == 0 ) {
				*s++ = 'F'; *s = 'F';
				*size = 3;
			}
			else {
				*s = 'N';
				*size = 2;
			}
			return(scrap);
		case V_PAGEDELAY:
			nn = dbufFer.PageWait;
			goto DoOneNum;
		case V_NEXTATT:
			if ( dtaused && dtacont == 0 ) {
				nn = sdta->attribute;
				*size = i = 6;
				s = (UBYTE *)backchars;
				t = scrap+6;
				while ( --i >= 0 ) {
					*--t = (((WORD)nn) & 1 ) ? *++s : *s++;
					nn >>= 1;
					s++;
				}
				*size = 6;
			}
			else *size = 0;
			return(scrap);
		case V_NEXTDATE:
			if ( dtaused && dtacont == 0 ) {
				s = inbuf;
				if ( DoDate(sdta->date,sdta->time) == 0 ) {
					*size = (WORD)(inbuf - s);
					return(s);
				}
			}
			*size = 0;
			return(scrap);
		case V_NEXTFNAME:
			if ( fullsearch ) {
				*size = 0;
				if ( dtaused && dtacont == 0 ) {
					s = fullsearchend;
					t = sdta->name;
					nn = MAXFILENAME+2;
					while ( --nn >= 0 && ( *s++ = *t++ ) != 0 );
					*size = (WORD)(s-fullsearch) - 1;
				}
				return(fullsearch);
			}
		case V_NEXTNAME:
			*size = 0;
			if ( dtaused && dtacont == 0 ) {
				s = scrap;
				t = sdta->name;
				nn = MAXFILENAME+2;
				while ( --nn >= 0 && ( *s++ = *t++ ) != 0 ) (*size)++;
			}
			return(scrap);
		case V_NEXTSIZE:
			if ( dtaused && dtacont == 0 ) {
				nn = sdta->size;
				goto DoOneNum;
			}			/* Fall through is intended */
		case V_RETURNCODE:
			*size = 0;	/* If here, it hasn't been set yet */
			return(scrap);
		case V_NEXTFILE:
			*size = 0;
			if ( dtaused == 0 || dtacont < 0 ) {
				return(scrap);
			}
			if ( dtacont == 0 ) {
#ifdef ATARI
				SetNewDTA(sdta);
				if ( NextFile() < 0 ) {
					dtacont = -1;
					return(scrap);
				}
#endif
#ifdef IBM
				if ( NextFile(sdta) != 0 ) {
					dtacont = -1;
					return(scrap);
				}
#endif
#ifdef HELIOS
				if ( NextFile(sdta) != 0 ) {
					dtacont = -1;
					return(scrap);
				}
#endif
			}
			dtacont = 0;
			scrap[0] = '1';
			*size = 1;
			return(scrap);
		case V_HSTEP:
			nn = ColumnStep;
			goto DoOneNum;
		case V_MSTEP:
			nn = cColumnStep;
			goto DoOneNum;
		case V_WORDWRAP:
			nn = cb->wordwrap;
			if ( nn ) goto DoOneNum;
			*size = 0;
			return(scrap);
		case V_KEY:
			nn = KeyChar();
			*size = i = 8;
			while ( --i >= 0 ) {
				scrap[i] = hex[nn&0xF];
				nn >>= 4;
			}
			return(scrap);
		case V_MAXHIST:
			nn = dbufFer.maxhist;
			goto DoOneNum;
		case V_MVERSION:
			nn = dbufFer.menuversion;
			goto DoOneNum;
		case V_VALUE:
			nn = ReturnValue;
			goto DoOneNum;
		case V_WORD:
			{
				UBYTE *sss;
				*size = DetWor(&sss);
				if ( *size < 0 ) *size = 0;
				return(sss);
			}
		case V_WWORD:
			{
				FINDPOS fp;
				LINE l = cb->current;
				if ( cb->newvirt 
				|| FindChar(l,cb->column,&fp) != NORMALCHAR
				|| *(s = fp.address) == ' ' || *s == '\t' || *s == 0 ) {
					*size = 0;
					return(scrap);
				}
				if ( l->used < 0 ) {
					ntop = ((FOLDLINE)l)->used - FOLDHEAD;
					t = ((FOLDLINE)l)->text;
				}
				else {
					ntop = l->used;
					t = l->text;
				}
				while ( s >= t && *s != ' ' && *s != '\t' && *s ) s--;
				s++;
				i = 0;
				t += ntop;
				fp.address = s;
				while ( s < t && *s != ' ' && *s != '\t' && *s ) { i++; s++; }
				*size = i;
				return(fp.address);
			}
		case V_SCREENLINE:
			nn = cb->screenline;
			goto DoOneNum;
		case V_SHELL:
#ifdef ATARI
			{
#ifdef __TURBOC__
				if ( GetShell() ) nn = 1;
				else nn = 0;
#else
				LONG SaveValue;
				WFUN shell;
				SaveValue = Super(0L);
				shell = *((WFUN *)0x4F6);
				Super((PVOID)SaveValue);
				if ( shell ) nn = 1;
				else nn = 0;
#endif
			}
#else
#ifdef __WATCOMC__
			{
				BYTE *s;
				s = MYGETENV("COMSPEC");
				if ( s && *s ) nn = 1;
				nn = 0;
			}
#else
			nn = 1;
#endif
#endif
			goto OnOff;
		case V_COLOR:
			nn = dbufFer.color;
			goto OnOff;
		case V_DIRTY:
			nn = cb->dirtyflag;
			goto OnOff;
		case V_WRITEMODE:
			*scrap = OUchars[cb->outputmode];
			*size = 1;
			return(scrap);
		case V_BACKUP:
			*scrap = VBchars[cb->backupmode];
			if ( *scrap == GRAVECROSS ) *scrap = '!';
			*size = 1;
			return(scrap);
		case V_CWD:
			t = scrap;
#ifndef UNIX
			*t++ = 'A' + GetDrive();
			*t++ = ':';
#ifdef IBM
			*t++ = SEPARATOR;
#endif
#endif
#ifdef UNIX
			GetPath((BYTE *)t,SCRAPSIZE);
#else
			GetPath((BYTE *)t,0);		/* 0 = current drive */
#endif
			t = scrap;
			while ( *t++ );
			*size = (WORD)(t - scrap) - 1;
			return(scrap);
	}
	return(0);
}

/*
 		#] FindVar :
 		#[ DoMacro :			LONG DoMacro(s,n)

		The macro execution routine
		a:	1:	Look in macro buffer
			2:	Look in default buffer
			3:	Look in current directory
			4:	Look in default/macro directory
		b:	Find the file and open it.
		c:	call LoadMacro
		d:	read the parameters and prepare the stack frame.
		e:	call Xmacro
		f:	clean up
*/

LONG
DoMacro(UBYTE *s,WORD n)
{
	MACRO mac, m;
	LONG retval = 0;
	WORD handle = -1, i, namesize;
	UBYTE *t1, *t2, *name, parnum, c;
	VARSTORE v;
/*
	Find the name of the macro
*/
	if ( n <= 0 ) return(0);
	name = s;
	while ( n > 0 && *s != ' ' && *s != '\t' ) { n--; s++; }
	namesize = (WORD)(s - name);
/*
	Now look for it
*/
	if ( ( mac = FindMacro(name,namesize) ) == 0 ) {
		t1 = varbuffer;
		t2 = name;
		i = namesize;
		while ( --i >= 0 ) *t1++ = *t2++;
		*t1++ = '.'; *t1++ = 'm'; *t1++ = 'a'; *t1++ = 'c'; *t1 = '\0';
		handle = (WORD)(OpenFile((BYTE *)varbuffer,0));
		if ( handle < 0 ) {		/* Get now the default directory in play */
			t1 = varbuffer;
			if ( macpath == 0 ) goto Nomacro;
			t2 = macpath;
			while ( *t2 ) *t1++ = *t2++;
			t2 = name;
			i = namesize;
			while ( --i >= 0 ) *t1++ = *t2++;
			*t1++ = '.'; *t1++ = 'm'; *t1++ = 'a'; *t1++ = 'c'; *t1 = '\0';
			handle = (WORD)(OpenFile((BYTE *)varbuffer,0));
			if ( handle < 0 ) {
Nomacro:		c = *t2; *t2 = '\0';
				MesPrint(16,t2-namesize); /* "%s not found" */
				*t2 = c;
				return(-1);
			}
		}
		if ( ( mac = LoadMacro(handle,name,namesize) ) == 0 ) {
			CloseFile(handle);
			return(-1);
		}
	}
/*
	Read the parameters and load the stack frame.
*/
	parnum = '0';
	if ( ( v = (VARSTORE)LineAlloc(0,varbuf->last) ) == 0 ) goto EndOfIt;
	if ( ( v = (VARSTORE)LineAlloc(namesize+(WORD)sizeof(WORD)+1,(LINE)v) ) == 0 ) {
		PopVarStack();
		goto EndOfIt;
	}
	v->namesize = 1;
	t1 = v->name;
	*t1++ = parnum;
	i = namesize;
	t2 = name;
	while ( --i >= 0 ) *t1++ = *t2++;

	if ( startupmacro ) {
		startupmacro = 0;
		while ( --gargc >= 0 && *gargv ) {
			t2 = s = *gargv++;
			i = 0;
			while ( *s ) { s++; i++; }
			if ( ( v = (VARSTORE)LineAlloc(i+(WORD)sizeof(WORD)+1,(LINE)v) ) == 0 ) {
				PopVarStack();
				goto EndOfIt;
			}
			parnum++;
			v->namesize = 1;
			t1 = v->name;
			*t1++ = parnum;
			while ( t2 < s ) *t1++ = *t2++;
		}
	}
	else {
		for (;;) {
			SKIPTBLANKS(s,n);
			if ( n <= 0 ) break;
			t2 = s;
			i = 0;
			while ( n > 0 ) {
				if ( *s == 0x1B || *s == '\\' ) {
					n--; s++;
				}
				else if ( *s == ' ' || *s == '\t' ) break;
				i++; n--; s++;
			}
			if ( ( v = (VARSTORE)LineAlloc(i+(WORD)sizeof(WORD)+1,(LINE)v) ) == 0 ) {
				PopVarStack();
				goto EndOfIt;
			}
			parnum++;
			v->namesize = 1;
			t1 = v->name;
			*t1++ = parnum;
			while ( t2 < s ) {
				if ( *t2 == 0x1B || *t2 == '\\' ) t2++;
				*t1++ = *t2++;
			}
		}
	}
	if ( parnum > '9' ) {
		MesnOut(39); /* "More than 9 parameters" */
		PopVarStack();
		goto EndOfIt;
	}
	if ( ( parnum = CheckParms(mac,parnum-'0') ) != 0 ) {
		MesPrint(36,parnum);
		PopVarStack();
		goto EndOfIt;
	}
/*
	Execute the macro
*/
	retval = Xmacro(mac);
/*
	Cleanup
*/
EndOfIt:
	if ( handle >= 0 ) {
/*
		And remove the macro again
*/
		m = (MACRO)(&FirstMacro);
		while ( m->next != mac ) m = m->next;
		m->next = mac->next;
		Mfree(mac);
	}
	return(retval);
}

/*
 		#] DoMacro :
 		#[ FindMacro :			MACRO FindMacro(name,namesize)

		Note that some systems have a case insensitive filesystem.
		This makes that the macronames must be case insensitive too
		in those systems. Alas but true!
*/

MACRO
FindMacro(UBYTE *name,WORD namesize)
{
	MACRO m;
	m = (MACRO)(&FirstMacro);
	while ( m->next ) {
		m = m->next;
		if ( namesize == m->namesize ) {
#ifdef SENSITIVE
			if ( strNcmp(name,m->name,namesize) == 0 ) return(m);
#else
			if ( strNIcmp(name,m->name,namesize) == 0 ) return(m);
#endif
		}
	}
	return(0);
}	

/*
 		#] FindMacro :
 		#[ CountMacro :			LONG CountMacro(first,last)

		Counts the size of the contents of a range of lines.
		This involves a recursion over the folds.
		Fold lines are not copied. Commentary is also not copied.
		Commentary starts with a '*' in column 1.
*/

LONG
CountMacro(LINE first,LINE last)
{
	LONG size = 0;
	last = last->next;
	while ( first != last ) {
		if ( first->used < 0 ) {
			size += CountMacro(((FOLDLINE)first)->first,((FOLDLINE)first)->last);
		}
		else {
			size += first->totlen;
		}
		first = first->next;
	}
	return(size);
}

/*
 		#] CountMacro :
 		#[ CopyToMacro :		UBYTE *CopyToMacro(first,last,to)
*/

UBYTE *
CopyToMacro(LINE first,LINE last,UBYTE *to)
{
	WORD i;
	UBYTE *s;
	last = last->next;
	while ( first != last ) {
		if ( first->used < 0 ) {
			to = CopyToMacro(((FOLDLINE)first)->first,
				((FOLDLINE)first)->last,to);
		}
		else {
			i = first->totlen;
			s = (UBYTE *)first;
			while ( --i >= 0 ) *to++ = *s++;
		}
		first = first->next;
	}
	return(to);
}

/*
 		#] CopyToMacro :
 		#[ CreaMacro :			MACRO CreaMacro(b, name, namesize)
*/

MACRO
CreaMacro(BUFFER b, UBYTE *name, WORD namesize)
{
	MACRO m, mm;
	LONG headersize, size;
	UBYTE *s, *to;
/*
		Count space needed.
		There must be a recursion for folds!
*/
	if ( b->first != (LINE)cbuf ) {
		size = CountMacro(b->first,b->last);
	}
	else {
		size = 0;
	}
/*
		Now the header
*/
	headersize = sizeof(struct macro_s) + namesize + sizeof(LONG) - 2;
	headersize &= -sizeof(LONG);
/*
		Allocate the memory and install the header
*/
	if ( ( m = (MACRO)MALLOC(headersize+size) ) == 0 ) {
		MesMem();
		return(0);
	}

	m->next = 0;
	m->size = headersize + size;
	m->start = headersize;
	m->ownmalloc = 1;
	m->namesize = namesize;
	m->used = 0;
	s = m->name;
	while ( --namesize >= 0 ) { *s++ = *name++; }
	to = ((UBYTE *)m) + m->start;
	while ( s < to ) *s++ = 0;
/*
		Copy the contents of the buffer. Open the folds during writing.
*/
	if ( b->first != (LINE)b ) {
		to = CopyToMacro(b->first,b->last,to);
	}
/*
		Insert the line links.
*/
	if ( size > 0 ) {
		for(;;) {
			((LINE)s)->prev = 0;
			if ( ( s + ((LINE)s)->totlen ) < to ) {
				((LINE)s)->next = (LINE)(s + ((LINE)s)->totlen);
				s += ((LINE)s)->totlen;
			}
			else {
				((LINE)s)->next = 0;
				break;
			}
		}
	}
/*
		Put the macro in the links.
*/
	if ( DoAll(m) ) {
		Mfree(m);
		return(0);
	}
	mm = (MACRO)(&FirstMacro);
	while ( mm->next ) mm = mm->next;
	mm->next = m;
	return(m);
}

/*
 		#] CreaMacro :
 		#[ MakeMacro :			LONG MakeMacro(s,n)

		Routine copies the contents of the current buffer to the
		macro buffer.
		There should be a name so that the macro can be found back.
		A number indicates how many parameters there should be.
*/

LONG
MakeMacro(UBYTE *s,WORD n)
{
	UBYTE *name;
	WORD namesize = 0;
	MACRO m;

	if ( n > 0 ) {
		if ( *s == 'd' || *s == 'D' ) {
			n--; s++;
			return(DeleteMacro(s,n));
		}
		if ( *s == 'v' || *s == 'V' ) {
			return(ViewMacros(s+1,n-1));
		}
	}
	if ( n <= 0 || ( *s != 'c' && *s != 'C' ) ) return(-1);
	n--; s++;
	while ( n > 0 && ( *s == ' ' || *s == '\t' ) ) { n--; s++; }
	if ( n <= 0 ) return(0L);
	name = s;
	while ( n > 0 && *s && *s != ' ' && *s != '\t' ) { n--; s++; }
	namesize = (WORD)(s - name);
/*
		Test for a macro by the same name
*/
	if ( FindMacro(name,namesize) != 0 ) {
		MesnOut(40); /* "There is a macro with this name already!" */
	}
	else if ( ( m = CreaMacro(cbuf,name,namesize) ) != 0 ) {
#ifdef PORTWIN
		MakeMacMen();
#endif
		MesPrint(17,m->name); /* "Macro %s added" */
		return(0);
	}
	return(-1);
}

/*
 		#] MakeMacro :
 		#[ WordTest :			WORD WordTest(line,s)
*/
 
WORD
WordTest(LINE line,BYTE *s)
{
	WORD n, m;
	BYTE *t;
	t = (BYTE *)(line->text);
	m = n = line->used - LINEHEAD;
	SKIPTBLANKS(t,n)
	while ( n > 0 && *s ) {
		if ( *s++ != *t++ ) return(0);
		n--;
	}
	if ( *s || ( ( n > 0 && *t != ' ' && *t != '\t' ) ) ) return(0);
	SKIPTBLANKS(t,n)
	WordContinue = (UBYTE *)t;
	WordCn = n;
	return(m-n);
}

/*
 		#] WordTest :
 		#[ DoAll :				WORD DoAll(mac)

		Set all the connections for the while, and if instructions.
		We skip the goto as they are less complicated
*/

WORD
DoAll(MACRO mac)
{
	LINE line;
	UBYTE *endofname, c;
	endofname = ((UBYTE *)mac) + mac->start;
	line = (LINE)endofname;
	while ( line ) {
		if ( WordTest(line,"while") ) {
			if ( line->prev == 0 && DoIfWhile(line,WHILE) == 0 ) goto UnMatch;
			line = line->prev;
		}
		else if ( WordTest(line,"if") ) {
			if ( line->prev == 0 && DoIfWhile(line,IF) == 0 ) goto UnMatch;
			line = line->prev;
		}
		else {
			line = line->next;
		}
	}
	return(0);
UnMatch:
	c = *endofname;			/* The name ends where the contents begin  */
	*endofname = 0;			/* So we make it end with zero temporarily */
	MesPrint(18,mac->name); /* "Unmatched while or if in macro %s"     */
	*endofname = c;
	return(-1);
}

/*
 		#] DoAll :
 		#[ DoIfWhile :			LINE DoIfWhile(line,par)
*/
 
LINE
DoIfWhile(LINE line,WORD par)
{
	LINE l, line1;
	line1 = 0;
	l = line->next;
	while ( l ) {
		if ( WordTest(l,"endif") ) {
			if ( par == WHILE ) {
Illeg:
				MesIll(107); /* "if/while nesting" */
				return(0);
			}
			if ( line1 ) {
				line->prev = line1->next;
				if ( l->next ) line1->prev = l->next;
				else line1->prev = l;
			}
			else {
				line->prev = l->next;
			}
			return(l);
		}
		if ( WordTest(l,"else") ) {
			if ( par == WHILE ) goto Illeg;
			if ( line1 ) {
				MesnOut(41); /* "Twice else in one if" */
				return(0);
			}
			line1 = l;
		}
		else if ( WordTest(l,"if") ) {
			l = DoIfWhile(l,IF);
			if ( !l ) return(0);
		}
		else if ( WordTest(l,"while") ) {
			l = DoIfWhile(l,WHILE);
			if ( !l ) return(0);
		}
		else if ( WordTest(l,"endwhile") ) {
			if ( par == IF ) goto Illeg;
			l->prev = line;
			line->prev = l->next;
			return(l);
		}
		l = l->next;
	}
	MesnOut(42); /* "if without endif" */
	return(0);
}

/*
 		#] DoIfWhile :
 		#[ FindName :			UBYTE *FindName(s,n,name,namesize)

		Routine determines the bounds of a name.
		Return value is the first char after the name.
*/

UBYTE *
FindName(UBYTE *s,WORD n,UBYTE **name,WORD *namesize)
{
	WORD BraceFlag, DollarFlag;
	UBYTE c;
	if ( *s == '$' && n > 0 ) { DollarFlag = 1; n--; s++; }
	else DollarFlag = 0;
	if ( n > 0 && *s == '{' ) { BraceFlag  = 1; n--; s++; }
	else BraceFlag = 0;
	*name = s;
	if ( n > 0 ) {
		c = ToLower[*s++]; n--;
		if ( ( c < 'a' || c > 'z' ) && c != '_' ) {
/*
			Possible strange names are:
			0-9 for the arguments
			<char> for character-in-word indications
*/
			if ( DollarFlag ) {
				if ( c >= '0' && c <= '9' ) DollarFlag = 2;
				else if ( c == '<' ) {
WordChar:
					if ( n < ( BraceFlag+1 )
					|| s[1] != '>' ||
					( BraceFlag && s[2] != '}' ) ) goto IllName;
					*namesize = 3;
					return(s+2+BraceFlag);
				}
				else if ( c == '@' ) {
					if ( *s != '&' && ( *s > '9' || *s < '0' ) )
						goto IllName;
					if ( BraceFlag ) {
						if ( n < 2 || s[1] != '}' ) goto IllName;
					}
					*namesize = 2;
					return(s+1+BraceFlag);
				}
				else return(0);
			}
			else {
				if ( c == '<' ) goto WordChar;
#ifdef WITHMOUSE
				if ( c <= '9' && c >= '0' && BraceFlag ) {
					while ( n > 0 && *s <= '9' && *s >= '0' ) { s++; n--; }
					*namesize = (WORD)(s - *name);
					if ( n > 0 && *s == '}' ) { return(s+1); }
				}
#endif
IllName:
				MesIll(108); /* "name for variable" */
				return(0);
			}
		}
		while ( n > 0 && (BYTE)(dbufFer.wordtable[*s]) > 0
		) { n--; s++; }
		*namesize = (WORD)(s - *name);
		if ( BraceFlag ) {
			if ( n <= 0 || *s != '}' ) return(0);
			n--; s++;
		}
		if ( DollarFlag > 1 && *namesize > 1 ) return(0);
		if ( *namesize > 10 ) {
			if ( DollarFlag ) return(0);
			c = *s; *s = 0;
			MesPrint(19,*name); /* "%s is illegal name" */
			*s = c;
			return(0);
		}
		return(s);
	}
	return(0);

}

/*
 		#] FindName :
 		#[ DoCommand :			LONG DoCommand(line,stopper)
*/
 
LONG
DoCommand(LINE line,LINE stopper)
{
	WORD m, namesize;
	WORD sum = 0;
	WORD retsum = 0, size, quotes = 0;
	UBYTE *s, *t, *u, *name, *var;
	LONG retval;
	UseAmper = 0;
	s = Com2Text;
	t = line->text;
	m = line->used - LINEHEAD;
	SKIPTBLANKS(t,m);
	if ( m <= 0 || *t == '*' || *t == '#' ) {
		commandmode = 0;
		return(0);	/* Commentary */
	}
	if ( *t == '"' ) quotes = 1;
	else if ( m > 3 && !strNIcmp(t,(UBYTE *)("SET"),3)
/*
	(  *t  == 's' ||  *t  == 'S' ) &&
	( t[1] == 'e' || t[1] == 'E' ) &&
	( t[2] == 't' || t[2] == 'T' )
*/
	 ) quotes = -1;
	while ( m > 0 ) {
		if ( *t == '$' ) {
			u = FindName(t,m,&name,&namesize);
			if ( u == 0 ) goto DoChar;
			if ( ( var = FindVar(name,namesize,&size) ) == 0 ) goto DoChar;
			m -= (WORD)(u - t);
			t = u;
			sum += size;
			if ( sum > (MAXCOMMAND -1) ) {
TooLong:
				MesnOut(14); /* "Line too long." */
				commandmode = 0;
				return(-1);
			}
			while ( --size >= 0 ) *s++ = *var++;
		}
		else if ( *t == 0x1B || *t == '\\' ) {
			if ( m == 1 ) {
				if ( 
#ifndef WITHBACKSLASH
				*t != '\\' &&
#endif
				line->next != stopper && line->next->used > 0 ) {
					sum += 2; *s++ = *t++; *s++ = '\n';
					line = line->next;
					m = line->used - LINEHEAD;
					t = line->text;
					retsum++;
				}
				else {
					m--;
					sum++; *s++ = *t++;
				}
			}
			else if ( t[1] == '"' && quotes > 0 ) {
				sum += 2;
				*s++ = *t++;
				*s++ = *t++;
				m -= 2;
			}
			else if ( ( t[1] == '"' && quotes ) || t[1] == '$' ) {
				sum++;
				t++;
				*s++ = *t++;
				m -= 2;
			}
			else goto DoChar;
		}
		else {
DoChar:
			m--; sum++; *s++ = *t++;
		}
		if ( sum > (MAXCOMMAND-1) ) goto TooLong;
	}
	ReturnValue = retval = Command(Com2Text,sum);
	if ( retval < 0 ) return(retval);
	return(retsum);
}

/*
 		#] DoCommand :
 		#[ NumVal :				WORD NumVal(s,n,to)

		Gives the numerical value of the string in s.
		If all is OK the return value should be zero.
*/

WORD
NumVal(UBYTE *s,LONG n,LONG *to)
{
	LONG x = 0;
	WORD sgn = 0;
	if ( n > 0 ) {
		SKIPTBLANKS(s,n);
		while ( n > 0 && ( *s == '+' || *s == '-' ) ) {
			if ( *s == '-' ) sgn ^= 1;
			n--; s++;
			SKIPTBLANKS(s,n);
		}
		while ( n > 0 && *s <= '9' && *s >= '0' ) {
#ifdef ATARI
			x = lllong(x,10L) + *s++ - '0';
#else
			x = x * 10 + *s++ - '0';
#endif
			n--;
		}
		SKIPTBLANKS(s,n);
		if ( sgn ) x = -x;
	}
	*to = x;
	if ( n > 0 ) return((WORD)(-n));
	return(0);
}

/*
 		#] NumVal :
 		#[ NumToStr :			WORD NumToStr(number)

		Puts the given number in inbuf as a string.
*/

WORD
NumToStr(LONG number)
{
	UBYTE buf[16], *b, *bstop;
	WORD n, sgn;
	b = bstop = buf + 16;
	if ( number < 0 ) { sgn = 1; number = -number; }
	else sgn = 0;
	do {
#ifdef ATARI
		*--b = lwdiv(&number,(WORD)10) + '0';
#else
		*--b = ( number % 10 ) + '0';
		number /= 10;
#endif
	} while ( number );
	if ( sgn ) *--b = '-';
	n = (WORD)(bstop - b);
	if ( ( buftop - inbuf ) < n ) return(-1);
	while ( --n >= 0 ) *inbuf++ = *b++;
	return(0);
}

/*
 		#] NumToStr :
 		#[ LogVal :				WORD LogVal(s,n)

		Returns the logical value of the given string.
*/

WORD
LogVal(UBYTE *s,LONG n)
{
	while ( n > 0 ) {
		if ( *s != '0' && *s != ' ' && *s != '\t' ) return(1);
		n--;
		s++;
	}
	return(0);
}

/*
 		#] LogVal :
 		#[ Operation :			VARIABLE *Operation(v,vstart)

		The operational unit of the calculator and the logical
		conditions. Starting from a variable it tries to simplify
		the expression from the back. The return value is the 
		address of the topmost variable on the stack.

		The notation is:

		v->where:		The string of this variable.
		v->number:		Its number of characters.
		v->operation:	The operation after it.
		v->bracket:		Number of brackets after this operation.

		v is the top element. If the routine is called with the
		operation left blank we have to resolve the top level bracket.
		An empty string counts as a zero for arithmetic purposes.
*/

VARIABLE *
Operation(VARIABLE *v,VARIABLE *vstart)
{
	WORD op1, op2 = v->operation, i, j;
	LONG num1, num2;
	UBYTE *s, *t;
	while ( v > vstart && v[-1].bracket == 0 ) {
		op1 = v[-1].operation;
		if ( OpTable[op1] > OpTable[v->operation] ) break;
		switch ( op1 ) {
			case LOGNOT:
				num1 = 1 - LogVal(v->where,v->number);
				v--;
				v->where = inbuf = v->inbuf;
				*inbuf++ = num1 ? '1' : '0';
				v->number = 1;
				v->operation = op2;
				break;
			case ADDITION:
				if ( v[-1].number <= 0 ) goto Catenate;
			case MULTIPLICATION:
			case QUOTIENT:
			case REMAINDER:
			case SUBTRACTION:
				if ( NumVal(v->where,v->number,&num2) ) {
					if ( op1 == ADDITION ) goto Catenate;
					goto NumWrong;
				}
				v--;
				if ( NumVal(v->where,v->number,&num1) ) {
					if ( op1 == ADDITION ) { v++; goto Catenate; }
					goto NumWrong;
				}
#ifdef ATARI
				if ( op1 == MULTIPLICATION ) num1 = lllong(num1,num2);
				else if ( op1 == QUOTIENT  ) {
					if ( num2 == 0 ) {
DivZero:				MesnOut(104);
						return(0);
					}
					num1 = lldiv(num1,num2);
				}
				else if ( op1 == REMAINDER ) {
					if ( num2 == 0 ) goto DivZero;
					num1 = llmod(num1,num2);
				}
#else
				if ( op1 == MULTIPLICATION ) num1 *= num2;
				else if ( op1 == QUOTIENT  ) {
					if ( num2 == 0 ) {
DivZero:				MesnOut(116);
						return(0);
					}
					num1 /= num2;
				}
				else if ( op1 == REMAINDER ) {
					if ( num2 == 0 ) goto DivZero;
					num1 %= num2;
				}
#endif
				else if ( op1 == ADDITION) num1 += num2;
				else num1 -= num2;
MakeNumber:
				v->where = inbuf = v->inbuf;
				if ( NumToStr(num1) ) goto BufOverF;
				v->number = inbuf - v->where;
				v->operation = op2;
				break;
			case CONCATENATION:
Catenate:
				num2 = v[-1].number;
				num1 = v->number;
				inbuf = v[-1].inbuf;
				if ( ( buftop - inbuf ) < ( num1+num2 ) ) {
BufOverF:
					MesnOut(43); /* "variable stack overflow during evaluation" */
					return(0);
				}
				t = inbuf + num1 + num2;
				if ( v->where < (inbuf+num2) ) {
					s = v->where + num1;
					while ( --num1 >= 0 ) *--t = *--s;
					s = v[-1].where;
					if ( s != inbuf ) {
						t = inbuf;
						while ( --num2 >= 0 ) *t++ = *s++;
					}
					inbuf = v[-1].inbuf + v[-1].number + v->number;
				}
				else {
					s = v[-1].where;
					while ( --num2 >= 0 ) *inbuf++ = *s++;
					s = v->where;
					while ( --num1 >= 0 ) *inbuf++ = *s++;
				}
				v--;
				v->number = inbuf - v->inbuf;
				v->where = v->inbuf;
				v->operation = op2;
				break;
			case LOGEQUAL:
			case LOGNOTEQUAL:
				s = v->where;
				num2 = v->number;
				v--;
				t = v->where;
				num1 = v->number;
				while ( num1 > 0 && num2 > 0 ) {
					if ( *s++ != *t++ ) break;
					num1--; num2--;
				}
				if ( num1 == 0 && num2 == 0 ) num1 = 1;
				else num1 = 0;
				if ( op1 == LOGNOTEQUAL ) num1 ^= 1;
				v->where = inbuf = v->inbuf;
				*inbuf++ = num1 ? '1' : '0';
				v->number = 1;
				v->operation = op2;
				break;
			case LOGGT:
			case LOGLT:
			case LOGGE:
			case LOGLE:
				if ( NumVal(v->where,v->number,&num2) ) goto stringcomp;
				v--;
				if ( NumVal(v->where,v->number,&num1) ) {
					v++; goto stringcomp;
				}
				if ( op1 == LOGGT ) num1 = (num1 > num2) ? 1 : 0;
				else if ( op1 == LOGLT ) num1 = (num1 < num2) ? 1 : 0;
				else if ( op1 == LOGGE ) num1 = (num1 >= num2) ? 1 : 0;
				else num1 = (num1 <= num2) ? 1 : 0;
PutLog:
				v->where = inbuf = v->inbuf;
				*inbuf++ = num1 ? '1' : '0';
				v->number = 1;
				v->operation = op2;
				break;
stringcomp:
				num1 = v->number; num2 = v[-1].number;
				i = (num1 > num2) ? (WORD)num2: (WORD)num1;
				s = v->where; v--; t = v->where;
				while ( i > 0 ) {
					if ( *s != *t ) {
						if ( *s > *t ) j = -1;
						else j = 1;
						goto diffstr;
					}
					i--; s++; t++;
				}
				if ( num1 > num2 ) j = -1;
				else if ( num2 > num1 ) j = 1;
				else j = 0;
diffstr:
				if ( op1 == LOGGT ) num1 = /* (j>0) ? 1 : 0; */ (j+1)>>1;
				else if ( op1 == LOGLT ) num1 = /*(j<0) ? 1 : 0;*/ (-j+1)>>1;
				else if ( op1 == LOGGE ) num1 = /*(j>=0) ? 1 : 0;*/ (j+2)>>1;
				else num1 = /* (j<=0) ? 1 : 0; */ (-j+2)>>1;
				goto PutLog;
			case LOGLEXGT:
			case LOGLEXLT:
			case LOGLEXGE:
			case LOGLEXLE:
				op1 -= 4;
				goto stringcomp;
			case LOGOR:
			case LOGAND:
				num2 = LogVal(v->where,v->number);
				v--;
				num1 = LogVal(v->where,v->number);
				if ( op1 == LOGOR ) num1 |= num2;
				else num1 &= num2;
				v->where = inbuf = v->inbuf;
				*inbuf++ = num1 ? '1' : '0';
				v->number = 1;
				v->operation = op2;
				break;
			case STRMAKELEFT:
			case STRMAKERIGHT:
				if ( NumVal(v->where,v->number,&num2) ) return(0);
				v--;
				if ( num2 < 0 ) goto NegNum;
				if ( num2 > v->number ) num2 = v->number;
				s = v->where;
				if ( op1 == STRMAKERIGHT ) s += v->number-num2;
				v->number = num2;
				goto Take2Num;
			case STRTAKELEFT:
			case STRTAKERIGHT:
				if ( NumVal(v->where,v->number,&num2) ) return(0);
				v--;
				if ( num2 < 0 ) {
NegNum:
					MesnOut(44); /* "Negative number of chars?" */
					return(0);
				}
				if ( num2 > v->number ) num2 = v->number;
TakeNum:
				v->number -= num2;
				s = v->where;
				if ( op1 == STRTAKELEFT ) s += num2;
Take2Num:
				num1 = v->number;
				v->where = inbuf = v->inbuf;
				while ( --num1 >= 0 ) *inbuf++ = *s++;
				v->operation = op2;
				break;
			case STRCLIPLEFT:
				num2 = v->number;
				op1 = STRTAKELEFT;
				num1 = v[-1].number - v->number;
				s = v[-1].where;
				i = 1;
				goto clippings;
			case STRCLIPRIGHT:
				num2 = v[-1].number+1;
				op1 = STRTAKERIGHT;
				num1 = v[-1].number - v->number;
				s = v[-1].where + num1 - 1;
				i = -1;
clippings:
				if ( v->number > v[-1].number ) {
NoAct:				inbuf = v->inbuf;
					v--;
					v->operation = op2;
					break;
				}
				t = v->where;
				while ( num1 > 0 ) {
					while ( num1 > 0 && *s != *t ) { num1--; s += i; num2 += i; }
					if ( num1 > 0 && strNcmp(s,t,(WORD)(v->number)) == 0 ) {
						v--;
						goto TakeNum;
					}
					num1--;
					s += i;
					num2 += i;
				}
				goto NoAct;
			case STRLEN:
				num1 = v->number;
				v--;
				goto MakeNumber;
			case TOUPPER:
				t = ToUpper;
				goto ConvertCase;
			case TOLOWER:
				t = ToLower;
ConvertCase:
				s = (UBYTE *)(v->where); i = (WORD)(v->number);
				v--;
				v->where = inbuf = v->inbuf;
				v->number = i;
				while ( --i >= 0 ) *inbuf++ = t[*s++];
				v->operation = op2;
				break;
#ifdef WITHHEX
			case DECTOHEX:
				if ( NumVal(v->where,v->number,&num2) ) goto NumWrong;
				v--;
				v->where = inbuf = v->inbuf;
				s = inbuf+20;
				*s = 0;
				if ( num2 ) {
					while ( num2 ) {
						*--s = hex[num2 & 0xF];
						num2 = ((ULONG)num2) >> 4;
					}
				}
				else *--s = '0';
				t = inbuf;
				while ( *s ) *t++ = *s++;
				v->number = t - inbuf;
				v->operation = op2;
				break;
			case HEXTODEC:
				num1 = 0;
				s = v->where;
				i = v->num;
				v--;
				while ( --i >= 0 ) {
					j = ToUpper[*s++];
					if ( j >= 0 && j <= '9' ) num1 = (num2 << 4) + j - '0';
					else if ( j >= 'A' && j <= 'F' ) num1 = (num2<<4)+j-55;
					else break;
				}
				goto MakeNumber;
#endif
			default:
				MesnOut(45); /* "Internal error!" */
				return(0);
		}
	}
	return(v);
NumWrong:
	MesnOut(46); /* "Improper use of nonnumerical string" */
	return(0);
}

/*
 		#] Operation :
 		#[ Compute :			LONG Compute(line)

		Define a variable. The right hand side may involve arithmetic.
		Computation is stack oriented. Operations:
		* / %
		+ -
		~ or //			string concatenation. Lowest priority
		( )
		""
		&& || != ==
		!
		Variables must fit inside MAXCOLUMN bytes.
		No more than MAXBRACKET levels of brackets!
		The intermediate buffer cannot hold more than
		MAXVARS (>= MAXCOLUMN) bytes.
*/         
 
LONG
Compute(LINE line)
{
	VARIABLE vars[2*MAXBRACKET];
	UBYTE *s, *name, *u;
	WORD n, namesize;
	WORD mode = LOCALMODE;
	LONG retval = 0;
/*
		Start with getting the name of the variable
*/
	s = WordContinue;
	n = WordCn;
	if ( *s == '-' ) {
		n--; s++;
		if ( n <= 0 ) return(0);
		if ( *s == 'l' || *s == 'L' ) mode = LOCALMODE;
		else if ( *s == 'g' || *s == 'G' ) mode = GLOBALMODE;
		else {
			MesnOut(47); /* "Unknown option in set" */
			return(-1);
		}
		n--; s++;
		SKIPTBLANKS(s,n);
		if ( n <= 0 ) return(0);
	}

	u = FindName(s,n,&name,&namesize);
	if ( u == 0 ) return(-1);
	n -= (WORD)(u - s);
	s = u;
/*
		Check for the equals sign
*/
	SKIPTBLANKS(s,n);
	if ( n <= 0 || *s != '=' ) {
		MesnOut(48); /* "No = in set" */
		return(-1);
	}
	n--; s++;

/*
		Now comes the real work. EvalExpression is used both
		for the definitions and the logical expressions.
*/
	retval = EvalExpression(line,line->used-LINEHEAD-n,vars,vars+2*MAXBRACKET);
/*
		Now we have the final string in v.
*/
	if ( retval < 0 ||
	EnterVar(name,namesize,vars[0].where,vars[0].number,mode) ) return(-1);

	return(retval);
}

/*
 		#] Compute :
 		#[ EvalExpression :		WORD EvalExpression(line,n,vars,vtop)
*/

static BYTE ops[] = {
	 LOGNOTEQUAL	,0 ,'!','='		,0
	,LOGNOT			,1 ,'!'			,0
	,REMAINDER		,0 ,'%'			,0
	,LOGAND			,0 ,'&','&'		,0
	,MULTIPLICATION	,0 ,'*'			,0
	,ADDITION		,2 ,'+'			,0
	,SUBTRACTION	,4 ,'-'			,0
	,CONCATENATION	,0 ,'/','/'		,0
	,QUOTIENT		,0 ,'/'			,0
	,STRTAKELEFT	,0 ,':','>'		,0
	,STRTAKERIGHT	,0 ,'<',':'		,0
	,STRMAKELEFT	,0 ,'<','<'		,0
	,LOGLE			,0 ,'<','='		,0
	,LOGLEXLE		,0 ,'<','=','~'	,0
	,LOGLEXLT		,0 ,'<','~'		,0
	,LOGLT			,0 ,'<'			,0
	,LOGEQUAL		,0 ,'=','='		,0
	,STRCLIPLEFT	,0 ,'=','^'		,0
	,STRLEN			,1 ,'s','t','r','l','e','n',0
	,LOGGE			,0 ,'>','='		,0
	,LOGLEXGE		,0 ,'>','=','~'	,0
	,STRMAKERIGHT	,0 ,'>','>'		,0
	,LOGLEXGT		,0 ,'>','~'		,0
	,LOGGT			,0 ,'>'			,0
	,TOLOWER		,1 ,'t','o','l','o','w','e','r',0
	,STRCLIPRIGHT	,0 ,'^','='		,0
	,TOUPPER		,1 ,'t','o','u','p','p','e','r',0
	,LOGOR			,0 ,'|','|'		,0
	,CONCATENATION	,0 ,'~'			,0
#ifdef WITHHEX
	,DECTOHEX		,1 ,'h','e','x',0
	,HEXTODEC		,1 ,'d','e','c','i','m','a','l',0
#endif
};

WORD
EvalExpression(LINE line,WORD n,VARIABLE *vars,VARIABLE *vtop)
{
	VARIABLE *v, *vstart;
	UBYTE *s, *name, *varstring, *t1, *u, c;
	WORD namesize, op, varsize, nn, i;
	LONG retval = 0;
	inbuf = varbuffer;

	s = line->text + n;
	n = line->used - LINEHEAD - n;

	v = vstart = vars;
	v->operation = ADDITION;
	v->inbuf = inbuf;
	v->where = (UBYTE *)v;
	v->number = 0;
	op = NOOPERATION;
	if ( n > 0 && ( *s == '+' || *s == '-' ) ) {
		n--;
		if ( *s++ == '-' ) {
			v->operation = SUBTRACTION;
		}
	}
	v->bracket = 0;
	while ( n > 0 ) {
		c = ToLower[*s];
		if ( c == ' ' || c == '\t' ) {}
		else if ( c <= '9' && c >= '0' ) {
			varstring = s;
			n--; s++;
			while ( n > 0 && *s <= '9' && *s >= '0' ) { n--; s++; }
			varsize = (WORD)(s - varstring);
			goto DoVarS;
		}
		else if ( c == '$' ) {
			u = FindName(s,n,&name,&namesize);
			if ( u == 0 ) {
UnDef:
				c = name[namesize];
				name[namesize] = 0;
				MesPrint(20,name); /* "%s is undefined" */
				name[namesize] = c;
				return(-1);
			}
			n -= (WORD)(u - s);
			s = u;
			varstring = FindVar(name,namesize,&varsize);
			if ( varstring == 0 ) goto UnDef;
			if ( varsize && varstring == scrap ) {	/* We have to copy this */
				nn = varsize;
				t1 = inbuf;
				if ( ( buftop - t1 ) < nn ) goto OverFlow;
				while ( --nn >= 0 ) *inbuf++ = *varstring++;
				varstring = t1;
			}
DoVarS:
			if ( v->operation == NOOPERATION ) {
				*inbuf = 0;
				MesPrint(28,varstring);  /* "Illegal sequence starting with %s" */
				return(-1);
			}
			v++;
			if ( v >= vtop ) goto OverFlow;
			v->number = varsize;
			v->where = varstring;
			v->operation = NOOPERATION;
			v->bracket = 0;
			v->inbuf = inbuf;
			continue;
		}
		else if ( c == '"' ) {
			n--; s++;
			varstring = inbuf;
			while ( n > 0 && *s != '"' ) {
				c = *s;
				if ( c == 0x1B || ( 
				c == '\\'
#ifndef WITHBACKSLASH
				&& n > 1
#endif
				) ) {
					n--; s++;
					if ( n > 0 ) {
						n--; *inbuf++ = *s++;
					}
					else {
						if ( line->next == 0 ) {
							MesIll(106); /* "end of macro" */
							return(-1);
						}
						line = line->next;
						retval++;
						n = line->used - LINEHEAD;
						s = line->text;
					}
				}
				else {
					n--; *inbuf++ = *s++;
				}
			}
			if ( n <= 0 ) {
				MesIll(112); /* "string" */
				return(-1);
			}
			n--; s++;
DoString:
			varsize = (WORD)(inbuf - varstring);
			goto DoVarS;
		}
		else if ( c == '(' ) {
			v->bracket++;
		}
		else if ( c == ')' ) {
			if ( v->bracket ) v->bracket--;
			else if ( v->operation == NOOPERATION ) {
				if ( ( v = Operation(v,vstart) ) == 0 ) return(-1);
				if ( v[-1].bracket == 0 ) {
					MesnOut(49); /* "Unmatched brackets" */
					return(-1);
				}
				v[-1].bracket--;
			}
			else {		/* match (. */
				MesIll(109); /* "position for )" */
				return(-1);
			}
		}
		else if ( c == 0x1B || (
		 c == '\\'
#ifndef WITHBACKSLASH
		 && n > 1
#endif
		) ) {
			n--; s++;
			if ( n == 0 ) {
				if ( line->next == 0 ) {
					MesIll(106); /* "end of macro" */
					return(-1);
				}
				line = line->next;
				s = line->text;
				n = line->used - LINEHEAD;
				retval++;
				continue;
			}
		}
		else {
			BYTE *stopper;
			WORD subcode;
			t1 = (UBYTE *)ops;
			stopper = ops + sizeof(ops);
			do {
				u = s; i = n;
				op = *t1++; subcode = *t1++;
				while ( *t1 && i > 0 && *t1 == *u ) { i--; t1++; u++; }
				if ( *t1 == 0 ) break;
				t1++;
				while ( *t1++ );
			} while ( t1 < (UBYTE *)stopper );
			if ( t1 < (UBYTE *)stopper ) {
				if ( ( subcode & 1 ) != 0 ) {
					if ( v->operation == NOOPERATION ) {
						MesIll(111); /* "sequence of operators" */
						return(-1);
							/* 114 "use of ! operator" */
					}
					v++;
					if ( v >= vtop ) goto OverFlow;
					v->number = 0;
					v->where = 0;
					v->bracket = 0;
					v->operation = op;
					v->inbuf = inbuf;
				}
				else {
					if ( v->operation != NOOPERATION ) {
						if ( subcode == 2 ) goto EndLoop;
							/* unary + is trivial */
						else if ( subcode == 4 ) {
							if ( v->bracket == 0 ) {
								if ( v->operation == ADDITION ) {
									v->operation = SUBTRACTION;
									goto EndLoop;
								}
								if ( v->operation == SUBTRACTION ) {
									v->operation = ADDITION;
									goto EndLoop;
								}
							}
							v++;
							if ( v >= vtop ) goto OverFlow;
							v->number = 0;		/* empty string */
							v->where = 0;
							v->bracket = 0;
						}
						else {
							MesIll(111); /* "sequence of operators" */
							return(-1);
						}
					}
					v->operation = op;
					if ( ( v = Operation(v,vstart) ) == 0 ) return(-1);
				}
EndLoop:
				n = i; s = u;
				continue;
			}
			else if ( (BYTE)(dbufFer.wordtable[*s]) > 0 ) {
				varstring = inbuf;
				while ( n > 0 && (BYTE)(dbufFer.wordtable[*s]) > 0 ) {
					n--; *inbuf++ = *s++;
				}
				goto DoString;
			}
			else {
				c = s[n]; s[n] = 0;
				MesPrint(28,s);	/* "Illegal sequence starting with '%s'" */
				s[n] = c;
				return(-1);
			}
		}
		n--; s++;
	}
	if ( v->bracket ) v->bracket--;
	if ( v->operation != NOOPERATION ) {
		MesIll(105); /* "end of expression" */
		return(-1);
	}
	if ( ( v = Operation(v,vstart) ) == 0 ) return(-1);
	if ( v != vstart ) {
		if ( v[-1].bracket ) {
			MesnOut(49); /* "Unmatched brackets" */
			return(-1);
		}
		MesnOut(50); /* "Evaluation error" */
		return(-1);
	}
	return(0);
 
OverFlow:
	MesnOut(51); /* "expression too complicated." */
	return(-1);
}

/*
 		#] EvalExpression :
 		#[ DoCondition :		LONG DoCondition(line,n)

		Read a (composite) condition. Determine whether it is true.
*/
 
LONG
DoCondition(LINE line,WORD n)
{
	VARIABLE vars[2*MAXBRACKET];
	LONG retval = 0;
	UBYTE *s;

	retval = EvalExpression(line,n,vars,vars+2*MAXBRACKET);

	if ( retval < 0 ) return(retval);

	s = vars[0].where;
	n = (WORD)(vars[0].number);
	while ( --n >= 0 ) {
		if ( *s != ' ' && *s != '\t' && *s != '0' && *s != '-' && *s != '+' )
			return(1);
		s++;
	}
	return(0);
}

/*
 		#] DoCondition :
 		#[ FindLabel :			WORD FindLabel(m,line,par)

		line contains a goto statement. We look for the matching
		label and insert its address in the ->prev link of line.

		If ( par != 0 ) not finding it is an error.
*/

WORD
FindLabel(MACRO m,LINE line,WORD par)
{
	LINE l;
	UBYTE *name, *s, *lstop;
	WORD namesize, n;
	lstop = ((UBYTE *)m)+m->size;
	l = (LINE)(((UBYTE *)m)+m->start);
	if ( line == &(OnError.l) ) {
		s = OnError.l.text+5;
		n = 7;
	}
	else {
		s = WordContinue;
		n = WordCn;
	}
	name = s;
	while ( n > 0 && *s != ' ' && *s != '\t' ) { n--; s++; }
	namesize = (WORD)(s - name);
	if ( namesize <= 0 ) {
		MesnOut(52); /* "No name specified in goto" */
		return(0);
	}
	while ( l && (UBYTE *)l < lstop ) {
		if ( WordTest(l,"label") ) {
/*
			s = l->text;
			n = l->used - LINEHEAD;
			SKIPTBLANKS(s,n);
			s += 5; n -= 5;
			SKIPTBLANKS(s,n);
*/
			s = WordContinue;
			n = WordCn;
			if ( n >= namesize && strNcmp(s,name,namesize) == 0 ) {
				s += namesize;
				if ( n == namesize || *s == ' ' || *s == '\t' ) {
					line->prev = l;
					return(1);			/* label found */
				}
			}
		}
		l = l->next;
	}
	if ( par ) {
		s = name + namesize;
		n = *s;
		*s = 0;
		MesPrint(21,name); /* "Label %s not found" */
		*s = n;
	}
	return(0);			/* label not found */
}

/*
 		#] FindLabel :
 		#[ Xmacro :				LONG Xmacro(mac)

		Execute a macro that has been loaded.
		If a while of if statement have unsubstituted links
		they are computed first.
		Statements have their variables substituted first in DoCommand
		and defines are done in Compute.
		The rest concerns the control flow.
		Note that escape codes can concatenate lines so:

		Return codes of Compute and DoCommand:
		< 0:	error
		>= 0:	number of extra lines to be skipped.
*/

LONG
Xmacro(MACRO mac)
{
	LINE line, L;
	LONG n = 0, i;
	UBYTE *s, c;
	WORD FirstError = 0, WithReturn = 0, ToRet = 0;
	DispBlock++;
	line = (LINE)(((BYTE *)mac) + mac->start);
	(mac->used)++;
	while ( line ) {
		if ( (( *DirKBshift ) & BREAKCODE ) == BREAKCODE )
		{
			WORD oldredraw = redraw;
			redraw = 0;
			ForceDisplay();
			MesnOut(53);
			i = MesAsk(103,INTEXT);
			/* "User interrupt. Abort execution? (Y/N) " */
			redraw = oldredraw;
			if ( i ) {
				MesnOut(54); /* "Stopped" */
				n = -23;
				goto MesMac;
			}
		}
		if ( ( i = WordTest(line,"while") ) > 0
		  || ( i = WordTest(line,"if"   ) ) > 0 ) {
			if ( ( n = DoCondition(line,(WORD)i) ) > 0 ) {
				while ( ( c = line->text[line->used-LINEHEAD-1] ) == 0x1B
#ifdef WITHBACKSLASH
				|| c == '\\'
#endif
				) line = line->next;
				line = line->next;
			}
			else if ( n == 0 )  {
				line = line->prev;
			}
			else {
				goto MesMac;
			}
		}
		else if ( WordTest(line,"endwhile") ) {
			if ( line->prev == 0 ) {
				MesnOut(55); /* "endwhile without while" */
				goto MesMac;
			}
			else line = line->prev;
		}
		else if ( WordTest(line,"endif")
		       || WordTest(line,"endif") ) {
			line = line->next;
		}
		else if ( WordTest(line,"else") ) {
			if ( line->prev == 0 ) {
				MesnOut(56); /* "else without if" */
				goto MesMac;
			}
			line = line->prev;
		}
		else if ( WordTest(line,"set") ) {
			if ( ( n = Compute(line) ) < 0 ) goto MesMac;
			do {
				line = line->next;
			} while ( --n >= 0 );
		}
		else if ( WordTest(line,"goto") ) {
			if ( line->prev == 0 && FindLabel(mac,line,1) == 0 ) {
				n = -1; goto MesMac;
			}
			line  = line->prev;
		}
		else if ( WordTest(line,"label") ) line = line->next;
		else if ( WordTest(line,"return") ) {
			VARIABLE vars[2*MAXBRACKET];
			UseAmper = 0;
			s = WordContinue;
			n = WordCn;
			if ( EvalExpression(line,line->used-(WORD)LINEHEAD-(WORD)n,
			vars,vars+2*MAXBRACKET) < 0 ) goto TryOnError;
			if ( EnterVar((UBYTE *)"returncode",(WORD)10,vars[0].where
			,(WORD)(vars[0].number),(WORD)GLOBALMODE) ) goto NoReturn;
			WithReturn = 1;
			break;
		}
		else if ( WordTest(line,"input") ) {
			if ( ( n = GetString() ) < 0 )
				goto MesMac;
			line = line->next;
		}
		else {
			if ( ( n = DoCommand(line,0) ) < 0 ) {
				if ( n == -2 ) break;	/* . option in search */
				if ( n == -23 ) goto MesMac;
TryOnError:
				if ( FirstError ) goto MesMac;
				if ( FindLabel(mac,&(OnError.l),0) == 0 ) {
					n = -1; goto MesMac;
				}
				FirstError = 1;
				line  = OnError.l.prev;
			}
			else {
				do {
					line = line->next;
				} while ( --n >= 0 );
			}
		}
	}
	ToRet = 0;
	if ( !WithReturn ) {
NoReturn:
		if ( EnterVar((UBYTE *)"returncode",(WORD)10,
		(UBYTE *)"",(WORD)0,(WORD)GLOBALMODE) ) {
			ToRet = -1;
		}
	}
	PopVarStack();
	(mac->used)--;
	DispBlock--;
	return(ToRet);
MesMac:
	i = 1;
	L = (LINE)(((UBYTE *)mac) + mac->start);
	s = (UBYTE *)L;
	while ( L != line ) { L = L->next; i++; }
	MesCon(" ("); MesNum(i); MesCon(")");
	c = *s;
	*s = 0;
	MesCon((BYTE *)(mac->name));
	*s = c;
	PopVarStack();
	(mac->used)--;
	DispBlock--;
	return(n);
}

/*
 		#] Xmacro :
 		#[ DeleteMacro :		LONG DeleteMacro(s,n)
*/

LONG
DeleteMacro(UBYTE *s,WORD n)
{
	UBYTE *name, c;
	WORD namesize = 0;

	MACRO m, mm;
	while ( n > 0 && ( *s == ' ' || *s == '\t' ) ) { n--; s++; }
	if ( n <= 0 ) return(0L);
	name = s;
	while ( n > 0 && *s && *s != ' ' && *s != '\t' ) { n--; s++; }
	namesize = (WORD)(s - name);
	if ( ( m = FindMacro(name,namesize) ) != 0 ) {
		if ( m->used > 0 ) {
			MesnOut(57); /* "Cannot delete running macro" */
			return(-1);
		}
		mm = (MACRO)(&FirstMacro);
		while ( mm->next != m ) mm = mm->next;
		mm->next = m->next;
		if ( m->ownmalloc ) Mfree((BYTE *)m);
		c = *s; *s = 0;
		MesPrint(22,name); /* "Macro %s deleted" */
		*s = c;
#ifdef PORTWIN
		MakeMacMen();
#endif
		return(0);
	}
	else {
		c = *s; *s = 0;
		MesPrint(23,name); /* "Cannot find macro %s" */
		*s = c;
		return(-1);
	}
}

/*
 		#] DeleteMacro :
 		#[ LoadMacro :			MACRO LoadMacro(handle,name,namesize)

		Routine gets an opened file and a name and is to return
		a pointer to a macro struct if all went well.
		The struct must be ready for execution and the macro must have
		been entered in the links so that recursive calls don't need
		a reload.

		We read the file in in the undo buffer and copy it then to
		a macro buffer.
*/

MACRO
LoadMacro(WORD handle,UBYTE *name,WORD namesize)
{
	BUFFER b = undoB;
	MACRO m;
	LINE after;
	WORD i;
	UBYTE *bufp, *Rbuffer;
	LONG numRead;
	WORD oldmode = cbuf->outputmode;

	m = 0;			/* Prefab return code */
	ClearUndo();

	if ( ( Rbuffer = (UBYTE *)MALLOC((LONG)MMEMLENGTH) ) == 0 ) {
		MesMem();
		goto Error1;
	}
	bufp = bufRead = Rbuffer + ( ( MAXINLINE + 10 ) & 0xFFFC );
	if ( ( numRead = FileRead((WORD)handle,(LONG)MREADLENGTH,(BYTE *)bufRead) ) <= 0 ) {
		MesnOut(26); /* "Read Error" */
		goto Error2;
	}
	bufRead[numRead] = CARRETURN;
	bstop2 = bstopper = bufRead + numRead;
	if ( numRead == MREADLENGTH ) bstop2 -= MAXINLINE + 2;

	cbuf->outputmode = ATARIMODE;
	after = (LINE)b;
	for(;;) {
		if ( ( after = InsertBuffer ( after, &bufp ) ) == 0 ) {
			goto Error2;
		}

		if ( ( i = (WORD)(bstopper - bufp) ) > 0 ) {	/* Copy leftover */
			bufp = bufRead;
			bstop2 = bstopper;
			do { *--bufp = *--bstop2; } while ( --i > 0 );
		}
		else  bufp = bufRead;

		if ( ( numRead = FileRead((WORD)handle,(LONG)MREADLENGTH,(BYTE *)bufRead) ) <= 0 ) {
			if ( numRead < 0 ) {
				MesnOut(26); /* "Read error" */
				goto Error2;
			}
			else if ( bufp == bufRead ) goto LastLine;
		}
		bufRead[numRead] = CARRETURN;
		bstop2 = bstopper = bufRead + numRead;
		if ( numRead == MREADLENGTH ) bstop2 -= MAXINLINE + 2;
	};

LastLine:
	b->totline = CountLines(b);
	b->current = b->first;
/*
	Now the file lies in the undo buffer.
	Install it now in the macro buffer.
*/
	m = CreaMacro(b,name,namesize);
Error2:
	Mfree(Rbuffer);
Error1:
	CloseFile((WORD)handle);
	cbuf->outputmode = oldmode;
	ClearUndo();
/*	garb();	  */			/* We clean up entirely! */
	return(m);
}

/*
 		#] LoadMacro :
 		#[ ShowVariable :		LONG ShowVariable(s,n)

		Shows the contents of a variable in the message line.
*/

static BYTE *isis[] = {"=", "is"};
static BYTE undefi[] = "undefined";

LONG
ShowVariable(UBYTE *s,WORD n)
{
	UBYTE *name, *u, *t, c, cc;
	WORD namesize, size, m = 0;
	if ( !FindName(s,n,&name,&namesize) ) return(-1);
	t = FindVar(name,namesize,&size);
	u = name + namesize; c = *u; *u = 0;
	if ( t == 0 ) { m = 1; size = 9; t = (UBYTE *)undefi; }
	s = t + size; cc = *s; *s = 0;
	MesPrint(24,name,isis[m],t); /* "%s %s %s" */
	*u = c;
	*s = cc;
	return(0);
}

/*
 		#] ShowVariable :
 		#[ setmacdir :			VOID setmacdir(name)
*/

VOID
setmacdir(UBYTE *name)
{
	UBYTE *s, *t;
	WORD i;
	s = name; i = 0;
	while ( *s ) { s++; i++; }
	if ( macpath ) Mfree(macpath);
	if ( ( macpath = (UBYTE *)MALLOC((LONG)(i+2)) ) == 0 ) MesMem();
	else {
		s = (UBYTE *)name;
		t = (UBYTE *)macpath;
		if ( i > 0 ) {
			NCOPY(t,s,i);
			if ( t[-1] != SEPARATOR 
#ifdef WITHALTSEPARATOR
				&& t[-1] != ALTSEPARATOR
#endif
			 ) *t++ = SEPARATOR;
		}
		*t = 0;
	}
}

/*
 		#] setmacdir :
 		#[ ViewMacros :			LONG ViewMacros(s,n)
*/

static LONG
ViewMacros(UBYTE *s,WORD n)
{
	MACRO m;
	UBYTE *t, c;
	LINE line;
	SKIPTBLANKS(s,n);
	if ( n <= 0 ) {
		m = (MACRO)(&FirstMacro);
		while ( m->next ) {
			m = m->next;
			if ( cbuf->totline && append() < 0 ) return(-1);
			if ( InNorm(m->name,m->namesize) < 0 ) return(-1);
		}
	}
	else {
		t = s;
		while ( n > 0 && *s != ' ' && *s != '\t' && *s ) { s++; n--; }
		if ( ( m = FindMacro(t,(WORD)(s-t)) ) == 0 ) {
			c = *s; *s = 0;
			MesPrint(23,t);
			*s = c;
			return(-1);
		}
		line = (LINE)(((BYTE *)m) + m->start);
		while ( line ) {
			if ( cbuf->totline && append() < 0 ) return(-1);
			if ( InNorm(line->text,line->used-LINEHEAD) < 0 ) return(-1);
			line = line->next;
		}
	}
	return(0);
}

/*
 		#] ViewMacros :
 		#[ GetFirst :			LONG GetFirst(s,n)
*/

LONG
GetFirst(UBYTE *s,WORD n)
{
	UBYTE *ss, c;
	ss = s + n; c = *ss; *ss = 0;
#ifdef ATARI
	SetNewDTA(sdta);
	if ( dtaused ) {
		while ( NextFile() == 0 ) {}
	}
	if ( Sfirst(s,0x27) == 0 ) dtacont = 1;
	else
#endif
#ifdef IBM
	SetNewDTA(sdta);
	if ( FindFile(s,sdta,0x27) == 0 ) dtacont = 1;
	else
#endif
#ifdef HELIOS
	if ( FindFile(s,sdta,0x27) == 0 ) dtacont = 1;
	else
#endif
		dtacont = 0;
	*ss = c;

	if ( fullsearch ) Mfree(fullsearch);
	if ( ( fullsearch = (UBYTE *)MALLOC((LONG)(n+MAXFILENAME+1)) ) == 0 )
		MesMem();
	else {
		ss = fullsearch;
		while ( --n >= 0 ) *ss++ = *s++;
		*ss = 0;
		ss--;
		while ( *ss != SEPARATOR
#ifdef WITHALTSEPARATOR
		 && *ss != ALTSEPARATOR
#endif
		 && *ss != ':' ) {
			if ( ss == fullsearch ) goto Complete;
			ss--;
		}
		ss++;
Complete:
		fullsearchend = ss;
	}
	dtaused = dtacont;
	return(0);
}

/*
 		#] GetFirst :
 		#[ CheckParms :			WORD CheckParms(mac,numpar)
*/

WORD
CheckParms(MACRO mac,WORD numpar)
{
	LINE line = (LINE)(((BYTE *)mac)+mac->start);
	BYTE *s = (BYTE *)line->text;
	WORD i = line->used - LINEHEAD, mpar;
	if ( i < 11 ) return(0);
	if ( *s != '*' && *s != '#' && s[1] != ':' ) return(0);
	s += 2; i -= 2;
	while ( i > 0 && ( *s == ' ' || *s == '\t' ) ) { s++; i--; }
	if ( i <= 0 || *s > '9' || *s < '0' ) return(0);
	mpar = 0;
	while ( i > 0 && *s <= '9' && *s >= '0' ) {
		mpar = 10*mpar + *s++ - '0';
		i--;
	}
	while ( i > 0 && ( *s == ' ' || *s == '\t' ) ) { s++; i--; }
	if ( i < 8 ) return(0);
	if ( strNIcmp(s,"argument",8) ) return(0);
	s += 8;
	i -= 8;
	if ( ( i > 0 && *s == 's' ) || *s == 'S' ) { s++; i--; }
	if ( i > 0 && *s != ' ' && *s != '\t' ) return(0);
	while ( i > 0 && ( *s == ' ' || *s == '\t' ) ) { s++; i--; }
	MacroText = s;
	MacroTnum = i;
	if ( mpar > numpar ) return(mpar);
	return(0);
}

/*
 		#] CheckParms :
*/
#endif
/*
  	#] Macros :
*/
