/*
  	#[ Include file :
*/
#ifndef DEMO
#include "stedi.h"

/*
  	#] Include file :
  	#[ Regular expressions :
 		#[ Variables :
*/

#define MAXGROUPS 10
#define MAXREPR 255
#define MAXPOPPER 512

UBYTE *BraceTable[MAXGROUPS];
WORD nbTable;

typedef struct repeat {
	WORD minval;
	WORD maxval;
} REPEAT;

typedef struct v_usage {
	LINE startline;
	LINE endline;
	BYTE *startchar;
	BYTE *endchar;
	WORD used;
	WORD claimed;
} V_USAGE;

V_USAGE VarUsage[11];

typedef struct t_temp {
	LINE line;
	UBYTE *pos;
} T_TEMP;

#define CHARACTER -1
#define PERIODC -2
#define BRACES -3
#define SUBEXPRESSION -4
#define FIRSTCHAR -5
#define LASTCHAR -6
#define ENDSTART -7

#define OPTIONELEMENT -10
#define OPTIONSUBEXPRESSION -11

/*
	SUBSTRING is the number of characters in the string
*/

WORD UseAmper = 0;

typedef struct object1 {
	union {
		UBYTE			chr;
		WORD			bracnum;
		struct ReGeXp	*expr;
		UBYTE			*substr;
	} obj;
	WORD type;
	WORD varnum;
} OBJECT1;

typedef struct object2 {	/* One object, including ifs */
	OBJECT1 fixed;
	OBJECT1 ifclause;
	REPEAT	repfix;
	REPEAT	repif;
	WORD	reptype;		/* 0 -> fixed goes plain once */
	WORD	type;			/* 0 -> no if */
} OBJECT2;

typedef struct object3 {	/* One object in a chain of or's */
	OBJECT2			withif;
	struct object3	*nextor;
} OBJECT3;

typedef struct object4 {	/* One object in a chain */
	OBJECT3			withor;
	struct object4	*nextone;
} OBJECT4;
 
typedef struct ReGeXp {		/* One subexpression */
	OBJECT4	obj4;			/* first composite object */
	REPEAT	rep;			/* Repetition information for the whole struct */
	WORD	type;			/* type of repetition */
	WORD	varnum;			/* primary variable number */
} REGEXP;
 
/* UBYTE *restart[MAXREPR]; */
/* WORD restartlevel; */

REGEXP *rexpression;		/* The address of the primary expression */

UBYTE **RegNext;
UBYTE *RegFill;
UBYTE *RegEnd;
UBYTE RegMem[REGMEMSIZE];

LINE CurLin;
LINE EndLine;
UBYTE *EndS;
WORD EndN;

UBYTE FixChar;			/* Character if search starts in a fixed way */
UBYTE *FixBrac;			/* Table if search starts with [] in a fixed way */
WORD FirstCol;			/* For a block range of Column range */
WORD LastCol;			/* For a block range. No block range -> 0 */
WORD FirstChar;			/* For a block range */
WORD LastChar;			/* For a block range. No block range -> 0 */
WORD StartCol;			/* Starting Column */
WORD VarFlag;			/* Is on if there are variables in the rhs */
WORD RetFlag;			/* Is on if there returns in the rhs */
WORD EscFlag;			/* Number of escape characters in rhs */
UBYTE *rhsstring;		/* The replacement string */
WORD rhsnumber;			/* The number of characters in above */
WORD GotRet;	/* 20-feb-1989 */

static WORD WeirdEnd;
static WORD QuitFlag;
static LONG RepNumber;
static WORD ContinWord;

extern WORD Srange;
extern WORD Sblock;
extern WORD Snum1;
extern WORD Snum2;
extern LINE Lstart;
extern LINE Lend;
extern WORD Scol1;
extern WORD Scol2;
extern WORD Scmatch;
extern LINE Sprev;
extern WORD PassedZero;

#define SMALLSIZE 20
UBYTE SmallBuf[SMALLSIZE];

typedef struct PoPPer {
	UBYTE *s;
	LINE line;
	REGEXP *e;
	OBJECT4 *obj4;
	OBJECT3 *obj3;
	REGEXP *parent;
	WORD fixgo;
	WORD optgo;
	WORD n;
	WORD vars_used;
	WORD dummy;
	BYTE type;
	BYTE inif;
} *POPPER;

POPPER PopStack;
POPPER PopStop;
 
WORD VarsUsed;

extern WORD	SCase;		/* Value of case sensitivity. */
extern WORD	SDirec;		/* Value of the search direction. */
extern WORD	Speriod;	/* Indicator for . option. */
extern WORD	Sword;		/* Word search indicator.(l) */
extern WORD	Rveto;		/* Veto flag.(l) */
extern WORD	Srange;		/* Range request indicator.(l) */
extern WORD Sblock;		/* Block range indicator. */

#ifdef ANSI
UBYTE *AllocA(WORD);
OBJECT3 *Alloc3(VOID);
OBJECT4 *Alloc4(VOID);
REGEXP *AllocExp(VOID);
WORD StartRMem(VOID);
VOID FreeRAll(VOID);
WORD Translate(UBYTE *,WORD);
UBYTE *GetGroup(UBYTE *,WORD);
UBYTE *MakeOr(UBYTE *,WORD,OBJECT3 *);
UBYTE *MakeIf(UBYTE *,WORD,OBJECT2 *);
UBYTE *DoObject1(UBYTE *,WORD,OBJECT1 *,REPEAT *);
UBYTE *OneObject(UBYTE *,WORD,OBJECT1 *);
UBYTE *Repetitor(UBYTE *,WORD,REPEAT *);
UBYTE *VarIable(UBYTE *,WORD,WORD *);
UBYTE *SubExpression(UBYTE *,WORD,REGEXP **);
WORD DetMatch(LINE);
WORD FillVars(WORD,T_TEMP *,UBYTE *);
WORD TryMatch(UBYTE *,WORD,REGEXP *);
LINE MakeReplace(LINE,WORD);
#else
OBJECT3 *Alloc3();
OBJECT4 *Alloc4();
REGEXP *AllocExp();
WORD StartRMem();
VOID FreeRAll();
UBYTE *AllocA(),*GetGroup(),*MakeOr(),*MakeIf(),*DoObject1();
UBYTE *OneObject(),*Repetitor(),*VarIable(),*SubExpression();
WORD Translate(),DetMatch(),TryMatch(),FillVars();
LINE MakeReplace();
#endif

/*
 		#] Variables :
 		#[ Allocations :		special memory management
			#[ AllocA :			UBYTE *AllocA(n)
*/

UBYTE *
AllocA(WORD n)
{
	UBYTE *RetVal;
	n = (n + 3) & (-4);
	if ( ( RegFill + n ) >= RegEnd ) {
		if ( ( RegFill = (UBYTE *)MALLOC(REGMEMSIZE) ) == NULL ) {
			MesMem();
			return(NULL);
		}
		RegEnd = RegFill + REGMEMSIZE;
		*RegNext = RegFill;
		RegNext = (UBYTE **)RegFill;
		*RegNext = 0;
		RegFill += sizeof(UBYTE **);
	}
	RetVal = RegFill;
	RegFill += n;
	return(RetVal);
}

/*
			#] AllocA :
			#[ Alloc3 :			OBJECT3 *Alloc3()
*/

OBJECT3 *
Alloc3(VOID)
{
	OBJECT3 *o3;
	if ( ( o3 = (OBJECT3 *)AllocA((WORD)(sizeof(OBJECT3))) ) == NULL )
		return(NULL);
	o3->nextor = NULL;
	return(o3);
}

/*
			#] Alloc3 :
			#[ Alloc4 :			OBJECT4 *Alloc4()
*/

OBJECT4 *
Alloc4(VOID)
{
	OBJECT4 *o4;
	if ( ( o4 = (OBJECT4 *)AllocA((WORD)(sizeof(OBJECT4))) ) == NULL )
		return(NULL);
	o4->nextone = NULL;
	o4->withor.nextor = NULL;
	return(o4);
}

/*
			#] Alloc4 :
			#[ AllocExp :		REGEXP *AllocExp()

		Note the vanilla initialization.
		Just in case things escape attention.

*/

REGEXP *
AllocExp(VOID)
{
	REGEXP *e;
	if ( ( e = (REGEXP *)AllocA((WORD)(sizeof(REGEXP))) ) == NULL ) return(NULL);
	e->varnum = -1;
	e->type = 0;
	e->rep.minval = e->rep.maxval = 1;
	e->obj4.nextone = NULL;
	e->obj4.withor.nextor = NULL;
	e->obj4.withor.withif.type = -1;
	e->obj4.withor.withif.reptype = 0;
	e->obj4.withor.withif.repif.minval =
	e->obj4.withor.withif.repif.minval =
	e->obj4.withor.withif.repfix.minval =
	e->obj4.withor.withif.repfix.minval = 1;
	e->obj4.withor.withif.ifclause.varnum = -1;
	e->obj4.withor.withif.ifclause.type = CHARACTER;
	e->obj4.withor.withif.ifclause.obj.chr = 0;
	e->obj4.withor.withif.fixed.varnum = -1;
	e->obj4.withor.withif.fixed.type = CHARACTER;
	e->obj4.withor.withif.fixed.obj.chr = 0;
	return(e);
}

/*
			#] AllocExp :
			#[ StartRMem :		WORD StartRMem()
*/

WORD
StartRMem(VOID)
{
	LONG x = MAXPOPPER;
	RegNext = (UBYTE **)RegMem;
	*RegNext = NULL;
	RegFill = RegMem + sizeof(UBYTE **);
	RegEnd = RegMem + REGMEMSIZE;
	while ( ( PopStack = (POPPER)MALLOC(x*sizeof(struct PoPPer)) ) == NULL ) {
		x >>= 1;
		if ( x < 8 ) {
			MesMem();
			return(-1);
		}
	}
	PopStop = PopStack + x;
	return(0);
}

/*
			#] StartRMem :
			#[ FreeRAll :		VOID FreeRAll()
*/

VOID
FreeRAll(VOID)
{
	UBYTE *r1, *r2;
	r1 = *((UBYTE **)RegMem);
	while ( r1 ) {
		r2 = *((UBYTE **)r1);
		Mfree(r1);
		r1 = r2;
	}
	while ( nbTable > 0 ) {
		Mfree(BraceTable[--nbTable]);
	}
	Mfree(PopStack);
}

/*
			#] FreeRAll :
 		#] Allocations :
 		#[ RegExp :				LONG RegExp(s,n)

	This is the outside routine
	It accepts the syntax and runs the show.

*/

LONG
RegExp(UBYTE *s,WORD n)
{
	BUFFER b = cbuf;
	LINE l, lastline = 0, ll = 0;
	UBYTE *startexp, *endexp, *t;
	WORD RetCode, i;
	WORD OnlySearch, OnceOnly, recentcol = 0;
	FINDPOS fp;
/*
  	#[ Syntax :
*/
	UseAmper = 0;
	WeirdEnd = 0;
	RepNumber = 0;
	QuitFlag = 0;
	SCase = b->sensitivity;
	SDirec = b->direction;
	Speriod = Sword = Rveto = Srange = Sblock = ColMode = 0;
	GotRet = 0;
	OnlySearch = 1;
	PassedZero = 0;
	VarFlag = EscFlag = RetFlag = 0;
	startexp = s;
	while ( n > 0 ) {
		if ( *s == 0x1B || *s == '\\' ) {
			s += 2;
			n -= 2;
			if ( n < 0 ) {
IrrEnd:
				MesnOut(62); /* "Irregular ending" */
				return(-1L);
			}
		}
		else {
			if ( *s == '/' ) break;
			n--; s++;
		}
	}
	endexp = s;
	if ( n > 0 ) {
		s++; n--;
		SKIPBLANKS(s,n);
		if ( n > 0 && *s == '=' ) {		/* Read right hand side */
			for ( i = 0; i < 10; i++ ) VarUsage[i].claimed = 0;
			OnlySearch = 0;
			n--; s++;
			SKIPBLANKS(s,n);
			if ( n <= 0 || *s != '/' ) goto BadSyntax;
			n--; s++;
			rhsstring = s;
			while ( n > 0 && *s != '/' ) {
				if ( *s == '\\' || *s == 0x1B ) {
					n--; s++;
					if ( n <= 0 ) goto IrrEnd;
					if ( *s == '\r' || *s == '\n' || *s == 'n' ) {
						RetFlag++;
					}
					else {
						EscFlag++;
					}
				}
				else if ( *s == '@' ) {
					n--; s++;
					if ( n <= 0 || *s > '9' || *s < '0' ) {
						MesnOut(63); /* "Improper use of @ in rhs" */
						return(-1L);
					}
					VarUsage[*s-'0'].claimed = 1;
					VarFlag++;
				}
				else if ( *s == '&' ) VarFlag++;
				n--; s++;
			}
			rhsnumber = (WORD)(s - rhsstring);
			if ( n <= 0 ) {
BadSyntax:
				MesnOut(64); /* "Missing / in replacement" */
				return(-1);
			}
			n--; s++;
			if ( EscFlag && !RetFlag && !VarFlag
				 && ( rhsnumber - EscFlag ) <= SMALLSIZE ) {
				UBYTE *s1;
				s1 = rhsstring;
				rhsstring = t = SmallBuf;
				i = rhsnumber;
				do {
					if ( ( *s1 == '\\' || *s1 == 0x1B ) &&
					*s1 != '\r' && *s1 != '\n' && *s1 != 'n'
					&& *s1 != '@' && *s1 != '&'
					&& *s1 != '/' ) { i--; s1++; }
					*t++ = *s1++;
				} while ( --i > 0 );
				rhsnumber -= EscFlag;
				EscFlag = 0;
			}
		}
		DoOptions(s,n);
	}
	if ( Translate(startexp,(WORD)(endexp-startexp)) ) {
		FreeRAll();
		return(-1L);
	}
	rexpression->varnum = 10;
	if ( VarFlag ) {
		for ( i=0; i < 10; i++ ) {
			if ( VarUsage[i].claimed && !VarUsage[i].used ) {
				MesPrint(26,i); /* "Undefined variable %d in rhs" */
				FreeRAll();
				return(-1);
			}
		}
	}
	VarFlag += EscFlag + RetFlag;
	if ( SDirec < 0 ) {
		MesnOut(65); /* "Not in backwards mode" */
		FreeRAll();
		return(-1);
	}
/*
  	#] Syntax :

	Now the ranges of action have to be looked at
*/
	if ( Srange || ColMode ) {
		if ( DetBounds(1) < 0 ) { FreeRAll(); return(-1); }
		if ( Sblock && Scol1 > Scol2 ) { i = Scol1; Scol1 = Scol2; Scol2 = i; }
		l = Lstart;
		if ( Srange ) Scol1--;	/* 30-apr-1989 */
	}
	else {
		Lstart = l = b->current;
		Scol1 = b->column;
		Scol2 = Scol1 - 1;
		RetCode = FindChar(l,b->column,&fp);
		if ( RetCode != AFTERVIRTUAL && RetCode != NORMALEOL ) Scol1--;
		else if ( OnlySearch ) { l = l->next; Scol1 = 0; }	/* 9-apr-1989 */
		else if ( l == b->last ) l = (LINE)b;
		Lend = (LINE)b;
	}
	FirstCol = Scol1;
	if ( OnlySearch && !Srange && l == Lstart ) {
		Scol2++;	/* 27-aug-1989 */
		FirstCol++;	/* 20-feb-1989 */
	}
	else {
		lastline = l->prev;
	}
	if ( Sblock || ( Srange && Lend == l ) ) {
		LastCol = Scol2;
		if ( Srange ) LastCol--;
	}
	else LastCol = 500;
	if ( SDirec == 2 ) OnceOnly = 1;
	else OnceOnly = 0;
DoStretch:;
	while ( l != Lend ) {
		if ( LastCol > 0 ) {
			WORD type;
			FINDPOS fpp;
			type = FindChar(l,LastCol,&fpp);
			LastChar = fpp.num;
			if ( type == INSIDETAB && fpp.virt > 0 ) LastChar--;
			if ( FirstCol == 0 ) FirstChar = 0;
			else {
				FirstChar = ColToChar(l,FirstCol)+1;
/*				if ( FirstChar < FirstCol ) FirstChar--;*/
			}
		}
		else {
			FirstChar = 0;
			if ( l->used < 0 ) LastChar = ((FOLDLINE)l)->used - FOLDHEAD;
			else LastChar = l->used - LINEHEAD;
		}
		if ( ( RetCode = DetMatch(l) ) >= 0 ) {
			if ( OnlySearch ) {
Found:			Sprev = l;
				Scmatch = RetCode + 1;
				FindPosc();
				Display(OnceOnly);
				FreeRAll();
				UseAmper = 1;
				return(0);
			}
			ll = l->prev;
			if ( ( l = MakeReplace(l,RetCode) ) == NULL ) {
				ForceDisplay();
				goto FounBug;
			}
			if ( OnceOnly ) { b->dirtyflag = 1; goto Found; }
			lastline = ll;
			recentcol = RetCode;
			if ( l == ll->next ) {
				if ( GotRet ) {
					GotRet = 0;
					FirstCol++;
				}
				else if ( !FirstCol ) goto DoNext1;
			}
			if ( rexpression->type == FIRSTCHAR ) {
				if ( l == Lend ) break;
/*				if ( l == (LINE)b ) break;  */
				l = l->next;
				if ( Sblock || ColMode ) {
					LastCol = Scol2;
					FirstCol = Scol1 - 1;
					if ( Srange ) LastCol--;
				}
				else { FirstCol = 0; LastCol = 0; }
			}
		}
		else if ( RetCode < -1 ) {
FounBug:	if ( QuitFlag ) {
				lastline = ll;
				recentcol = RetCode;
				goto EndSearch;
			}
			FreeRAll();
			b->dirtyflag = 1;
			DoDisplay();
			return(-1);
		}
		else {
			if ( Sblock || ColMode ) {
				FirstCol = Scol1;
				if ( ColMode ) FirstCol--;
				LastCol = Scol2;
				if ( Srange ) LastCol--;
			}
			else {
				LastCol = 0; FirstCol = 0;
			}
			l = l->next;
		}
DoNext1:
		if ( WeirdEnd ) break;
#ifdef WITHBREAK
		if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) goto EndSearch;
#endif
	}
	if ( Srange ) goto DoLast;
	GotRet = 0;			/* 20-feb-1989 */
	if ( ColMode ) {
		FirstCol = Scol1-1;		/* 9-apr-1989 */
		LastCol = Scol2;
	}
	else FirstCol = 0;		/* 20-feb-1989 */
	if ( SDirec == CIRCULAR ) {
		if ( PassedZero == 0 ) {
			l = b->first;
			PassedZero = 1;
			Lend = Lstart;
			goto DoStretch;
		}
DoLast:
		if ( Srange ) Scol2--;
		if ( Scol2 > 1 || ( Scol2 == 1 && Srange ) ) {
			if ( !OnlySearch && !Srange ) Scol2--;
			if ( Srange || ColMode ) {
				LastCol = Scol2;
				if ( Sblock || ColMode || Lstart == l ) {
					FirstCol = Scol1;
					if ( ColMode ) FirstCol--;
				}
				else FirstCol = 0;
			}
			else { FirstCol = 0; LastCol = Scol2+1; }
RedoLast:
			if ( LastCol > 0 ) {
				WORD type;
				FINDPOS fpp;
				type = FindChar(l,LastCol,&fpp);
				LastChar = fpp.num;
				if ( type == INSIDETAB && fpp.virt > 0 ) LastChar--;
				if ( FirstCol == 0 ) FirstChar = 0;
				else {
					FirstChar = ColToChar(l,FirstCol)+1;
/*					if ( FirstChar < FirstCol ) FirstChar--; */
				}
			}
			else {
				FirstChar = 0;
				if ( l->used < 0 ) LastChar = ((FOLDLINE)l)->used - FOLDHEAD;
				else LastChar = l->used - LINEHEAD;
			}
			if ( ( RetCode = DetMatch(l) ) >= 0 ) {
				if ( !OnlySearch ) {
					ll = l->prev;
					if ( ( l = MakeReplace(l,RetCode) ) == NULL ) {
						ForceDisplay();
						goto FounBug;
					}
					if ( OnceOnly ) { b->dirtyflag = 1; goto Found; }
					if ( GotRet && l == ll->next ) {
						FirstCol++;
						GotRet = 0;
					}
					fp.num += l->used;
					lastline = ll;
					recentcol = RetCode;
#ifdef WITHBREAK
					if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) goto EndSearch;
#endif
					if ( rexpression->type != FIRSTCHAR ) goto RedoLast;
				}
				else if ( RetCode != (fp.num-1) ) goto Found;
				else {
					MesnOut(67); /* "No other match" */
					goto FounBug;
				}
			}
			else if ( RetCode < -1 ) goto FounBug;
		}
	}
EndSearch:
	FreeRAll();
	if ( ( OnlySearch || RepNumber == 0 ) && !QuitFlag ) {
		DoDisplay();
		MesnOut(58); /* "No match" */
		if ( Speriod ) return(-2);
		return(0);
	}
	else {
		l = lastline->next;
		b->newline = FindNum(l);
		b->current = l;
		b->column  = FindColumn(l,recentcol+1);
		b->newvirt = 0;
		if ( RepNumber ) b->dirtyflag = 1;
		ClearUndo();
		ForceDisplay();
		i = 0;
		if ( RepNumber == 1 ) i = 1;
		MesPrint(27,RepNumber,plural+i); /* "%l replacement%s" */
	}
	if ( Speriod && RepNumber <= 0 ) return(-2);
	return(RepNumber);
}

/*
 		#] RegExp :
 		#[ Translate :			WORD Translate(s,n)

		We follow the syntax of Aho,Sethi and Ullman p.148
		In addition a $# (with # a single digit) indicates
		a variable, that can be used also in the rhs.
		A linefeed is indicated by ^.

*/

WORD
Translate(UBYTE *s,WORD n)
{
	UBYTE *s1,c;
	WORD i;
	REGEXP *e;
	nbTable = 0;
	for ( i = 0; i < 10; i++ ) VarUsage[i].used = 0;
	if ( StartRMem() ) return(-1);
	c = s[n];
	s[n] = ')';
	s1 = SubExpression(s,n+1,&rexpression);
	s[n] = c;
	if ( s1 == NULL ) return(-1);
	e = rexpression;
ReTryE:
	if ( ( e->type == 0 || e->rep.minval > 0 ) && e->obj4.withor.nextor == NULL ) {
		switch ( e->obj4.withor.withif.fixed.type ) {
			case CHARACTER:
				rexpression->type = CHARACTER;
				FixChar = e->obj4.withor.withif.fixed.obj.chr;
				break;
			case BRACES:
				rexpression->type = BRACES;
				FixBrac = BraceTable[e->obj4.withor.withif.fixed.obj.bracnum];
				break;
			case SUBEXPRESSION:
				e = e->obj4.withor.withif.fixed.obj.expr;
				goto ReTryE;
			case FIRSTCHAR:
				rexpression->type = FIRSTCHAR;
				break;
			case LASTCHAR:
				rexpression->type = LASTCHAR;
				break;
			case ENDSTART:
				rexpression->type = ENDSTART;
			case PERIODC:
			case 0:
				break;
			default:
				rexpression->type = CHARACTER;
				FixChar = *(e->obj4.withor.withif.fixed.obj.substr);
				if ( !SCase ) FixChar = ToUpper[FixChar];
				break;
		}
	}
	return(0);
}

/*
 		#] Translate :
 		#[ GetGroup :			UBYTE *GetGroup(UBYTE *,WORD)

		Scans the contents of a pair of straight braces.
		Syntax:
		ab+*	are individual characters.
		Special charcaters are : ^, -, [ and ].
		They are taken as themselves if they occur in an impossible
		position. Their use:
		[ and ] :	Delimit the set.
		^		:	If first in set: everything except for the set.
		-		:	Indicates a range.
		Use as regular characters:
		[		:	[ ... [ .. ]		No problem
		]		:	[] ... ]			As first character
		^		:	Only special if first character
		-		:	Use [-....] or [...-]

		Routine returns the next address in the patternstring
		or NULL when anything is wrong.

*/

UBYTE *
GetGroup(UBYTE *s,WORD n)
{
	UBYTE *table, *t;
	WORD invert = 0, once = 0;
	UWORD i1, i2, i, j;
	if ( n <= 0 ) goto NoPar;
	if ( nbTable >= (MAXGROUPS-1) ) {
		MesnOut(68); /* "Too many character groups" */
		return(NULL);
	}
	if ( ( table = (UBYTE *)MALLOC(0x100L) ) == 0 ) {
		MesMem();
		return(NULL);
	}
	t = table;
	for ( i = 0; i < 256; i++ ) *t++ = 0;
	if ( n > 0 && *s == '^' ) { n--; s++; invert = -1; }
	j = n;
	while ( n > 0 ) {
		if ( s[1] == '-' && n > 3 ) {
			i1 = *s;
			i2 = s[2];
			s += 3; n -= 3;
			if ( i1 == 'a' && i2 > 0x7F && (BYTE)(dbufFer.wordtable[i2]) > 0 ) {
DoLower:		if ( !SCase && !once ) {
					once = 1;
					goto DoUpper;
				}
				for ( i = 0; i < 128; i++ ) {
					if ( (BYTE)(dbufFer.wordtable[i]) > 0
					&& ToUpper[i] != i ) table[i] = 1;
				}
GoLower:
				for ( i = 128; i < 256; i++ ) {
					if ( (BYTE)(dbufFer.wordtable[i]) > 0
					&& ToLower[i] == i ) table[i] = 1;
				}
			}
			else if ( i1 == 'A' && i2 > 0x7F
			&& (BYTE)(dbufFer.wordtable[i2]) > 0 ) {
DoUpper:		if ( !SCase && !once ) {
					once = 1;
					goto DoLower;
				}
				for ( i = 0; i < 256; i++ ) {
					if ( (BYTE)(dbufFer.wordtable[i]) > 0
					&& ToLower[i] != i ) table[i] = 1;
				}
GoUpper:
				for ( i = 128; i < 256; i++ ) {
					if ( (BYTE)(dbufFer.wordtable[i]) > 0
					&& ToUpper[i] == i ) table[i] = 1;
				}
			}
			else if ( i1 > 0x7F && (BYTE)(dbufFer.wordtable[i1]) > 0
			&& i2 > 0x7F && (BYTE)(dbufFer.wordtable[i2]) > 0 ) {
				if ( !SCase ) {
					if ( ToUpper[i1] == i1 && ToUpper[i2] == i2 ) goto GoUpper;
					if ( ToLower[i1] == i1 && ToLower[i2] == i2 ) goto GoLower;
				}
				for ( i = 128; i < 256; i++ ) {
					if ( (BYTE)(dbufFer.wordtable[i]) > 0 ) table[i] = 1;
				}
			}
			else if ( i2 < i1 ) {
				Mfree(table);
				MesnOut(69); /* "Invalid range in string" */
				return(NULL);
			}
			else {
				for ( i = i1; i <= i2; i++ ) {
					if ( !SCase ) {
						table[ToUpper[i]] = 1;
						table[ToLower[i]] = 1;
					}
					else table[i] = 1;
				}
			}
		}
					/* For matching: '[' */
		else if ( *s == ']' && j != n ) {
			if ( invert ) {
				t = table;
				for ( i = 0; i < 256; i++ ) { *t++ ^= 1; }
			}
			BraceTable[nbTable++] = table;
			return(s+1);
		}
		else {
			if ( !SCase ) {
				table[ToUpper[*s]] = 1;
				table[ToLower[*s++]] = 1;
			}
			else table[*s++] = 1;
			n--;
		}
	}
	Mfree(table);
NoPar:
	MesnOut(70); /* "Unmatched [" */
	return(NULL);
}

/*
 		#] GetGroup :
 		#[ MakeOr :				UBYTE *MakeOr(s,n,obj3)

		The `or' binds less than the if.
		So an or can contain an if.
		The or is indicated by the character | followed by a single
		or-object (ie may contain an if and variables indicators ($)).

		|(object)[repetitor][$n1]/(object)[repetitor][$n2]
*/

UBYTE *
MakeOr(UBYTE *s,WORD n,OBJECT3 *obj3)
{
	UBYTE *s1;
	if ( ( s1 = MakeIf(s,n,&(obj3->withif)) ) == NULL ) return(NULL);
	n -= (WORD)(s1 - s); s = s1;
	while ( n > 0 && *s == '|' ) {
		n--; s++;
		if ( ( obj3->nextor = Alloc3() ) == NULL ) return(NULL);
		obj3 = obj3->nextor;
		if ( ( s1 = MakeIf(s,n,&(obj3->withif)) ) == NULL ) return(NULL);
		n -= (WORD)(s1 - s); s = s1;
	}
	obj3->nextor = NULL;
	return(s);
}

/*
 		#] MakeOr :
 		#[ MakeIf :				UBYTE *MakeIf(s,n,obj2)

		The if binds tighter than the or.
		It is indicated by a /.

		/(object)[repetitor][$n]

		Note the exception for the ifclause with a nontrivial repetition.
		It is mapped to a subexpression!
*/

UBYTE *
MakeIf(UBYTE *s,WORD n,OBJECT2 *obj2)
{
	UBYTE *s1;
	if ( n <= 0 ) {
		MesnOut(71); /* "Unexpected end of expression" */
		return((UBYTE *)0);
	}
	if ( ( s1 = DoObject1(s,n,&(obj2->fixed),&(obj2->repfix) ) ) == NULL )
		return(NULL);
	if ( obj2->repfix.maxval == 1 && obj2->repfix.minval == 1 )
		obj2->reptype = 0;
	else
		obj2->reptype = 1;
	n -= (WORD)(s1 - s);
	s = s1;
	if ( n <= 0 || *s != '%' ) {
		obj2->type = -1;
	}
	else {
		n--; s++;
		if ( ( s1 = DoObject1(s,n,&(obj2->ifclause),&(obj2->repif) ) ) == (UBYTE *)0 )
			return((UBYTE *)0);
		if ( obj2->repif.maxval != 1 || obj2->repif.minval != 1 ) {
			REGEXP *e;
			if ( ( e = AllocExp() ) == NULL ) return(NULL);
			e->obj4.withor.withif.repfix.minval = obj2->repif.minval;
			e->obj4.withor.withif.repfix.maxval = obj2->repif.maxval;
			e->rep.minval = e->rep.maxval = 1;
			e->type = 0;
			e->obj4.withor.withif.fixed.varnum = obj2->ifclause.varnum;
			e->obj4.nextone = NULL;
			e->obj4.withor.nextor = NULL;
			e->obj4.withor.withif.type = -1;
			e->obj4.withor.withif.reptype = 1;
			e->obj4.withor.withif.fixed.type = obj2->ifclause.type;
			switch(obj2->ifclause.type) {
				case CHARACTER:
					e->obj4.withor.withif.fixed.obj.chr =
						obj2->ifclause.obj.chr;
					break;
				case BRACES:
					e->obj4.withor.withif.fixed.obj.bracnum =
						obj2->ifclause.obj.bracnum;
					break;
				case SUBEXPRESSION:
					e->obj4.withor.withif.fixed.obj.expr =
						obj2->ifclause.obj.expr;
					break;
				default:
					e->obj4.withor.withif.fixed.obj.substr =
						obj2->ifclause.obj.substr;
					break;
			}
			e->varnum = -1;
			obj2->ifclause.type = SUBEXPRESSION;
			obj2->ifclause.obj.expr = e;
			obj2->ifclause.varnum = -1;
		}
		obj2->type = 0;
		s = s1;
	}
	return(s);
}

/*
 		#] MakeIf :
 		#[ DoObject1 :			UBYTE *DoObject1(s,n,obj1,rep)
*/

UBYTE *
DoObject1(UBYTE *s,WORD n,OBJECT1 *obj1,REPEAT *rep)
{
	UBYTE *s1;
	WORD varnum;
	if ( n <= 0 ) {
Inc:
		MesnOut(71); /* "Unexpected end of expression" */
		return(NULL);
	}
	if ( *s == '(' ) {
		n--; s++;
		obj1->type = SUBEXPRESSION;
		if ( ( s1 = SubExpression(s,n,&(obj1->obj.expr)) ) == NULL )
			return(NULL);
	}
	else if ( *s == ')' ) goto Inc;
	else {
		if ( ( s1 = OneObject(s,n,obj1) ) == NULL ) return(NULL);
	}
	n -= (WORD)(s1 - s);
	s = s1;
	if ( ( s1 = Repetitor(s,n,rep) ) == (UBYTE *)0 ) return((UBYTE *)0);
	n -= (WORD)(s1 - s);
	s = s1;
	if ( n > 0 && *s == '@' ) {
		s = VarIable(s,n,&varnum);
		obj1->varnum = varnum;
	}
	else obj1->varnum = -1;
	return(s);
}

/*
 		#] DoObject1 :
 		#[ OneObject :			UBYTE *OneObject(s,n,object)

		An object is a single character, [] or ().
		Furthermore ^ acts as an object.
*/

static BYTE twiddlestr[] = {'a','-','z','A','-','Z','0','-','9',0};
						/* "a-\x84\x41-\x8e\x30-9]"; */
static BYTE hashstr[] = "0-9]";
static BYTE andstr[] = {'a','-','z','A','-','Z',0}; /* "a-\x84\x41-\x8e]"; */

UBYTE *
OneObject(UBYTE *s,WORD n,OBJECT1 *object)
{
	UBYTE *outstr, c;
	WORD i;
	UBYTE *s1;
	BYTE *s2;
	if ( n <= 0 ) return(NULL);
	switch ( *s ) {
		case '(':
			object->type = SUBEXPRESSION;
			return ( SubExpression(s,n,&(object->obj.expr)) );
		case 0x1B:
		case '\\':
			if ( n == 1 ) goto Illl;
			s++;
			if ( *s == '\r' || *s == '\n' || *s == 'n' ) {
				object->type = ENDSTART;
			}
			else {
				object->type = CHARACTER;
				object->obj.chr = SCase ? *s : ToUpper[*s];
			}
			break;
		case '[':
			if ( n == 1 ) goto Illl;
			object->type = BRACES;
			object->obj.bracnum = nbTable;
			s++; n--;
			return(GetGroup(s,n));
		case '^':
			object->type = FIRSTCHAR;
			break;
		case '$':
			object->type = LASTCHAR;
			break;
		case '~':
			outstr = (UBYTE *)twiddlestr;
			i = 10;
			goto DoAgroup;
		case '!':
			object->type = BRACES;
			object->obj.bracnum = nbTable;
			s++; n--;
			if ( GetGroup((UBYTE *)("a]"),2) == NULL ) return(NULL);
			s1 = BraceTable[object->obj.bracnum];
			s2 = (BYTE *)(dbufFer.wordtable);
				if ( n > 0 && *s == '^' ) {
				n--; s++; c = 1;
			}
			else c = 0;
			i = 256;
			do {
				if ( c ) *s1++ = *s2 > 0 ? 0 : 1;
				else     *s1++ = *s2 > 0 ? 1 : 0;
				s2++;
			} while ( --i > 0 );
			return(s);
		case '#':
			outstr = (UBYTE *)hashstr;
			i = 4;
			goto DoAgroup;
		case '&':
			outstr = (UBYTE *)andstr;
			i = 7;
DoAgroup:
			object->type = BRACES;
			object->obj.bracnum = nbTable;
			if ( GetGroup(outstr,i) == NULL ) return(NULL);
			break;
		case '*':
		case '?':
		case '+':
		case '%':
		case '|':
		case '@':
		case '{':
		case ')':
		case '}':
		case ']':
Illl:		c = s[1]; s[1] = '\0';
			MesPrint(28,s); /* "Illegal sequence starting with %s",s */
			s[1] = c;
			return(NULL);
		case '"':
			s++; n--; i = 0;
			outstr = s;
			while ( n > 0 && *outstr != '"' ) { n--; outstr++; i++; }
			if ( n <= 0 ) {
				MesIll(113); /* "substring" */
				return(NULL);
			}
			if ( i == 0 ) {
				MesnOut(72); /* "Empty substring" */
				return(NULL);
			}
				outstr = AllocA(i);
			object->obj.substr = outstr;
			object->type = i;
			while ( --i >= 0 ) { *outstr++ = SCase ? *s : ToUpper[*s]; s++; }
			break;
		case '.':
			object->type = PERIODC;
			object->obj.chr = *s;
			break;
		default:
			object->type = CHARACTER;
			object->obj.chr = SCase ? *s : ToUpper[*s];
			break;
	}
	return(++s);
}

/*
 		#] OneObject :
 		#[ Repetitor :			UBYTE *Repetitor(s,n,rep)

		Reads a single repetition indicator
		The output is in the struct rep

		Syntax:
			*		Zero or more
			+		One or more
			?		Zero or one
			{m,n}	From m to n (inclusive)

*/

UBYTE *
Repetitor(UBYTE *s,WORD nn,REPEAT *rep)
{
	WORD n = nn;
	WORD x;
	if ( n > 0 ) {
		switch ( *s ) {
			case '*':
				rep->minval = 0;
				rep->maxval = MAXREPR;
				s++;
				break;
			case '+':
				rep->minval = 1;
				rep->maxval = MAXREPR;
				s++;
				break;
			case '?':
				rep->minval = 0;
				rep->maxval = 1;
				s++;
				break;
			case '{':
				n--; s++;
				SKIPBLANKS(s,n);
				if ( n > 0 ) {
					if ( *s == ',' ) {
						rep->minval = 0;
					}
					else if ( *s <= '9' && *s >= '0' ) {
						s = ReadNum(s,&n,&x);
						rep->minval = x;
						if ( n <= 0 ) goto illeg;
						if ( *s == '}' ) {
							rep->maxval = x;
							return(++s);
						}
						else if ( *s != ',' ) goto illeg;
					}
					else {
illeg:
						MesIll(110); /* "repetitor" */
						return(NULL);
					}
				}
				else {  /* "Incomplete repetitor" */
					goto illeg;
				}
				s++; n--;
				if ( n <= 0 ) goto illeg;
				if ( *s == '}' ) {
					rep->maxval = MAXREPR;
					return(++s);
				}
				s = ReadNum(s,&n,&x);
				rep->maxval = x;
				if ( n <= 0 ) goto illeg;
				if ( *s != '}' ) goto illeg;
				s++;
				break;
			default :
				rep->minval = rep->maxval = 1;
				break;
		}
	}
	else {
		rep->minval = rep->maxval = 1;
	}
	return(s);
}

/*
 		#] Repetitor :
 		#[ VarIable :			UBYTE *VarIable(s,n,num)

		Syntax: @n with n a single digit: variable
		All other cases are clearly nonsense.
		The above cases could also be wrong but that should give an
		unsuccessful search.

*/

UBYTE *
VarIable(UBYTE *s,WORD n,WORD *num)
{
	*num = 0;
	n--; s++;
	if ( n > 0 && *s <= '9' && *s >= '0' ) {
		*num = *s++ - '0';
		VarUsage[*num].used = 1;
	}
	else {
		MesnOut(75); /* "illegal use of @" */
		return(NULL);
	}
	return(s);
}

/*
 		#] VarIable :
 		#[ SubExpression :		UBYTE *SubExpression(s,n,expr)

		Does a single subexpression, consisting of objects with ors etc.
		If par == 0 there may not be a closing bracket.

*/

UBYTE *
SubExpression(UBYTE *s,WORD n,REGEXP **expr)
{
	UBYTE *s1;
	OBJECT4 *ob;
	WORD varnum;
	if ( ( *expr = AllocExp() ) == NULL ) return(NULL);
	ob = &((*expr)->obj4);
	if ( n > 0 && *s != ')' ) goto InOr;
	while ( n > 0 && *s != ')' ) {
		if ( ( ob->nextone = Alloc4() ) == NULL ) return(NULL);
		ob = ob->nextone;
InOr:
		if ( ( s1 = MakeOr(s,n,&(ob->withor)) ) == NULL ) return(NULL);
		n -= (WORD)(s1 - s);
		s = s1;
	}
	if ( n <= 0 ) {
		MesnOut(76); /* "Unmatched parentheses" */
		return(NULL);
	}
	n--; s++;
	if ( ( s1 = Repetitor(s,n,&((*expr)->rep)) ) == NULL ) return(NULL);
	n -= (WORD)(s1-s);
	s = s1;
	if ( (*expr)->rep.maxval == 1 && (*expr)->rep.minval == 1 )
		(*expr)->type = 0;
	else
		(*expr)->type = 1;
	if ( n > 0 && *s == '@' ) {
		s = VarIable(s,n,&varnum);
		(*expr)->varnum = varnum;
	}
	else
		(*expr)->varnum = -1;
	return(s);
}

/*
 		#] SubExpression :
 		#[ DetMatch :			WORD DetMatch(line)

		Determines whether there is a match starting in line.
		FirstCol and LastCol indicate a restriction on the columns in the line.
		when LastCol is zero there is no restriction.
		The exact position of the match and other particulars are
		left behind in global variables, because it must be possible
		to restart the search (in a multiple replace).

		There is a pretreatment for searches that start with a fixed
		object. This influences the search times greatly.
*/

WORD
DetMatch(LINE line)
{
	UBYTE *t, *t1, fixchar;
	BYTE *w = (BYTE *)(dbufFer.wordtable);
	WORD n;
	WORD RetVal, sc, type;
	FINDPOS fp;
	if ( line->used >= 0 ) {
		n = line->used - LINEHEAD;
		t = (UBYTE *)(line->text);
	}
	else {
		n = ((FOLDLINE)line)->used - FOLDHEAD;
		t = (UBYTE *)(((FOLDLINE)line)->text);
	}
	ContinWord = ( LastChar < 0 ) ? 1 : 0;
	t1 = t;
	if ( rexpression->type == CHARACTER ) {			 /* fixed startup */
		if ( FirstChar < 0 ) return(-1);
		n = LastChar - FirstChar;
		t += FirstChar;
		sc = FirstChar;
		fixchar = FixChar;
		if ( n > 0 ) {
			if ( !SCase ) {
				do {
					if ( ToUpper[*t] == fixchar ) {
						if ( !Sword || t <= t1 || w[t[-1]] <= 0 ) {
							CurLin = line;
							if ( ( RetVal = TryMatch(t,n,rexpression) ) > 0 ) {
								StartCol = sc;
								RetVal = (WORD)(t - t1);
								goto DidMatch;
							}
							else if ( RetVal < 0 ) return(-2);
#ifdef WITHBREAK
							if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) return(-1);
#endif      	
						}
					}
					t++;
					sc++;
				} while ( --n > 0 );
			}
			else {
				do {
					if ( *t == fixchar ) {
						if ( !Sword || t <= t1 || w[t[-1]] <= 0 ) {
							CurLin = line;
							if ( ( RetVal = TryMatch(t,n,rexpression) ) > 0 ) {
								StartCol = sc;
								RetVal = (WORD)(t - t1);
								goto DidMatch;
							}
							else if ( RetVal < 0 ) return(-2);
#ifdef WITHBREAK
							if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) return(-1);
#endif      	
						}
					}
					t++;
					sc++;
				} while ( --n > 0 );
			}
		}
	}
	else if ( rexpression->type == BRACES ) {		 /* fixed startup */
		if ( FirstChar < 0 ) return(-1);
		n = LastChar - FirstChar;
		t += FirstChar;
		sc = FirstChar;
		while ( n > 0 ) {
			if ( FixBrac[(UBYTE)(*t)] ) {
				if ( !Sword || t <= t1 || w[t[-1]] <= 0 ) {
					CurLin = line;
					if ( ( RetVal = TryMatch(t,n,rexpression) ) > 0 ) {
						StartCol = sc;
						RetVal = (WORD)(t - t1);
						goto DidMatch;
					}
					else if ( RetVal < 0 ) return(-2);
#ifdef WITHBREAK
					if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) return(-1);
#endif
				}
			}
			sc++;
			t++; n--;
		}
	}
	else if ( rexpression->type < 0 ) {				   /* eol startup */
		if ( rexpression->type == FIRSTCHAR ) {
			if ( FirstChar < 0 ) return(-1);
			if ( LastCol > 0 && FirstCol > 0 ) return(-1);
			StartCol = 0;
			CurLin = line;
			if ( ( RetVal = TryMatch(t,n,rexpression) ) > 0 ) {
				RetVal = 0;
				goto DidMatch;
			}
			else if ( RetVal < 0 ) return(-2);
		}
		else {							/* Last character or linefeed */
			if ( LastCol > 0 ) {
				type = FindChar(line,LastCol,&fp);
				if ( type != AFTERVIRTUAL && type != NORMALEOL ) return(-1);
				if ( FirstCol > 0 ) {
					type = FindChar(line,FirstCol,&fp);
					if ( type == AFTERVIRTUAL ) return(-1);
				}
			}
			StartCol = n-1;
			CurLin = line;
			t += n;
			if ( ( RetVal = TryMatch(t,0,rexpression) ) > 0 ) {
				RetVal = n;
				GotRet = 1;	/* 20-feb-1989 */
				goto DidMatch;
			}
			else if ( RetVal < 0 ) return(-2);
		}
	}
	else {
		if ( FirstChar < 0 ) return(-1);
		n = LastChar - FirstChar;
		t += FirstChar;
		sc = FirstChar;
		while ( n >= 0 ) {
			if ( !Sword || t <= t1 || w[t[-1]] <= 0 ) {
				CurLin = line;
				if ( ( RetVal = TryMatch(t,n,rexpression) ) > 0 ) {
					StartCol = sc;
					RetVal = (WORD)(t - t1);
					goto DidMatch;
				}
				else if ( RetVal < 0 ) return(-2);
#ifdef WITHBREAK
				if ( ((*DirKBshift)&BREAKCODE) == BREAKCODE ) return(-1);
#endif
			}
			t++;
			sc++;
			n--;
		}
	}
	return(-1);
DidMatch:
	VarUsage[10].startline = line;
	VarUsage[10].endline = EndLine;
	VarUsage[10].startchar = (BYTE *)t;
	VarUsage[10].endchar = (BYTE *)EndS;
	return(RetVal);
}

/*
 		#] DetMatch :
 		#[ FillVars :			WORD FillVars(x,tmp,s)

		Supporting routine to fill information about variables
*/

WORD
FillVars(WORD x,T_TEMP *tmp,UBYTE *s)
{
	V_USAGE *V;
	T_TEMP *t;
	WORD mask;
	V = VarUsage + x;
	t = tmp + x;
	mask = 1 << x;
	if ( ( VarsUsed & mask ) != 0 ) {
		UBYTE *t1, *t2, *u1, *u2;
		LINE l1, l2;
		l1 = t->line->prev;
		l2 = V->startline->prev;
		do {
			l1 = l1->next; l2 = l2->next;
			if ( l1 == CurLin ) t1 = s;
			else t1 = ((UBYTE *)l1)
			 + (( l1->used < 0 ) ? ((FOLDLINE)l1)->used : l1->used);
			if ( l2 == V->endline ) t2 = (UBYTE *)(V->endchar);
			else t2 = ((UBYTE *)l2)
			 + (( l2->used < 0 ) ? ((FOLDLINE)l2)->used : l2->used);
			u1 = t->pos;
			u2 = (UBYTE *)(V->startchar);
			while ( u1 < t1 && u2 < t2 ) {
				if ( *u1 != *u2 ) return(-1);
				u1++; u2++;
			}
			if ( u1 != t1 || u2 != t2 ) return(-1);
		} while ( l1 != CurLin && l2 != V->endline );
		if ( l1 != CurLin || l2 != V->endline ) return(-1);
	}
	else {
		V->startline = t->line;
		V->startchar = (BYTE *)(t->pos);
		V->endline = CurLin;
		V->endchar = (BYTE *)s;
		VarsUsed |= mask;
	}
	return(0);
}

/*
 		#] FillVars :
 		#[ TryMatch :			WORD TryMatch(s,n,expr)

		Tests for a match at a fix position in a text string.
		Extra globals concerning a match are:
		FirstCol, LastCol, StartCol, CurLin, EndLine, EndS.

		The main problem is the order of the repetitors.
		Regular programming has the loop over subexpressions outside
		the loop over its constituents. If however the matching goes
		wrong later we have to go back inside the subexpression to
		the constituents to continue their loop. This excludes regular
		recursions and forces the use of a single subroutine with
		simulated stacks and many goto's. Trying to keep this all in
		good style would be exceptionally costly in terms of execution
		time.

		Strategy:

		An expression consists of objects. An object can be a subexpression
		or a fixed object.
		Objects can have repetitors. A repetitor has two parts:
		1: The fixed repetition
		2: The optional repetition
		The repetitor {m,n} has a fixed repetition of m and an optional
		repetition of n-m.
		The treatment of repetitions is different between fixed objects
		and subexpressions. This is because subexpressions can contain
		optional elements.
		Whenever the matching fails we have to pop back to the last
		option that is active. Options run from 0 to an integer i. At
		first we try a match that involves as many matches <= i as possible.
		Whenever we pop back to an option we diminish the number of matches
		in this option by one. In order to continue from that point we
		need a context save for each element in the option.

		Things are slightly more complicated with subexpressions because
		we have to remember where to continue when the subexpression is
		complete. Moreover subexpressions may contain options. This means
		that we have to remember how many more copies of the subexpression
		are needed in a repetition. Popping back to an option may involve
		popping back into a subexpression that was properly finished.
		This means that there are three types of context saves:
		OPTIONELEMENT and SUBEXPRESSION.
		There is also the hybrid OPTIONSUBEXPRESSION to keep things simple.

		What is needed in a context save?
		1:	Current Line:		CurLin
		2:	String position:	s
		3:	Chars to go:		n
		4:	Fixed to go:		m1	(SUBEXPRESSION and OPTIONSUBEXPRESSION)
		5:	Option to go:		m2	(SUBEXPRESSION and OPTIONSUBEXPRESSION)
		6:	Subexpression:		e
		7:	NextOne:			o4
		8:	NextOr:				o3
		9:	In if-clause?		InIf
		10:	Type:
		11:	Parent:				parent.

		Prescription:
		At a failing match: go back to the last OPTIONELEMENT or
		OPTIONSUBEXPRESSION.
		At the end of a subexpression, go to the last time that it occurred
		as SUBEXPRESSION and reload its o4, o3, InIf and parent.
		Note that the s,n information has to be kept, even in a plain
		SUBEXPRESSION. It could occur in an if or an or!

		Note that the pop-stack should be allocated. Its preferred size
		is about 500. PopStop is its `stopper'.

		The complicated tmp constructions are to guard against the use
		of variables inside repetitors

		Coded: 26-jan-1989
		First round debugging: 29-jan-1989
*/

#define GOTONEXT if(o3->withif.type>=0&&!InIf)goto DoIf;\
				 else goto NextObject

WORD
TryMatch(UBYTE *s,WORD n,REGEXP *expr)
{
	POPPER p, pp, pword = 0;
	REGEXP *e, *parent, *ep, *OldParent = 0, *OldE = 0;
	OBJECT4 *o4, *Oldo4 = 0;
	OBJECT3 *o3, *Oldo3 = 0;
	OBJECT1 *fix;
	REPEAT *repf;
	BYTE InIf, OldInIf;
	UBYTE *OldS, *t;
	WORD OldN;
	LINE OldLine;
	WORD complete, i, j, repper;
	T_TEMP tmp[10];
	VarsUsed = 0;
	p = PopStack;
	e = expr; parent = NULL;		/* Primary expression */
DoExpr:
	o4 = &(e->obj4);
/*
	o4 will loop through the objects in the (sub)expression
	o3 runs over the or-clauses of an object.
*/
DoObjects:
	o3 = &(o4->withor);
	do {
/*
		Check now the match of one object.
*/
		fix = &(o3->withif.fixed);
		repf = &(o3->withif.repfix);
		InIf = 0;
		repper = o3->withif.reptype;
		OldS = s; OldN = n; OldLine = CurLin;
		goto DoObject;
/*
		Do a potential if clause
		Don't forget to pop the s,n position afterwards.
*/
DoIf:
		OldS = s; OldN = n; OldLine = CurLin;

		fix = &(o3->withif.ifclause);
		repf = &(o3->withif.repif);
		InIf = 1;
		if ( repf->minval == 1 && repf->maxval == 1 ) repper = 0;
		else	repper = 1;
		goto DoObject;
RedoIf:
		s = OldS; n = OldN; CurLin = OldLine;
/*
		Success:
*/
NextObject:
		if ( ( o4 = o4->nextone ) != NULL ) goto DoObjects;
		pp = p;
		if ( Sword ) {
			pword = p;
			Oldo3 = o3;
			Oldo4 = o4;
			OldInIf = InIf;
			OldParent = parent;
			OldE = e;
		}
		complete = 0;
		while ( pp > PopStack ) {
			pp--;
			if ( pp->e == parent ) {
				e = parent;
				complete = 0;
			}
			if ( pp->type != OPTIONELEMENT && pp->e == e && !complete ) {
				if ( pp->fixgo > 0 ) {		/* Load next fixed repetition */
					if ( p >= PopStop ) goto PopOver;
					p->fixgo = pp->fixgo - 1;
					p->optgo = pp->optgo;
					p->type = SUBEXPRESSION;
					p->s = s;
					p->line = CurLin;
					p->e = e;
					p->obj4 = pp->obj4;
					p->obj3 = pp->obj3;
					p->parent = pp->parent;
					p->n = n;
					p->inif = pp->inif;
					p->vars_used = VarsUsed;
					p++;
					goto DoExpr;
				}
				else if ( pp->optgo > 0 ) {	/* Load next optional repetition */
					if ( p >= PopStop ) goto PopOver;
					p->fixgo = 0;
					p->optgo = pp->optgo - 1;
					p->type = OPTIONSUBEXPRESSION;
					p->s = s;
					p->line = CurLin;
					p->e = e;
					p->obj4 = pp->obj4;
					p->obj3 = pp->obj3;
					p->parent = pp->parent;
					p->n = n;
					p->inif = pp->inif;
					p->vars_used = VarsUsed;
					p++;
					goto DoExpr;
				}
				complete = 1;
				if ( e->varnum >= 0 ) {
					if ( FillVars(e->varnum,tmp,s) ) goto PopOne;
				}
PopPP:			InIf = pp->inif;
				ep = e;
				e = pp->parent;
				o4 = pp->obj4;
				o3 = pp->obj3;
				parent = 0;
				while ( pp > PopStack ) {
					pp--;
					if ( pp->e == e ) {
						parent = pp->parent;
						break;
					}
					if ( pp->e == ep && InIf ) {
						s = pp->s;
						n = pp->n;
						VarsUsed = pp->vars_used;
						CurLin = pp->line;
					}
				}
				GOTONEXT;
			}
		}
		if ( Sword && ( n > 0 || ContinWord ) && (BYTE)(dbufFer.wordtable[*s]) > 0 ) {
			s = OldS;
			n = OldN;
			CurLin = OldLine;
			o4 = Oldo4;
			o3 = Oldo3;
			InIf = OldInIf;
			e = OldE;
			parent = OldParent;
			p = pword;
			goto DoNextOr;
		}
		EndLine = CurLin;
		EndS = s;
		EndN = n;
		return(1);
/*
		Failure:
*/
DoNextOr:
		if ( !(o3->nextor) ) goto PopOne;
		s = OldS; n = OldN; CurLin = OldLine;
DoOr:;
	} while ( ( o3 = o3->nextor ) != NULL );
/*
	Dropping out here means there is no match with this element.

	The heart of the matter. Popping is nontrivial.
	Keep track of subexpressions and options.
	or's are done before coming here.
*/
PopOne:
	while ( p > PopStack ) {
		p--;
		if ( p->type == OPTIONELEMENT ) {
			s = p->s;
			CurLin = p->line;
			e = p->e;
			o4 = p->obj4;
			o3 = p->obj3;
			parent = p->parent;
			VarsUsed = p->vars_used;
			n = p->n;
			InIf = p->inif;
			if ( InIf ) {
				if ( o3->withif.ifclause.varnum >= 0 ) {
					if ( FillVars(o3->withif.ifclause.varnum,tmp,s) ) goto PopOne;
				}
				goto DoOr;
			}
			if ( o3->withif.fixed.varnum >= 0 ) {
				if ( FillVars(o3->withif.fixed.varnum,tmp,s) ) goto PopOne;
			}
			if ( o3->withif.type >= 0 ) goto DoIf;
			goto NextObject;
		}
		if ( p->type == OPTIONSUBEXPRESSION ) {
			s = p->s;
			CurLin = p->line;
			n = p->n;
			VarsUsed = p->vars_used;
			pp = p;
			goto PopPP;
		}
		if ( p->obj3->nextor ) {
			pp = p; j = p->fixgo + 1;
			while ( pp > PopStack ) {
				pp--;
				if ( pp->e == p->e ) {
					if ( pp->fixgo != j || !pp->obj3->nextor ) break;
					j++; p = pp;
				}
			}
			s = p->s;
			CurLin = p->line;
			e = p->e;
			o4 = p->obj4;
			o3 = p->obj3;
			parent = p->parent;
			n = p->n;
			VarsUsed = p->vars_used;
			InIf = p->inif;
			goto DoOr;
		}
	}
/*
	Coming here means: no match!
*/
	return(0);
/*
	Now the matching and pushing operations.
	Fixed objects are straight forward. Note the dealing of the Old
	objects for fixed elements without options.
	There is one problem left:
		a%b{3,5} would be the same as a%b{3}.
	This changes with
		a%b{3,5}@1
	Here we cannot drop the ,5.
	The compiler has to intercept this problem and alter the
	expression to:
		a%(b){3,5}@1
	So repetitions in an if-clause are always fixed for fixed elements!
	Options can only occur with subexpressions.
*/

DoObject:
	if ( fix->varnum >= 0 ) {
		tmp[fix->varnum].line = CurLin;
		tmp[fix->varnum].pos = s;
	}
	if ( ( j = fix->type ) == CHARACTER ) {
		if ( repper ) {
			if ( n < repf->minval ) goto DoNextOr;
			for ( i = 0; i < repf->minval; i++, s++ ) {
				if ( !SCase ) {
					if ( ToUpper[*s] != fix->obj.chr ) {
						s -= i; goto DoNextOr;
					}
				}
				else {
					if ( *s != fix->obj.chr ) {
						s -= i; goto DoNextOr;
					}
				}
			}
			n -= i;
			i = repf->maxval - repf->minval;
			while ( i > 0 && n > 0 ) {
				if ( !SCase ) {
					if ( ToUpper[*s] != fix->obj.chr ) break;
				}
				else {
					if ( *s != fix->obj.chr ) break;
				}
				if ( p >= PopStop ) goto PopOver;
				p->s = s;
				p->line = CurLin;
				p->e = e;
				p->obj4 = o4;
				p->obj3 = o3;
				p->parent = parent;
				p->n = n;
				p->type = OPTIONELEMENT;
				p->inif = InIf;
				p->vars_used = VarsUsed;
				i--; p++; n--; s++;
			}
		}
		else {
			if ( n <= 0 ) goto DoNextOr;
			if ( !SCase ) {
				if ( ToUpper[*s] != fix->obj.chr ) goto DoNextOr;
			}
			else {
				if ( *s != fix->obj.chr ) goto DoNextOr;
			}
			n--; s++;
		}
TstVnext:
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		if ( InIf ) goto RedoIf;
		if( o3->withif.type>=0 )goto DoIf;
		else goto NextObject;
	}
	else if ( j >= 0 ) {		/* string */
		if ( repper ) {
			if ( n < repf->minval * fix->type ) goto DoNextOr;
			for ( i = 0; i < repf->minval; i++, s++ ) {
				j = fix->type;
				n -= j;
				t = fix->obj.substr;
				while ( j > 0 ) {
					if ( !SCase ) {
						if ( ToUpper[*s] != *t ) break;
					}
					else {
						if ( *s != *t ) break;
					}
					j--; t++; s++;
				}
				if ( j > 0 ) { goto DoNextOr; }
			}
			i = repf->maxval - repf->minval;
			while ( i > 0 && n >= fix->type ) {
				j = fix->type; t = fix->obj.substr;
				p->s = s;
				while ( j > 0 ) {
					if ( !SCase ) {
						if ( ToUpper[*s] != *t ) break;
					}
					else {
						if ( *s != *t ) break;
					}
					j--; t++; s++;
				}
				if ( j > 0 ) {
					s = p->s;
					break;
				}
				if ( p >= PopStop ) goto PopOver;
				p->s = s;
				p->line = CurLin;
				p->e = e;
				p->obj4 = o4;
				p->obj3 = o3;
				p->parent = parent;
				p->n = n;
				p->type = OPTIONELEMENT;
				p->inif = InIf;
				p->vars_used = VarsUsed;
				n -= fix->type; i--; p++;
			}
		}
		else {
			if ( n < fix->type ) goto DoNextOr;
			i = fix->type;
			t = fix->obj.substr;
			n -= i;
			while ( --i >= 0 ) {
				if ( !SCase ) {
					if ( ToUpper[*s] != *t ) goto DoNextOr;
				}
				else {
					if ( *s != *t ) goto DoNextOr;
				}
				t++; s++;
			}
		}
		goto TstVnext;
#ifdef OLDCODE
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		if ( InIf ) goto RedoIf;
		if( o3->withif.type>=0 )goto DoIf;
		else goto NextObject;
#endif
	}
	else if ( j == BRACES ) {
		if ( repper ) {
			if ( n < repf->minval ) goto DoNextOr;
			for ( i = 0; i < repf->minval; i++, s++ ) {
				if ( !BraceTable[fix->obj.bracnum][*s] ) {
					s -= i; goto DoNextOr;
				}
			}
			n -= i;
			i = repf->maxval - repf->minval;
			if ( i > n ) i = n;
			while ( i > 0 ) {
				if ( !BraceTable[fix->obj.bracnum][*s] ) break;
				i--;
				if ( p >= PopStop ) goto PopOver;
				p->s = s;
				p->line = CurLin;
				p->e = e;
				p->obj4 = o4;
				p->obj3 = o3;
				p->parent = parent;
				p->n = n;
				p->type = OPTIONELEMENT;
				p->inif = InIf;
				p->vars_used = VarsUsed;
				p++; n--; s++;
			}
		}
		else {
			if ( n <= 0 || !BraceTable[fix->obj.bracnum][*s] ) goto DoNextOr;
			else {
				n--; s++;
			}
		}
		goto TstVnext;
#ifdef OLDCODE
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		if ( InIf ) goto RedoIf;
		if( o3->withif.type >= 0 ) goto DoIf;
		else goto NextObject;
#endif
	}
	else if ( j == PERIODC ) {
		if ( repper ) {
			if ( n < repf->minval ) goto DoNextOr;
			s += repf->minval;
			n -= repf->minval;
			i = repf->maxval - repf->minval;
			if ( i > n ) i = n;
			while ( --i >= 0 ) {
				if ( p >= PopStop ) goto PopOver;
				p->s = s;
				p->line = CurLin;
				p->e = e;
				p->obj4 = o4;
				p->obj3 = o3;
				p->parent = parent;
				p->n = n;
				p->type = OPTIONELEMENT;
				p->inif = InIf;
				p->vars_used = VarsUsed;
				p++; n--; s++;
			}
		}
		else {
			if ( n <= 0 ) goto DoNextOr;
			else {
				n--; s++;
			}
		}
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		if ( InIf ) goto RedoIf;
		if( o3->withif.type >= 0 )goto DoIf;
		else goto NextObject;
	}
	else if ( j == FIRSTCHAR ) {
		if ( CurLin == (LINE)cbuf ) goto DoNextOr;
		if ( ( CurLin->used > 0 && s == CurLin->text )
		|| ( CurLin->used < 0 && s == ((FOLDLINE)CurLin)->text ) ) {}
		else goto DoNextOr;
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		GOTONEXT;
	}
	else if ( j == SUBEXPRESSION ) {
		if ( p >= PopStop ) goto PopOver;
		p->s = s;
		p->line = CurLin;
		p->parent = parent = e;
		p->e = e = fix->obj.expr;
		p->obj4 = o4;
		p->obj3 = o3;
		p->n = n;
		p->vars_used = VarsUsed;
		if ( e->rep.minval > 0 ) {
			p->type = SUBEXPRESSION;
			p->fixgo = e->rep.minval - 1;
			p->optgo = e->rep.maxval - e->rep.minval;
		}
		else {
			p->type = OPTIONSUBEXPRESSION;
			p->fixgo = 0;
			p->optgo = e->rep.minval - 1;
		}
		p->inif = InIf;
		p++;
		if ( e->varnum >= 0 ) {
			tmp[e->varnum].line = CurLin;
			tmp[e->varnum].pos = s;
		}
		goto DoExpr;
	}
	else {			/* LASTCHAR or ENDSTART */
		if ( CurLin == (LINE)cbuf ) goto DoNextOr;
		if ( n > 0 ) goto DoNextOr;
		if ( j == ENDSTART ) {
			if ( ColMode ) goto DoNextOr;
			CurLin = CurLin->next;
			if ( CurLin->used > 0 ) {
				n = CurLin->used - LINEHEAD;
				s = CurLin->text;
			}
			else {
				n = ((FOLDLINE)CurLin)->used - FOLDHEAD;
				s = ((FOLDLINE)CurLin)->text;
			}
		}
		goto TstVnext;
#ifdef OLDCODE
		if ( fix->varnum >= 0 ) {
			if ( FillVars(fix->varnum,tmp,s) ) goto PopOne;
		}
		if ( InIf ) goto RedoIf;
		if( o3->withif.type>=0 )goto DoIf;
		else goto NextObject;
#endif
	}
/*
	Error conditions:
*/
PopOver:
	MesnOut(77); /* "Expression too complicated during matching" */
	return(-1);
}

/*
 		#] TryMatch :
 		#[ MakeReplace :		LINE MakeReplace(l,start)

		Routine takes line l and start substituting from position
		`start' on (starts counting at 0 so it is the number of
		characters left untouched).

		The rhs is in string rhsstring and has rhsnumber characters.
		It should be interpreted for the following elements:
		@				Indicates a variable.
		<esc><return>	Indicates a linefeed.
		\ or <esc>		Escape character.

		In the end the return line is the line at the end of the match
		where the search should continue.
		In addition we return:
		FirstCol:		Column for continuing the search
		LastCol:		Modified last column. (Old LastCol + inc).

		Note the helpful use of VarFlag, EscFlag and RetFlag.
		When all three are zero we have a plain string. Easy case.

		Coded: 31-jan-1989
*/

LINE
MakeReplace(LINE l,WORD start)
{
	LINE line2 = l, line3, line1 = 0, line4, line5;
	WORD i,n1,n2, inc, j;
	UBYTE *s1, *s2, *str1, *str2, *str3, *str4;
	UBYTE Buffer[MAXINLINE], *BufStop;
	V_USAGE *v;
	LONG change = 0, error = 0;
	if ( Rveto ) {
		Sprev = l;
		Scmatch = start + 1;
		switch ( AskVeto((UBYTE *)("Replace?")) ) {
			case QUIT :
				QuitFlag = 1;
				return(0);
			case NO :
DontDo:			line5 = l;
				FirstChar = Scmatch;
				goto RetPoint;
			case CONTIN :
				Rveto = 0;
			case YES :
				break;
		}
	}
	RepNumber++;
	line5 = EndLine;
	if ( line5 == (LINE)cbuf ) {
		line5 = cbuf->last;
		WeirdEnd = 1;
	}
	for (;;) {						/* reject foldlines */
		if ( line2->used < 0 ) {
			line5 = l;
			FirstChar++;
			goto RetPoint;
		}
		if ( line2 == line5 ) break;
		change--;
		line2 = line2->next;
	}
	if ( VarFlag ) {
		inc = 0;				/* No extra line yet */
		line1 = l->next;
		line2 = line5;
		s1 = l->text;
		str1 = rhsstring;
		str2 = Buffer;
		BufStop = Buffer + MAXINLINE;
		n2 = start;
		while ( --n2 >= 0 ) *str2++ = *s1++;
		n2 = 0;
		j = rhsnumber;
		while ( j > 0 ) {
			if ( *str1 == '@' ) {
				str1++; j -= 2;
				v = VarUsage + *str1++ - '0';
DoVar:			line4 = v->startline;
				str3 = (UBYTE *)(v->startchar);
				while ( line4 != v->endline ) {
					str4 = line4->text + line4->used - LINEHEAD;
					while ( str3 < str4 ) {
						if ( str2 >= BufStop ) {
							if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) )
								== NULL ) goto FiniLine;
							inc = 1;
							line2 = line3;
							s1 = line2->text;
							s2 = Buffer;
							while ( s2 < str2 ) *s1++ = *s2++;
							str2 = Buffer;
							change++;
						}
						*str2++ = *str3++;
					}
					{
/*
						There is a linefeed inside the variable.
*/
						if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) )
							== NULL ) goto FiniLine;
						inc = 1;
						line2 = line3;
						s1 = line2->text;
						s2 = Buffer;
						while ( s2 < str2 ) *s1++ = *s2++;
						str2 = Buffer;
						change++;
					}
					line4 = line4->next;
					str3 = line4->text;
				}
				while ( str3 < (UBYTE *)(v->endchar) ) {
					if ( str2 >= BufStop ) {
						if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) )
							== NULL ) goto FiniLine;
						inc = 1;
						line2 = line3;
						s1 = line2->text;
						s2 = Buffer;
						while ( s2 < str2 ) *s1++ = *s2++;
						str2 = Buffer;
						change++;
					}
					*str2++ = *str3++;
				}
			}
			else if ( *str1 == '\\' || *str1 == 0x1b ) {
				str1++; j--;
				if ( *str1 != '\r' && *str1 != '\n' && *str1 != 'n' )
					goto CopyChar;
				if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) ) == NULL ) 
					goto FiniLine;
				inc = 1;
				line2 = line3;
				s1 = line2->text;
				s2 = Buffer;
				while ( s2 < str2 ) *s1++ = *s2++;
				str2 = Buffer;
				str1++; j--;
				change++;
			}
			else if ( *str1 == '&' ) {
				j--; str1++;
				v = VarUsage + 10;
				goto DoVar;
			}
			else {
CopyChar:
				if ( str2 >= BufStop ) {
					if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) ) == NULL ) {
FiniLine:				error = 1;
						line3 = line5;
						line2 = line2->next;
						while ( line3->next != line2 ) LineDealloc(line3->next);
						return(NULL);
/*
						line5 = NULL;
						goto RetPoint;
*/
					}
					line2 = line3;
					s1 = line2->text;
					s2 = Buffer;
					while ( s2 < str2 ) *s1++ = *s2++;
					str2 = Buffer;
					change++;
				}
				*str2++ = *str1++;
				j--;
			}
		}
		FirstChar = (WORD)(str2 - Buffer);
		if ( EndLine != (LINE)cbuf ) {
			line4 = EndLine;
			str3 = EndS;
			i = line4->used - LINEHEAD;
			str4 = line4->text + i;
			i = LastChar - i;
			line4 = line2;
			while ( str3 < str4 ) {
				if ( str2 >= BufStop ) {
					if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) )
						== NULL ) goto FiniLine;
					inc = 1;
					line2 = line3;
					s1 = line2->text;
					s2 = Buffer;
					while ( s2 < str2 ) *s1++ = *s2++;
					str2 = Buffer;
					change++;
				}
				*str2++ = *str3++;
			}

			if ( RetFlag ) LastChar = MAXINLINE+100;
			else LastChar = i + (WORD)(str2 - Buffer);
		}
		else {
			line4 = line2;
		}
		if ( !inc && (str2 - Buffer) <= (l->totlen - LINEHEAD)
			&& l == EndLine ) {			/* Fits in old allocation */
			s1 = l->text; str1 = Buffer;
			while ( str1 < str2 ) *s1++ = *str1++;
			inc = (WORD)(str2 - Buffer) + LINEHEAD;
			if ( inc >= l->used ) l->used = inc;
			else DropPart(l,l->used - inc);
			line5 = l;
			goto RetPoint;
		}
		else {
			if ( EndLine != (LINE)cbuf || str2 != Buffer ) {
				if ( ( line3 = LineAlloc((WORD)(str2 - Buffer),line2) )
					== NULL ) goto FiniLine;
				line2 = line3;
				s1 = line2->text;
				s2 = Buffer;
				while ( s2 < str2 ) *s1++ = *s2++;
				line4 = line4->next;
			}
			else change--;
  			line3 = line2 = line5->next;
			goto DoDelete;
#ifdef OLDCODE
			while ( l != line2 ) {
				line1 = l->next;
				LineDealloc(l);
				if ( l == cbuf->current ) cbuf->current = line3;
				if ( l == Lstart ) Lstart = line3;
				if ( l == cbuf->mark ) cbuf->mark = (LINE)cbuf;
				l = line1;
			}
			cbuf->totline += change;
			line5 = line4;
			goto RetPoint;
#endif
		}
	}
	else {							/* Plain string */
		if ( l == EndLine || l == cbuf->last ) {	/* 20-feb-1989 */
			n1 = start;
			if ( l == EndLine ) n2 = (WORD)(EndS - l->text);/* 20-feb-1989 */
			else n2 = l->used - LINEHEAD;	/* 20-feb-1989 */
			inc = rhsnumber - n2 + n1;
			if ( LastChar ) LastChar += inc;
			if ( inc == 0 ) {
				s1 = rhsstring;
				s2 = l->text + n1;
				i = rhsnumber;
				while ( --i >= 0 ) *s2++ = *s1++;
				FirstChar = n2;
				line5 = l;
			}
			else if ( inc < 0 ) {
				s1 = rhsstring;
				s2 = l->text + n1;
				i = rhsnumber;
				while ( --i >= 0 ) *s2++ = *s1++;
				s1 = EndS; i = l->used - LINEHEAD - n2;
				while ( --i >= 0 ) *s2++ = *s1++;
				FirstChar = n2 + inc;
				DropPart(l,-inc);
				line5 = l;
			}
			else if ( ( inc + l->used ) <= l->totlen ) {
				if ( l == EndLine ) {
					s1 = l->text + l->used + inc - LINEHEAD;
					s2 = s1 - inc;
					while ( s2 > EndS ) *--s1 = *--s2;
				}
				s1 = rhsstring;
				s2 = l->text + n1;
				i = rhsnumber;
				while ( --i >= 0 ) *s2++ = *s1++;
				FirstChar = n2 + inc;
				l->used += inc;
				line5 = l;
			}
			else {
				if ( ( line2 = LineAlloc(l->used-LINEHEAD+inc,l) ) == NULL )
							return(NULL);
				s1 = line2->text;
				s2 = l->text;
				i = n1;
				while ( --i >= 0 ) *s1++ = *s2++;
				s2 = rhsstring;
				i = rhsnumber;
				while ( --i >= 0 ) *s1++ = *s2++;
				if ( l == EndLine ) {
					s2 = l->text + n2;
					i = EndN;
					while ( --i >= 0 ) *s1++ = *s2++;
				}
				FirstChar = n1 + rhsnumber;
				LineDealloc(l);
				if ( l == cbuf->current ) cbuf->current = line2;
				if ( l == Lstart ) Lstart = line2;
				if ( l == cbuf->mark ) cbuf->mark = (LINE)cbuf;
				if ( line2->used > LINEHEAD + MAXINLINE ) {
				}
				line5 = line2;
			}
			goto RetPoint;
		}
		else {						/* We ate a linefeed */
			GotRet = 0;				/* 20-feb-1989 */
			n1 = start;
			n2 = EndLine->used - LINEHEAD + (WORD)(EndLine->text - EndS);
			inc = n1 + (WORD)(EndLine->text - EndS) + rhsnumber;
			if ( n1+n2+rhsnumber > MAXINLINE ) goto DontDo;
			LastChar += inc;
			if ( ( line2 = LineAlloc(n2+n1+rhsnumber,
				EndLine) ) == NULL ) return(NULL);
			s1 = line2->text;
			s2 = l->text;
			while ( --n1 >= 0 ) *s1++ = *s2++;
			s2 = rhsstring;
			i = rhsnumber;
			while ( --i >= 0 ) *s1++ = *s2++;
			FirstChar = (WORD)(s1 - line2->text);
			s2 = EndS;
			while ( --n2 >= 0 ) *s1++ = *s2++;
			line4 = line2;
			line3 = line1;
DoDelete:
			while ( l != line2 ) {
				line1 = l->next;
				LineDealloc(l);
				if ( l == cbuf->current ) cbuf->current = line3;
				if ( l == Lstart ) Lstart = line3;
				if ( l == cbuf->mark ) cbuf->mark = (LINE)cbuf;
				l = line1;
			}
			cbuf->totline += change;
			line5 = line4;
			goto RetPoint;
		}
	}
RetPoint:
	if ( LastChar >= 0 ) LastCol = FindColumn(line5,LastChar);
	else LastCol = 0;
	if ( FirstChar == 0 ) FirstCol = 0;
	else FirstCol = FindColumn(line5,FirstChar);
	if ( error ) return(NULL);
	return(line5);
}
#endif

/*
 		#] MakeReplace :
  	#] Regular expressions :
*/
