/*
  	#[ Include file :

	Main revision of file at 29-apr-1989
*/
#include "stedi.h"
#ifdef UNIX
#include <sys/time.h>
#endif
/*
  	#] Include file :
  	#[ String utilities :
 		#[ string copy :		VOID Strcpy(from,to)

		Copy a zero terminated string
*/

VOID
Strcpy(UBYTE *s,UBYTE *t)
{
	while ( ( *t++ = *s++ ) != 0 );
}

/*
 		#] string copy :
 		#[ string compare : 	WORD strNcmp(s,t,n)

		Compare two strings of n characters.
		Return value is zero if they are equal.
*/

WORD
strNcmp(UBYTE *s,UBYTE *t,WORD n)
{
	while ( --n >= 0 ) {
		if ( *s != *t ) return(((WORD)(BYTE)*s)-((WORD)(BYTE)*t));
		s++; t++;
	}
	return(0);
}

/*
 		#] string compare :
 		#[ string compare : 	WORD strNIcmp(s,t,n)

		Compare two strings of n characters.
		The compare is case insensitive. In the compare everything
		is mapped to upper case according to a table, so that also
		the national non-ASCII characters are taken care of.
*/

WORD
strNIcmp(UBYTE *s,UBYTE *t,WORD n)
{
	while ( --n >= 0 ) if ( ToUpper[*s++] != ToUpper[*t++] ) return(1);
	return(0);
}

/*
 		#] string compare :
 		#[ string compare : 	WORD StrCmp(s,t)

		Compare two zero terminated strings.
		The compare is case insensitive. In the compare everything
		is mapped to upper case according to a table, so that also
		the national non-ASCII characters are taken care of.
*/

WORD
StrCmp(UBYTE *s,UBYTE *t)
{
	WORD c;
	while ( ( ( c = ToUpper[*s] - ToUpper[*t] ) == 0 ) && *s ) { s++; t++; }
	return(c);
}

/*
 		#] string compare :
 		#[ string compare : 	WORD strcmp1(s,t)
*/

WORD
strcmp1(UBYTE *s,UBYTE *t)
{
	while ( *s && *s++ == *t++ ){}
	if ( !*s ) return(-((WORD)(BYTE)(*t)));
	return((WORD)(BYTE)s[-1]-(WORD)(BYTE)t[-1]);
}

/*
 		#] string compare :
 		#[ string contained :	WORD StrCIcmp(s,t)

		Is s contained in t (case insensitive).
		s and t are zero terminated strings.
*/

WORD
StrCIcmp(UBYTE *s,UBYTE *t)
{
	while ( *t && *s && ToUpper[*s] == ToUpper[*t] ) { t++; s++; }
	if ( *s ) return(0);
	return(1);				/* is contained */
}

/*
 		#] string contained :
 		#[ mygetenv :

	The advantage of this own getenv is that
	a:	We have already a strnicmp routine
	b:	It is better with its case insensitivity.
*/

#ifdef OWNENV

extern BYTE **myenvironment;

BYTE *
mygetenv(BYTE *name)
{
	WORD i = 0;
	BYTE *s, **envp;
	envp = myenvironment;
	s = name;
	while ( *s ) { s++; i++; }
	while ( ( s = *envp++ ) != 0 ) {
		if ( strNIcmp((UBYTE *)name,(UBYTE *)s,i) == 0 ) {
			s += i;
			if ( *s == '=' ) return(s+1);
		}
	}
	return((BYTE *)0);
}

#endif

/*
 		#] mygetenv :
  	#] String utilities :
  	#[ Number utilities :
 		#[ Read a hexadecimal number :	WORD ReadHex(a,b)

		The two hex-digits are in a and b. a is the most significant.
		If either of the variables isn't a hex-digit (case insensitive)
		the return value is -1. Else the compound value is returned.
*/

WORD
ReadHex(WORD a,WORD b)
{
	WORD ret = 0;
	WORD first = 2;
	WORD i;
	while ( --first >= 0 ) {
		a = ToLower[a&0xFF];
		if ( ( a >= '0' ) && ( a <= '9' ) ) i = a - '0';
		else if ( ( a >= 'a' ) && ( a <= 'f' ) ) i = a - 'a' + 10;
		else return(-1);
		ret = ( ret << 4 ) + i;
		a = b;
	}
	return(ret);
}

/*
 		#] Read a hexadecimal number :
 		#[ LtoA(n,s) :					VOID LtoA(n,s)	

		Funny routine to convert a long number to a string.
		s is the end of the string and we assume that there
		must be 12 characters in it. Blanks will be filled.
*/

VOID
LtoA(LONG n,UBYTE *s)
{
	LONG x = n;
	WORD count = 12;
	if ( x < 0 ) x = -x;
	do {
#ifdef ATARI
		*--s = '0' + lwdiv(&x,(WORD)10);
#else
		*--s = ( x % 10 ) + '0';
		x /= 10;
#endif
		count--;
	} while ( x );
	if ( n < 0 ) { *--s = '-'; count--; }
	while ( --count >= 0 ) *--s = ' ';
}

/*
 		#] LtoA(n,s) :
 		#[ ItoL(s) :					LONG ItoL(s)

		Read a signed long number from the string s.
		Any character that isn't a digit is seen as
		an end of string. Multiple +/- are permitted.
*/

LONG
ItoL(UBYTE *s,WORD n)
{
	LONG x = 0;
	WORD sig = 0;
	while ( n > 0 && ( *s == '-' || *s == '+' ) ) {
		if ( *s++ == '-' ) sig ^= 1;
		n--;
	}
	while ( --n >= 0 && ( *s <= '9' ) && ( *s >= '0' ) ) x = x*10 + *s++ - '0';
	return ( sig ? -x : x );
}

/*
 		#] ItoL(s) :
 		#[ Read a number :				UBYTE *ReadNum(s,pn,px)

		Read a number compiler style. In *pn is the number of
		characters, and the chars are in s.
		The return value is the next pointer in s.
		In *pn is the left over number of characters.
		In *px is the number.
*/

UBYTE *
ReadNum(UBYTE *s,WORD *pn,WORD *px)
{
	LONG x = 0;
	while ( *pn > 0 && *s <= '9' && *s >= '0' ) {
		x = x*10 + *s++ - '0';
		(*pn)--;
	}
	*px = (WORD)x;
	return(s);
}

/*
 		#] Read a number :
  	#] Number utilities :
  	#[ Word utilities :
 		#[ Determine the current word :

		Find the word the cursor is on (if any).
		Return values:
			The start address of the word is returned in *st.
			The length of the word is the return value of the routine.
		First we find the current character. If it may belong to a
		word we run backwards and forwards in this word to reach the
		boundaries. Note that we need the length of the line for this.

		The word table has been defined in such a way that there are
		characters that are words by themselves. These have an entry
		of zero.
*/

WORD
DetWor(UBYTE **st)
{
	BUFFER b = cbuf;
	UBYTE *s;
	WORD type, n;
	LINE curlin;
	WORD num;
	UBYTE *address, *t;
	FINDPOS fp;

	curlin = b->current;
	if ( curlin == (LINE)b || b->newvirt > 0 ) return(0);
	type = FindChar(curlin,b->column,&fp);
	*st = address = fp.address; num = fp.num;

	if ( type == NORMALCHAR ) {
		if ( (BYTE)(dbufFer.wordtable[*address]) < 0 ) return(0);	/* No word */
		else if ( dbufFer.wordtable[*address] == 0 ) {		/* Single char word */
			return(1);
		}
		n = curlin->used- LINEHEAD;
		if ( n < 0 ) n = ((FOLDLINE)curlin)->used - FOLDHEAD;

		s = address + 1;
		while ( ( n > num ) && ( (BYTE)(dbufFer.wordtable[*s]) > 0 ) ) { s++; n--; }
		t = s;

		s = address /* -1 */;
		/*  num--;  */
		while ( ( num > 0 ) && ( (BYTE)(dbufFer.wordtable[*s]) > 0 ) ) { s--; num--; }
		/* s++; */
		*st = s+1;
		return(((WORD)(t-s))-1);
	}
	return(0);
}

/*
 		#] Determine the current word :
  	#] Word utilities :
  	#[ Tab utilities :
 		#[ GetRange :			WORD GetRange(Line1,Line2,param)

		Get the range we need for tabbing operations.
		param == 0 -> whole buffer.
		param != 0 -> partial range.
		Returns the lines in Line1 and Line2.
		The main returns value:
			-1 or 0: No further work
			> 0: Non trivial range.
*/
#ifndef DEMO

WORD
GetRange(LINE *Line1,LINE *Line2,WORD param)
{
	BUFFER b = cbuf;
	WORD a1,a2,a3,a4;
	ClearUndo();
	if ( param ) {
		param = Range(Line1,Line2,&a1,&a2,&a3,&a4);
		if ( param < 0 ) return(-1);
		if ( param > 0 ) {
			if ( b->MarkVirt > 0 ) return(0);
		}
		else if ( b->newvirt > 0 ) return(0);
		*Line2 = (*Line2)->next;
	}
	else {
		*Line1 = b->first;
		*Line2 = (LINE)b;
	}
	b->dirtyflag = 1;
	return(1);
}
#endif

/*
 		#] GetRange :
 		#[ Trimming : 			LONG Trim(param)
*/
#ifndef DEMO

WORD trimfold;

LONG
Trim(WORD param)
{
	LINE a, b;
	WORD a1, foldflag;
	ULONG chars[65];
	UBYTE *t, *v;
	WORD oldtab, i, col;
	UBYTE *s;
	LINE c, d;
	LONG number = 0;
	if ( cbuf->first == (LINE)cbuf ) return(number);	/* No lines */
	if ( ( i = GetRange(&c,&d,param) ) <= 0 ) return((LONG)i);
	a = c; b = d;
	do {
		if ( a->used > LINEHEAD ) {	/* Trim now line a */
			number++;
			t = cbuf->tabstring;
			oldtab = -1;
			v = a->text;
			i = a->used - LINEHEAD;
			s = (UBYTE *)chars;
			col = 0;
			foldflag = 0;
			if ( v[3] == '#' && trimfold && i > 5
			   && ( v[4] == '[' || v[4] == ']' ) ) {
				a1 = i - 5;
				v += 5;
				while ( --a1 >= 0 ) {
					if ( *v++ == ':' ) { foldflag = 1; break; }
				}
				v = a->text;
			}
			do {
				*s = *v++;
				while ( ( col > *t ) && *t ) { oldtab = *t; t++; }
				if ( *s == '\t' && ( !foldflag || v > (a->text + 4) ) ) {
					s--;
					while ( ( *s == ' ' ) && ( --col > oldtab ) ) { s--; }
					s++; *s = '\t'; col = *t;
				}
				col++; s++;
			} while ( --i > 0 );
			while ( ( s > (UBYTE *)chars ) &&
				( ( *(s-1) == ' ' ) || ( *(s-1) == '\t' ) ) ) s--; /* trim */
			i = a->used - LINEHEAD;
			col = (WORD)(s - (UBYTE *)chars);
			if ( i > col ) {
				a1 = i - col;
				/* i = ( col + sizeof(LONG) - 1 )/sizeof(LONG); */
				i = ( col + 3 ) >> 2;
#ifdef FASTCOPY
				s = (UBYTE *)chars;
				v = a->text;
				do { *((LONG *)v)++ = *((LONG *)s)++; } while ( --i > 0 );
#else
				{
					LONG *from, *to;
					from = (LONG *)chars;
					to = (LONG *)(a->text);
					do { *to++ = *from++; } while ( --i > 0 );
				}
#endif
				DropPart(a,a1);
			} 

		}
	} while ( ( a = a->next ) != b );
	if ( TabShow ) ForceDisplay();
	return(number);
}
#endif

/*
 		#] Trimming :
 		#[ Tabbing :			LONG Tabbing(param)
*/
#ifndef DEMO

LONG
Tabbing(WORD param)
{
	LINE a, b;
	WORD a1, foldflag;
	ULONG chars[65];
	UBYTE *t, *v;
	WORD oldtab, i, col;
	UBYTE *s;
	LINE c , d;
	LONG number = 0;
	if ( cbuf->first == (LINE)cbuf ) return(number);	/* No lines */
	if ( ( i = GetRange(&c,&d,param) ) <= 0 ) return((LONG)i);
	a = c; b = d;
	do {
		if ( a->used > LINEHEAD ) {	/* Tab now line a */
			number++;
			t = cbuf->tabstring;
			oldtab = -1;
			v = a->text;
			i = a->used - LINEHEAD;
			s = (UBYTE *)chars;
			col = 0;
			foldflag = 0;
			if ( v[3] == '#' && trimfold && i > 5
			   && ( v[4] == '[' || v[4] == ']' ) ) {
				a1 = i - 5;
				v += 5;
				while ( --a1 >= 0 ) {
					if ( *v++ == ':' ) { foldflag = 1; break; }
				}
				v = a->text;
			}
			do {
				*s = *v++;
				while ( ( col > *t ) && *t ) { oldtab = *t; t++; }
				if ( *s == '\t' && ( !foldflag || v > (a->text + 4) ) ) {
					s--;
					while ( ( *s == ' ' ) && ( --col > oldtab ) ) { s--; }
					s++; *s = '\t'; col = *t;
				}
				else if ( *s == ' ' && ( !foldflag || v > (a->text + 4) ) ) {
					if ( ( col == *t ) && ( *(s-1) == ' ' ) && *t ) {
						s--;
						while ( ( *s == ' ' ) && ( --col > oldtab ) ) { s--; }
						s++; *s = '\t'; col = *t;
					}
				}
				col++; s++;
			} while ( --i > 0 );
			i = a->used - LINEHEAD;
			col = (WORD)(s - (UBYTE *)chars);
			if ( i > col ) {
				a1 = i - col;
				/* i = ( col + sizeof(LONG) - 1 )/sizeof(LONG); */
				i = ( col + 3 ) >> 2;
#ifdef FASTCOPY
				s = (UBYTE *)chars;
				v = a->text;
				do { *((LONG *)v)++ = *((LONG *)s)++; } while ( --i > 0 );
#else
				{
					LONG *from, *to;
					from = (LONG *)chars;
					to = (LONG *)(a->text);
					do { *to++ = *from++; } while ( --i > 0 );
				}
#endif
				DropPart(a,a1);
			} 
		}
	} while ( ( a = a->next ) != (LINE)b );
	if ( TabShow ) ForceDisplay();
	return(number);
}
#endif

/*
 		#] Tabbing :
 		#[ Detabbing :			LONG DeTab(param)
*/
#ifndef DEMO

LONG
DeTab(WORD param)
{
	BUFFER cb = cbuf;
	LINE a, b;
	LONG num;
	WORD a1, foldflag, i;
	ULONG chars[130];
	LONG *s;
	LONG *t, number = 0;
	UBYTE *v = 0, *w = 0;
	LINE c,d;
	if ( cb->first == (LINE)cbuf ) return(number);	/* No lines */
	if ( ( a1 = GetRange(&c,&d,param) ) <= 0 ) return((LONG)a1);
	a = c; b = d;
	do {
		if ( a->used > (WORD)(LINEHEAD) ) {
			number++;
			foldflag = 0;
			if ( trimfold ) {
				v = a->text + 3;
				i = a->used - LINEHEAD;
				if ( *v == '#' && i > 5 && ( v[1] == '[' || v[1] == ']' ) ) {
					v += 2;
					i -= 5;
					while ( --i >= 0 ) {
						if ( *v++ == ':' ) { foldflag = 1; break; }
					}
				}
			}
			num = ExpandLine(-1,a->used-LINEHEAD,a->text,cbuf->tabstring,(UBYTE *)chars,
			PRINTMODE);
			if ( foldflag ) {
				v = ((UBYTE *)chars)+3;
				while ( *v != '#' ) { v++; num--; }
				w = a->text;
			}
			if ( ( num + LINEHEAD ) > a->totlen ) {
				c = LineAlloc((WORD)num,a);
				if ( !c ) {
					undoB->current = a;
					undoB->mark = b;
					while ( Garbage() ) {}
					b = undoB->mark;
					a = undoB->current;
					c = LineAlloc((WORD)num,a);
					if ( number > 0 ) cbuf->dirtyflag = 1;
					if ( !c ) return(-1L);
					MesnOut(23);	/* "" Garbage message */
				}
				if ( a == cb->current ) cb->current = c;
				if ( a == cb->mark ) cb->mark = c;
				if ( foldflag ) w = a->text;
				d = a;
				a = c;
			}
			else { d = (LINE)0; a->used = (WORD)num + LINEHEAD; }
			if ( foldflag ) {
				a->text[0] = *w++;
				a->text[1] = *w++;
				a->text[2] = *w++;
				w = a->text + 3;
				num -= 3;
				do { *w++ = *v++; } while ( --num > 0 );
			}
			else {
				num = ( num + 3 ) >> 2;
				t = (LONG *)(a->text);
				s = (LONG *)chars;
				do { *t++ = *s++; } while ( --num > 0 );
			}
			if ( d ) LineDealloc(d);
			if ( a == cb->mark ) DetMark();	/* Mark column -> char */
		}
		a = a->next;
	} while ( a != b );
	if ( TabShow ) ForceDisplay();
	return(number);
}
#endif

/*
 		#] Detabbing :
  	#] Tab utilities :
  	#[ Tabbing :

	Reaction to the <tab> command. This routine determines a possible
	subkey and then has two possible actions:
	1:	Call one of the three service routines
	2:	Make a new tab setting.
	Syntax:
	<tab><tab>[r]	Try to change blanks into tabs.
	<tab>e[r]		Expand tabs into blanks.
	<tab>t[r]		Trim trailing blanks and tabs.
			The `r' key restricts the operation to the range of action.
	<tab>[g] settings
					Make tab settings. G is for all buffers simultaneously.
			Settings: Either an absolute number or a number of increments
					<num> or <num>*<inc>
					There may be many of these and there can be mixed
					expressions.
	The major complication concerns where the cursor should be when
	the tab settings are altered.

	At serious accidents the tabstring is set to zero.
	Maybe we should try to save the old one.
*/

static BYTE *tabops[] = {"Trimm","Tabb","Detabb"};

LONG
Tab(UBYTE *s,WORD nn)
{
	UWORD c;
	WORD param = 0, n = nn;
	UBYTE *t;
	WORD x, y, old, numtab = 99, i;
	WORD num,type,glob;
	LONG number;
	UBYTE oldtab[100];
	FINDPOS fp;
	if ( cbuf->outputmode == RAWMODE ) {
		MesnOut(85); /* "Not in raw mode" */
		return(-1L);
	}
	if ( n == 0 ) return(0L);
#ifndef DEMO
	c = ToUpper[*s];
	if ( ( c == 'A' && n > 1 && ToUpper[s[1]] == 'B' )
	 || ( c == 'E' ) || ( c == 'T' ) ) {
		if ( c == 'A' ) { s++; n--; }
		s++; n--;
		SKIPBLANKS(s,n);
		trimfold = 1;
		while ( n > 0 ) {
			if ( *s == 'r' || *s == 'R' ) param = 1;
			if ( *s == 'f' || *s == 'F' ) trimfold = 0;
			s++; n--;
		}
		cbuf->dirtyflag = 1;
		if		( c == 'T' ) {
			number = Trim(param);
			if ( number <= 0 ) return(number);
			param = 0;
		}
		else if ( c == 'E' ) {
			number = DeTab(param);
			if ( number <= 0 ) return(number);
			param = 2;
		}
		else {
			number = Tabbing(param);
			if ( number <= 0 ) return(number);
			param = 1;
		}
		i = 0;
		if ( number == 1 ) i = 1;
		MesPrint(34,tabops[param],(LONG)number,plural+i);
			 /* "%sed %l line%s" */
		return(0);
	}
#endif
	for ( i = 0; i < 100; i++ ) oldtab[i] = cbuf->tabstring[i];
	if ( *s == 'g' || *s == 'G' ) {
		glob = 1;
		s++; n--;
		if ( n <= 0 ) return(0L);
		SKIPEBLANKS(s,n,',');
	}
	else glob = 0;
	if ( ( *s > '9' ) || ( *s < '0' ) ) return(Syntax());
	type = FindChar(cbuf->current,cbuf->column,&fp);
	t = cbuf->tabstring;
	*t = 0;
	old = -1;
	while ( n > 0 ) {
		s = ReadNum(s,&n,&x);
		if ( ( n > 0 ) && ( *s == '*' ) ) {
			s++; n--;
			s = ReadNum(s,&n,&y);
			if ( y == 0 ) goto RestrOld;
			if ( ( n > 0 ) && ( *s != ' ' ) && ( *s != ',' ) ) goto RestrOld;
			while ( --x >= 0 ) {
				old += y;
				if ( old > MAXCOLUMN ) old = 0;
				if ( numtab-- > 0 ) *t++ = old;
			}
		}
		else if ( ( n > 0 ) && ( *s != ' ' ) && ( *s != ',' ) ) goto RestrOld;
		else {
			if ( ( x <= 0 ) || ( x > MAXCOLUMN ) ) x = 1;
			old = x - 1;
			if ( numtab-- > 0 ) *t++ = old;
		}
		SKIPEBLANKS(s,n,',');
	}
	do { *t++ = 0; } while ( --numtab >= 0 );
	if ( glob ) {
		for ( x = 0; x < 10; x++ ) {
			if ( cbuf != textbuffer[x] ) {
				t = textbuffer[x]->tabstring;
				s = cbuf->tabstring;
				for ( i = 0; i < 100; i++ ) *t++ = *s++;
			}
		}
		s = cbuf->tabstring;
		t = dbufFer.tabstring;
		for ( i = 0; i < 100; i++ ) *t++ = *s++;
	}
	if ( cbuf->column > 1 ) {
		num = FindColumn(cbuf->current,fp.num);
		if ( ( type == AFTERVIRTUAL ) || ( type == NORMALEOL ) ) num += fp.virt + 1;
		cbuf->column = num;
	}
	ForceDisplay();
	return(0L);
RestrOld:
	for ( i = 0; i < 100; i++ ) cbuf->tabstring[i] = oldtab[i];
	return(Syntax());
}

/*
  	#] Tabbing :
  	#[ Case routines :
 		#[ Conversion of string :	VOID StrConv(s,n,table)
*/

VOID
StrConv(UBYTE *s,WORD n,UBYTE *table)
{
	while ( --n >= 0 ) { *s = table[*s]; s++; }
}

/*
 		#] Conversion of string :
 		#[ Convert range :			LONG Convert(table)
*/

LONG
Convert(UBYTE *table)
{
	LINE start, last;
	WORD numstart, numlast, diffv, diffvcol;
	BUFFER b;
	LINE l;
	if ( commandmode ) b = commandbuffer;
	else b = cbuf;
	if ( Range(&start,&last,&numstart,&numlast,&diffv,&diffvcol) >= 0 ) {
		if ( start == last ) { /* Same line */
			if ( b->newvirt && b->MarkVirt ) return(0L); /* All virtual */
			if ( diffv > 0 ) { /* One is virtual --> to end of file. */
			}
			else if ( numstart == numlast ) return(0L); /* zero range */
			else {	/* Fixed range inside a single line */
				if ( start->used < 0 ) return(NoFold());
			}
			StrConv(start->text+numstart-1,numlast-numstart,table);
			if ( commandmode ) MessageCommand();
			else {
				LineDisplay(start);
#ifdef WITHSYNCH
				if ( !redraw ) PSsynch();
#endif
			}
		}
		else { /* start and end are different */
			if ( start->used < 0 || last->used < 0 ) return(NoFold());
			if ( start->used > LINEHEAD ) numstart--;
			if ( diffv == 0 ) numlast--;
			if ( last->used == LINEHEAD ) numlast = 0;
			StrConv(start->text+numstart,start->used-LINEHEAD-numstart,table);
			StrConv(last->text,numlast,table);
			l = start;
			while ( ( l = l->next ) != last ) {
				if ( l->used >= 0 ) {
					StrConv(l->text,l->used-LINEHEAD,table);
				}
				else {
					MesnOut(86); /* "Foldline skipped" */
				}
			}
			if ( commandmode ) MessageCommand();
			else ForceDisplay();
		}
		b->dirtyflag = 1;
		return(0L);
	}
	return(-1L);
}

/*
 		#] Convert range :
 		#[ Convert to upper :		LONG upper()
*/

LONG
upper(VOID)
{
	if ( !commandmode ) {
		MesOut("Convert range to upper case? ");
		if ( MesAsk(98,INTEXT) > 0 ) return(Convert(ToUpper));
		else return(0);
	}
	return(-1L);
}

/*
 		#] Convert to upper :
 		#[ Convert to lower :		LONG lower()
*/

LONG
lower(VOID)
{
	if ( !commandmode ) {
		MesOut("Convert range to lower case? ");
		if ( MesAsk(98,INTEXT) > 0 ) return(Convert(ToLower));
		else return(0);
	}
	return(-1);
}

/*
 		#] Convert to lower :
 		#[ Flip case :				LONG flip()
*/

LONG
flip(VOID)
{
	BUFFER b = cbuf;
	LINE line;
	WORD column;
	UBYTE *charaddress;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	if ( ( b->totline <= 0 ) || ( b->newvirt > 0 ) ) return(0L);
	line = b->current;
	column = b->column;
	if ( FindChar(line,column,&fp) == NORMALCHAR ) {
		charaddress = fp.address;
		if ( line->used < 0 ) return(NoFold());
		if ( *charaddress == ToUpper[*charaddress] ) {
			*charaddress = ToLower[*charaddress];
		}
		else {
			*charaddress = ToUpper[*charaddress];
		}
		b->dirtyflag = 1;
		if ( commandmode ) MessageCommand();
		else {
			LineDisplay(line);
#ifdef WITHSYNCH
			if ( !redraw ) PSsynch();
#endif
		}
	}
	return(0L);
}

/*
 		#] Flip case :
  	#] Case routines :
  	#[ Date routines :
 		#[ DoDate :

		Puts the date and time of a file in the macro intermediate buffer.
*/

#ifndef DEMO

extern UBYTE *buftop, *inbuf;

WORD
DoDate(UWORD date,UWORD time)
{
	LONG x;
	if ( ( inbuf + 19 ) >= buftop ) return(-1);
	x = (date >> 9) + 1980;
	NumToStr(x);
	*inbuf++ = '/';
	x = (date >> 5) & 0xF;
	if ( x < 10 ) *inbuf++ = '0';
	NumToStr(x);
	*inbuf++ = '/';
	x = date & 0x1F;
	if ( x < 10 ) *inbuf++ = '0';
	NumToStr(x);
	*inbuf++ = '-';
	x = time >> 11;
	if ( x < 10 ) *inbuf++ = '0';
	NumToStr(x);
	*inbuf++ = ':';
	x = (time >> 5) & 0x3F;
	if ( x < 10 ) *inbuf++ = '0';
	NumToStr(x);
	*inbuf++ = ':';
	x = (time & 0x1F) << 1;
	if ( x < 10 ) *inbuf++ = '0';
	NumToStr(x);
	return(0);
}

#endif

/*
 		#] DoDate :
 		#[ MakeDate :
*/
 
#ifdef WITHDATE

BYTE *Months[13] = {
	"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec","???"
};

#ifdef UNIX

int	days[10] = { 31,30,31,30,31,31,30,31,30,31 };

WORD
MakeDate(UBYTE *buf)
{
	UBYTE da[4];
	UBYTE *b = buf, *s;
	long x,y,z;
	int i, m, d;
	struct timeval tp;
	struct timezone tzp;
	if ( gettimeofday(&tp,&tzp) ) return(b-buf);
	x = tp.tv_sec / (24*3600);	/* Days since 1-1-1970 */
	x -= 790;		/* 1-3-1972 */
	y = x / 1461;	/* Number of olympiads */
	z = x % 1461;
	i = z / 365;
	if ( i > 3 ) {
		i = 3; d = 365;
	}
	else d = z % 365;	/* Days into the year */
	y *= 4;
	y += 1972 + i;
	if ( d >= 306 ) {
		y++;
		d -= 306;
		if ( d >= 31 ) {
			m = 1; d -= 31;
		}
		else m = 0;
	}
	else {
		for ( m = 0; m < 9; m++ ) {
			if ( days[m] > d ) break;
			d -= days[m];
		}
		m += 2;
	}
	d++;
	i = d / 10; d %= 10;
	if ( i ) *b++ = i + '0';
	*b++ = d + '0';
	if ( m >= 12 ) m = 12;
	*b++ = '-';
	s = (UBYTE *)(Months[m]);
	while ( *s ) *b++ = *s++;
	*b++ = '-';
	s = da;
	for ( i = 0; i < 4; i++ ) { *s++ = y % 10; y /= 10; }
	for ( i = 0; i < 4; i++ ) *b++ = *--s+'0';
	return((WORD)(b - buf));
}

#else

WORD
MakeDate(UBYTE *buf)
{
	UWORD x,y,z;
	UBYTE da[4];
	UBYTE *b, *s;
	b = buf;
	x = (UWORD)(TgetDate());
	y = x & 0x1F;
	z = y / 10; y %= 10;
	if ( z ) *b++ = z + '0';
	*b++ = y + '0';
	x >>= 5;
	y = ( x & 0xF ) - 1;
	if ( y >= 12 ) y = 12;
	*b++ = '-';
	s = (UBYTE *)(Months[y]);
	while ( *s ) *b++ = *s++;
	*b++ = '-';
	x >>= 4;
	x += 1980;
	s = da;
	for ( z = 0; z < 4; z++ ) { *s++ = x % 10; x /= 10; }
	for ( z = 0; z < 4; z++ ) *b++ = *--s+'0';
	return((WORD)(b - buf));
}

#endif

#else

WORD
MakeDate(UBYTE *buf)
{
	return(0);
}

#endif

/*
 		#] MakeDate :
  	#] Date routines :
*/

